#!/bin/sh

# mamkfaacosx.sh

# this script makes libfaac.a for OSX
# from the faac-1.26.tar.gz release

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamkfaacosx.sh : not in libs"
 echo >&2 "mamkfaacosx.sh : not in libs"
 exit 1
fi

if [ "powerpc" != `uname -p | cut -c 1-7` ] ; then
 osxdir="osxi"
else
 osxdir="osx"
fi

cd faac

# cleanup from any previous builds

make clean 2>/dev/null
make distclean 2>/dev/null
rm -fr aclocal.m4 bootstrapnu config.h config.h.in config.log config.status
rm -fr configure libtool ltmain.sh Makefile Makefile.in mkinstalldirs stamp-h1
rm -fr autom4te.cache ../../ltmain.sh
rm -fr ./.libs
rm -fr ./.deps
rm -f $osxdir/libfaac.a
rm -f $osxdir/libmp4v2.a

# build the libs

chmod a+x bootstrap
./bootstrap
./configure --disable-shared

cd libfaac
make
cd ..

cd common/mp4v2
make
cd ../..

# copy our lib to dir $osxdir/

mkdir -p $osxdir
cp -p libfaac/.libs/libfaac.a ./$osxdir/libfaac.a
cp -p common/mp4v2/.libs/libmp4v2.a ./$osxdir/libmp4v2.a

# optional cleanup

make clean 2>/dev/null
#make distclean 2>/dev/null
#rm -fr aclocal.m4 config.h config.h.in config.log config.status
rm -fr aclocal.m4 config.h.in config.log config.status
rm -fr configure libtool ltmain.sh Makefile Makefile.in mkinstalldirs stamp-h1
rm -fr autom4te.cache ../../ltmain.sh
rm -fr ./.libs
rm -fr ./.deps

# back to MoreAmp/libs dir

cd ..
