#!/bin/sh

# mamkfaad2osx.sh

# this script makes libfaad.a and libmp4ff.a for OSX
# from the faad2-2.6.1.tar.gz.tar release

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamkfaad2osx.sh : not in libs"
 echo >&2 "mamkfaad2osx.sh : not in libs"
 exit 1
fi

if [ "powerpc" != `uname -p | cut -c 1-7` ] ; then
 osxdir="osxi"
else
 osxdir="osx"
fi

cd faad2

# cleanup from any previous builds

make clean 2>/dev/null
make distclean 2>/dev/null
rm -fr config.h config.h.in config.status Makefile faad2.spec stamp-h1
rm -fr config.log aclocal.m4 autom4te.cache Makefile.in configure libtool
rm -fr libfaad/.libs common/mp4ff/.libs common/mp4v2/.libs
rm -fr libfaad/.deps common/mp4ff/.deps common/mp4v2/.deps
rm -f $osxdir/libfaad.a $osxdir/libmp4ff.a

# reconfigure everything

chmod a+x bootstrap
./bootstrap

# build the libs

./configure --disable-shared --disable-server --without-xmms 

cd libfaad
make clean 2>/dev/null
make
cd ..

cd common/mp4ff
make clean 2>/dev/null
make
cd ../..

# copy our libs to dir $osxdir/

mkdir -p $osxdir
cp -p libfaad/.libs/libfaad.a $osxdir/libfaad.a
cp -p common/mp4ff/.libs/libmp4ff.a $osxdir/libmp4ff.a

# optional cleanup

make clean 2>/dev/null
make distclean 2>/dev/null
rm -f ltmain.sh ../../ltmain.sh
#rm -fr config.h config.h.in config.status Makefile faad2.spec stamp-h1
rm -fr config.h.in config.status Makefile faad2.spec stamp-h1
rm -fr config.log aclocal.m4 autom4te.cache Makefile.in configure libtool
rm -fr libfaad/.libs common/mp4ff/.libs common/mp4v2/.libs
rm -fr libfaad/.deps common/mp4ff/.deps common/mp4v2/.deps frontend/.deps plugins/mpeg4ip/.deps

# back to MoreAmp/libs dir

cd ..
