#!/bin/sh

# mamkfaad2unix.sh

# this script makes libfaad.a libmp4ff.a
# for unix/linux from the faad2-2.6.1.tar.gz.tar release

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamkfaad2unix.sh : not in libs"
 echo >&2 "mamkfaad2unix.sh : not in libs"
 exit 1
fi

cd faad2

# cleanup from any previous builds

make clean 2>/dev/null
make distclean 2>/dev/null
rm -fr aclocal.m4 config.h.in config.h ltmain.sh configure
rm -fr autom4te.cache install-sh mkinstalldirs missing
rm -fr config.guess config.sub Makefile.in compile depcomp libtool config.status
rm -fr Makefile faad2.spec stamp-h1 config.log
rm -fr libfaad/.libs common/mp4ff/.libs
rm -fr libfaad/.deps common/mp4ff/.deps
rm -f libfaad.a libmp4ff.a

# fix line feeds
# chmod +x ../fixlf.sh
# ../fixlf.sh

# reconfigure everything

chmod +x bootstrap; ./bootstrap # autoreconf -vif

# remove "tag=CC" "tag=cc" "tag=CXX" from Makefile.in's
chmod +x ../fixtag.sh
../fixtag.sh

# build the libs

./configure --disable-shared --without-xmms

cd libfaad
make clean 2>/dev/null
make
cd ..

cd common/mp4ff
make clean 2>/dev/null
make
cd ../..

# copy our libs

cp -p libfaad/.libs/libfaad.a .
cp -p common/mp4ff/.libs/libmp4ff.a .

# optional cleanup

# make clean 2>/dev/null
# make distclean 2>/dev/null
# rm -fr libfaad/.libs common/mp4ff/.libs
# rm -fr libfaad/.deps common/mp4ff/.deps

# back to MoreAmp/libs dir

cd ..
