#!/bin/sh

# script mamklibsosx.sh
# rebuilds the libs in the libs dir for osx
#--------------------------------------------------------------------------

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamklibsosx.sh : not in libs"
 echo >&2 "mamklibsosx.sh : not in libs"
 exit 1
fi

#--------------------------------------------------------------------------
if [ "powerpc" != `uname -p | cut -c 1-7` ] ; then
 osxdir="osxi"
else
 osxdir="osx"
fi

#--------------------------------------------------------------------------



# faac

echo
date
echo "faac"
echo >&2
date >&2
echo >&2 "faac"

./mamkfaacosx.sh
#--------------------------------------------------------------------------

# faad2

echo
date
echo "faad2"
echo >&2
date >&2
echo >&2 "faad2"

./mamkfaad2osx.sh
#--------------------------------------------------------------------------

# lame

echo
date
echo "lame"
echo >&2
date >&2
echo >&2 "lame"

cd lame
make clean; make distclean
./configure --disable-shared --disable-decoder --disable-decode-layer2 --disable-frontend --disable-gtktest
make
mkdir -p $osxdir
cp -p libmp3lame/.libs/libmp3lame.a $osxdir
make clean
cd ..
#--------------------------------------------------------------------------

# libid3tag

echo
date
echo "libid3tag"
echo >&2
date >&2
echo >&2 "libid3tag"

cd libid3tag
make clean; make distclean
./configure --disable-shared
make
mkdir -p $osxdir
cp -p .libs/libid3tag.a $osxdir
make clean
cd ..
#--------------------------------------------------------------------------

# libmad

echo
date
echo "libmad"
echo >&2
date >&2
echo >&2 "libmad"

cd libmad
make clean; make distclean
./configure --disable-shared
make
mkdir -p $osxdir
cp -p .libs/libmad.a $osxdir
cp -p mad.h $osxdir
make clean
cd ..
#--------------------------------------------------------------------------

# libogg

echo
date
echo "libogg"
echo >&2
date >&2
echo >&2 "libogg"

cd libogg
make clean; make distclean
./configure --disable-shared --prefix=`pwd`/inst
make
mkdir -p $osxdir
cp -p src/.libs/libogg.a $osxdir
make install
make clean
cd ..
#--------------------------------------------------------------------------

# libvorbis

echo
date
echo "libvorbis"
echo >&2
date >&2
echo >&2 "libvorbis"

cd libvorbis
make clean; make distclean
./configure --disable-shared --with-ogg=`pwd`/../libogg/inst
make
mkdir -p $osxdir
cp -p lib/.libs/libvorbis.a $osxdir
cp -p lib/.libs/libvorbisfile.a $osxdir
cp -p lib/.libs/libvorbisenc.a $osxdir
make clean
cd ..
#--------------------------------------------------------------------------

# libjack

echo
date
echo "jack"
echo >&2
date >&2
echo >&2 "jack"

cd jack
make clean; # make distclean

./configure --enable-static --disable-shared --disable-mac-universal --disable-portaudio

cd libjack
make
cd ..

mkdir -p ./$osxdir
cp -p libjack/.libs/libjack.a ./$osxdir
make clean
cd ..
#--------------------------------------------------------------------------

# portaudio

echo
date
echo "portaudio"
echo >&2
date >&2
echo >&2 "portaudio"

./mamkpaosx.sh
#--------------------------------------------------------------------------

# libFLAC

echo
date
echo "flac"
echo >&2
date >&2
echo >&2 "flac"

cd flac
make clean; make distclean

# 1.1.2 
# ./configure --disable-shared \
#             --disable-dependency-tracking \
#             --disable-libtool-lock \
#             --disable-oggtest \
#             --disable-asm-optimizations

# 1.2.1
# ./configure --disable-shared --disable-dependency-tracking --disable-libtool-lock --disable-oggtest --disable-asm-optimizations --disable-ogg --disable-xmms-plugin --disable-flac --disable-doxygen-docs --disable-cpplibs

./configure --disable-shared \
            --disable-dependency-tracking \
            --disable-libtool-lock \
            --disable-oggtest \
            --disable-asm-optimizations \
            --disable-ogg --disable-xmms-plugin --disable-flac --disable-doxygen-docs --disable-cpplibs

cd src/libFLAC
make
cd ../..
mkdir -p $osxdir
cp -p src/libFLAC/.libs/libFLAC.a $osxdir
make clean
cd ..
#--------------------------------------------------------------------------

echo
date
echo >&2
date >&2
