#!/bin/sh

# mamkpaosx.sh

# this script makes libportaudio.a for os x
# from the pa_snapshot.tar.gz

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamkpaosx.sh : not in libs"
 echo >&2 "mamkpaosx.sh : not in libs"
 exit 1
fi

if [ "powerpc" != `uname -p | cut -c 1-7` ] ; then
 osxdir="osxi"
else
 osxdir="osx"
fi

cd portaudio

# cleanup from any previous build
make clean; make distclean

# configure
string=`/usr/bin/sw_vers -productVersion | /usr/bin/grep 10.3`
if [ "$string" != "" ]; then
 # this is for 10.3
 echo "BUILDING PORTAUDIO FOR 10.3" >&2
 CFLAGS="-DMAC_OS_X_VERSION_MIN_REQUIRED=MAC_OS_X_VERSION_10_3 -DMAC_OS_X_VERSION_MAX_ALLOWED=MAC_OS_X_VERSION_10_3 -DALLOW_SMP_DANGERS -DMOSX_USE_NON_ATOMIC_FLAG_BITS=1" JACK_LIBS="../jack/osx/libjack.a" JACK_CFLAGS="-I../jack/jack" ./configure --disable-shared --disable-mac-universal
else
 CFLAGS="" JACK_LIBS="../jack/osxi/libjack.a" JACK_CFLAGS="-I../jack/jack" ./configure --enable-static --disable-shared --disable-mac-universal
fi

# build the lib
make

# copy our lib
mkdir -p ./$osxdir
cp -p lib/.libs/libportaudio.a ./$osxdir

# optional cleanup
make clean
CFLAGS=""
JACK_LIBS=""
JACK_CFLAGS=""

# back to MoreAmp/libs dir
cd ..

