// maDefs.h

/*
 * MoreAmp
 * Copyright (C) 2004-2010 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __MADEFS_H__
#define __MADEFS_H__

#define MAX_PATH 260							// max file path length
#define SONGSLOADMAX 128						// max songs loaded on vdisk or in memory
#define MAVDISKTMP (char *)"mavdisktmp"
#define MASONGLISTSDIR (char *)"masonglists"
#define MASETTINGSDIR (char *)"masettings"
#define MAFILEOUTDIR (char *)"mafileout"
#define MASETSDEFAULT (char *)"madefault"
#define SONGLISTTMP (char *)"masonglisttmpf"
#define SONGLISTDROP (char *)"madrop"
#define SONGLISTCDA (char *)"macda"
#define SONGLISTAUDIOIN (char *)"maaudioin"

#define NAMELENMAX 255
#define SONGRECORD unsigned short // info saved for each song in a list (has played or not)
#define RECENTSONGLIST (char *)"marecentlistname.txt"
#define MALOG (char *)"maLog"
#define NOSONGSLOADED (char *)"(No songs loaded)"
#define CDAMAXNUMDRIVES 16
#define MAREADME (char *)"README"
#if !defined(MANOCDA) && defined(__MAUNIX__)
 #define MASETSCDROMFILE (char *)"masetscdrom"	// cdrom settings file name
#endif
#if defined(MAKEYBOARD)
 #define MAKEYBINDINGSFILE (char *)"makeybindings" // keyboard bindings file name
#endif

// button labels
#if defined(MAGUIOSX)
 #define LABEL_QUIT (char *)""
 #define LABEL_PREV (char *)""
 #define LABEL_PLAY (char *)""
 #define LABEL_PAUSE (char *)""
 #define LABEL_STOP (char *)""
 #define LABEL_NEXT (char *)""
#elif defined(MAGUIGTK)
 #define LABEL_QUIT (char *)"   '" // these go under buttons
 #define LABEL_PREV (char *)"   '"
 #define LABEL_PLAY (char *)"   '"
 #define LABEL_PAUSE (char *)"   '"
 #define LABEL_STOP (char *)"   '"
 #define LABEL_NEXT (char *)"   '"
 #define LABEL_B_QUIT (char *)"Quit" // these go inside buttons
 #define LABEL_B_PREV (char *)"Prev"
 #define LABEL_B_PLAY (char *)"Play"
 #define LABEL_B_PAUSE (char *)"Pause"
 #define LABEL_B_STOP (char *)"Stop"
 #define LABEL_B_NEXT (char *)"Next"
 #define LABEL_INFO (char *)"Info"
 #define LABEL_LIST (char *)"List"
 #define LABEL_LOAD (char *)"Load"
 #define LABEL_SONG (char *)"Song" 
 #define LABEL_MINUS (char *)"Minus"
 #define LABEL_PLUS (char *)"Plus"
 #define LABEL_MID (char *)"Mid"
 #define LABEL_COPY (char *)"Copy"
 #define LABEL_PASTE (char *)"Paste"
 #define LABEL_RESET (char *)"Reset"
 #define LABEL_SHIFTL (char *)"Shift L"
 #define LABEL_SHIFTR (char *)"Shift R"
 #define LABEL_INVERT (char *)"Invert"
 #define LABEL_OK (char *)"Ok"
 #define LABEL_CANCEL (char *)"Cancel"
#else // wx
 #define LABEL_QUIT (char *)"Quit" // these go under buttons
 #define LABEL_PREV (char *)"Prev"
 #define LABEL_PLAY (char *)"Play"
 #define LABEL_PAUSE (char *)"Pause"
 #define LABEL_STOP (char *)"Stop"
 #define LABEL_NEXT (char *)"Next"
#endif

// if you log this many errors something is wrong
#define MALOGMAXDEF 1000

// if you log errors this fast something is wrong
#define MALOGEVENTSDEF 100
#define MALOGPERIODDEF 3 // seconds

// values for logflags to stop or limit logging :
#define kMALOGOFF   1 // stop logging
#define kMALOGMAX   2 // popup a warning and stop logging if MALOGMAXDEF log events occur
#define kMALOGRATE  4 // popup a warning if more than MALOGEVENTSDEF occur per MALOGPERIODDEF

// threads
#if defined(__MAOSX__)
 #define MATHREADPRILO   100 // default value
 #define MATHREADPRIHI1 3000 // 1 to 10000
 #define MATHREADPRIHI2 5000
 #define MATHREADSTACKSIZE 4194304 // 2 exp 22 bytes
#endif
#if defined(__MAWIN__)
 #define MATHREADPRILO  THREAD_PRIORITY_NORMAL
 #define MATHREADPRIHI1 THREAD_PRIORITY_ABOVE_NORMAL // THREAD_PRIORITY_TIME_CRITICAL
 #define MATHREADPRIHI2 THREAD_PRIORITY_HIGHEST
 #define MATHREADSTACKSIZE 4096 // kbytes
#endif
#if defined(__MAUNIX__)
 #define MATHREADPRILO  SCHED_OTHER // sched policy, not pri
 #define MATHREADPRIHI1 SCHED_RR
 #define MATHREADPRIHI2 SCHED_FIFO
 #define MATHREADSTACKSIZE 4096 // kbytes, probably never used
#endif

// file extensions
#define EXTMP1 ".mp1"
#define EXTMP2 ".mp2"
#define EXTMP3 ".mp3"
#define EXTOGG ".ogg"
#define EXTWMA ".wma"

#define EXTAIF ".aif"
#define EXTAIFF ".aiff"
#define EXTWAV ".wav"

/* these could be added to maPlayAif
							// actual extensions may be different
#define EXTAU ".au"			// Sun/NeXT AU format (big endian)
#define EXTRAW ".raw"		// RAW PCM data
#define EXTPAF ".paf"		// Ensoniq PARIS file format
#define EXTSVX ".svx"		// Amiga IFF / SVX8 / SV16 format
#define EXTNIST ".nist"		// Sphere NIST format
#define EXTVOC ".voc"		// VOC fil
#define EXTIRCAM ".ircam"	// Berkeley/IRCAM/CARL
#define EXTW64 ".w64"		// Sonic Foundry's 64 bit RIFF/WAV
#define EXTMAT4 ".mat4"		// Matlab (tm) V4.2 / GNU Octave 2.0
#define EXTMAT5 ".mat5"		// Matlab (tm) V5.0 / GNU Octave 2.1
#define EXTPVF ".pvf"		// Portable Voice Format
#define EXTXI ".xi"			// Fasttracker 2 Extended Instrument
#define EXTHTK ".htk"		// HMM Tool Kit format
*/

#define EXTAAC ".aac"
#define EXTM2A ".m2a"
#define EXTM4A ".m4a"
#define EXTMP4 ".mp4"
#define EXTFLA ".fla"
#define EXTFLAC ".flac"
#define EXTMAA ".maa" // audio input flag file
#define EXTCDA ".cda"
#define EXTMAF ".maf" // ma song list
#define EXTMAS ".mas" // ma settings
#define EXTM3U ".m3u" // standard song list
#define EXTTXT ".txt" // ma log

// input files (order matches g_extstr[] in maPlayer.c)
enum
{
	kMAMP1 = 0,
	kMAMP2,
	kMAMP3,
	kMAOGG,
	kMAWMA,

	kMAAIF,
	kMAAIFF,
	kMAWAV,
	
	/* these could be added to maPlayAif
	kMAAU,		// Sun/NeXT AU format (big endian)
	kMARAW,		// RAW PCM data
	kMAPAF,		// Ensoniq PARIS file format
	kMASVX,		// Amiga IFF / SVX8 / SV16 format
	kMANIST,	// Sphere NIST format
	kMAVOC,		// VOC fil
	kMAIRCAM,   // Berkeley/IRCAM/CARL
	kMAW64,		// Sonic Foundry's 64 bit RIFF/WAV
	kMAMAT4,	// Matlab (tm) V4.2 / GNU Octave 2.0
	kMAMAT5,	// Matlab (tm) V5.0 / GNU Octave 2.1
	kMAPVF,		// Portable Voice Format
	kMAXI,		// Fasttracker 2 Extended Instrument
	kMAHTK,		// HMM Tool Kit format
	*/
	
	kMAAAC,
	kMAM2A,
	kMAM4A,
	kMAMP4,
	kMAFLA,
	kMAFLAC,
	kMAMAA,		// audio input fag file
	
	// files from here on are 'not playable'
	kMAMAF,		// ma songlist file
	kMAMAS,		// ma settings file
	kMAM3U,		// songlist file
	kMACDA,		// keep this here (next-to-last)
	kMALAST
};

#define kMAFIRSTPLAYBLE 0 // kMAMP1
#define kMALASTPLAYBLE (kMAMAF - 1) // not kMACDA

// outputs (order matches g_extstrout[] in maPlayer.c)
enum
{
	kOUTSOUND = 0,
	
#ifdef ENCODEMP3
	kOUTMP3,
#endif

#ifdef ENCODEOGG
	kOUTOGG,
#endif

#ifdef ENCODEFLAC
	kOUTFLAC,
#endif

#ifdef ENCODEAAC
	kOUTAAC,
#endif

#ifdef ENCODEMP4
	kOUTMP4,
#endif

#ifdef ENCODEWMA
	kOUTWMA,
#endif

#ifdef ENCODEWAV
	kOUTWAV,
#endif

#ifdef ENCODEAIF
	kOUTAIF,
#endif

	kOUTLASTE
};

#define MASTRSOUND "Sound"
#define kOUTFIRST (kOUTSOUND + 1)
#define kOUTLAST (kOUTLASTE - 1) // kOUTAIF
#define kOUTMAX 10 // at least kOUTLASTE

// faac encoder options
#define kACCADTS	1
#define kACCMPEG2   2 // else MPEG4
#define kACCMAIN	4
#define kACCLTP		8 // else LC // MAIN 0, LOW 1, SSR 2, LTP 3
#define kACCTNS		16
#define kACCM4A		32 // make .m4a instead of .mp4

#if defined(__MAOSX__)
 #ifdef __MAOSX__
  #define FILESEP '/'
  #define VOLSEP '/'
 #else
  #define FILESEP ':'
  #define VOLSEP ':'
 #endif
#endif

#ifdef __MAWIN__
 #define FILESEP '\\'
 #define VOLSEP ':'
#endif

#ifdef __MAUNIX__
  #define FILESEP '/'
  #define VOLSEP '/'
#endif

#define MADNUMBANDS 10					// mad mp3 equalizer bands (used as preamp)

#define EQBANDS31 31					// larger number of pcm equalizer bands (sliders)
#define EQBANDS10 10					// lesser number of pcm equalizer bands

#define EQSLIDERFIRST 0					// first pcm equalizer slider index
#define EQSLIDERLAST (EQBANDS31 - 1)	// last  pcm equalizer slider index
#define EQ2SLIDERFIRST (EQSLIDERLAST + 1) // first pcm equalizer2 slider index
#define EQ2SLIDERLAST (EQ2SLIDERFIRST + EQBANDS31 - 1) // last  pcm equalizer2 slider index
#define EQNAMELEN 32					// max length of name of equalizer preset
#define EQNUMPRESETS 16					// sets of pcm equalizer slider values

#define SLIDERINCR 1					// slider increment value when pushing the + button
#define SLIDERDECR 1					// slider decrement value when pushing the - button

// listbox display modes
#define LBOXON		 1
#define LBOXINFO	 2
#define LBOXLIST	 4
#define LBOXLOADED	 8
#define LBOXID3		16
#define LBOXINDEX   32
#define LBOXDIR		64
#define LBOXPATH   128

// slider ranges. Some code depends on MIN values being 0.
#define POSMIN 0				// position slider range 0 to 1000
#define POSMAX 1000

#define VOLUMEMIN 0				// volume slider range
// volume attenuation
#define VOLUMEMAX 1000
#define VOLUMESCALE VOLUMEMAX
#define kVOLMAX 32767
#define kVOLEXP 15

#define SEPARATIONMIN 0			// separation slider range 0 to 100
#define SEPARATIONMAX 100
#define SEPARATIONCALE SEPARATIONMAX

#define PREAMPMIN DBSLIDERMIN	// preamp slider range 0 to 64
#define PREAMPMAX DBSLIDERMAX
#define PREAMPMINDB (-16)		// preamp slider db range -16 to +16
#define PREAMPMAXDB 16

#define EFFECTSMIN 0			// effects slider range 0 to 100
#define EFFECTSMAX 100

#define EFFECTSPITCHMIN 0		// pitch effect slider range 0 to 48
#define EFFECTSPITCHMAX 48

#define DBSLIDERMIN 0			// dbsliders have a symmetric dB scale (eq and preamp sliders)
#define DBSLIDERMAX 64			// db slider range 0 to 64
#define DBRANGE 16				// db slider abs dB range (-16 to +16)

//constants
//							 0 to EQBANDS31
#define PREAMPSLIDER		-1
#define SEPARATIONSLIDER	-2
#define VOLUMESLIDERS		-3
#define EFFECTSSLIDERS		-4
#define VOLUMESLIDERRIGHT	-5
#define VOLUMESLIDERLEFT	-6
#define EFFECTSSLIDERPITCH  -7
#define EFFECTSSLIDERPITCH2 -8
#define EFFECTSSLIDERTEMPO  -9
#define EFFECTSSLIDERSPEED  -10
#define EQSLIDERS			-11
#define EQ2SLIDERS			-12
#define ALLSLIDERS			-13

// effects switches
#define EFFECTSON			 1
#define EFFECTSPITCH		 2
#define EFFECTSTEMPO		 4
#define EFFECTSSPEED		 8
#define EFFECTSQUALFILTER	16
#define EFFECTSQUALSPEED	32

// values for usemem
#define BUFUSEMEM		0
#define BUFUSEVDISK		1
#define BUFUSEDIRECT	2
#define BUFUSEMAX		3

// songmem
#define MEGABYTE 1048576	// 1 MB

//(2047 * MEGABYTE is close to max positive int value, 2048 goes negative)
#define SONGMEMMAX 2047		// 2047 MB maximum

#define SONGMEMDEF 16		// default
#define SONGMEMMIN 16		// minimum

// sound output
#define MAOUTCHANNELS   2   // number of output channels
#define MAOUTBITS	   16   // bits per mono sample
#define MAOUTBYTES		4   // bytes per stereo sample
#define MAOUTRATE   44100   // not always

// equalizer flags
#define MAEQACTIVE		1 // equalizer is on
#define MAEQWINDOW		2 // show equalizer window
#define MAEQ31BANDS		4 // 31 bands, else 10
#define MAEQEXTRA		8 // filter twice, else once
#define MASEPARATELR   16 // separate left/right equalizers
#define MAEQZOOM	   32 // zoom mode, else offset
#define MAEQLINK	   64 // link sliders

#define FILEOUTBITRATEDEF 8 // 128 

// 2 near-best quality, not too slow; 5 good quality, fast; 7 ok quality, really fast
#define FILEOUTQUALITYDEF 5
#define FILEOUTQUALITYMP3DEF 2
#define FILEOUTQUALITYOGGDEF 5 // not used
#define FILEOUTQUALITYAACDEF 3
#define FILEOUTQUALITYMP4DEF 3

#define FILEOUTMODEDEF 0 // Stereo

#define FILEOUTSAMPLERATEDEF 7 // 44100

#define NUMWINCONF 2 // alternate window configurations

#define VERSIONSTRINGSIZE 16

#if !defined(MANOCDA) && defined(__MAUNIX__)
 #define MACDANAMEDEF (char *)"/dev/cdrom" // default unix cdrom drive name
#endif

#define SOUNDBUFSIZE FIFOSIZE
// FIFOSIZE affects output controls latency and
//			sets minimum playable file size and
//			sets the size of the pcm block for the equalizer
//			g_cdabufblocks = FIFOSIZE / CDABLOCKSIZE;
#define FIFOSIZE 27648 // 2 * 13824 // 2 * 1152 * 12 // 2 * PCM_CHUNK * 2 * 12
#define STOP_FLAG		0x01
#define STOP_PLAYDECODE	0x02
#define STOP_SNDCHANNEL	0x04
#define STOP_INPUT		0x08
#define MSPERSEC 1000		// milliseconds per second, or MAD_UNITS_MILLISECONDS
#define DUMMYOUTFILEP ((FILE *)-123)
#define NOTIMESTR (char *)"--:--:--.-"
#define ZEROMSSTR (char *)"00:00:00.0"
#if defined(MAGUIOSX)
 #define LISTLINELEN 256	// max listbox line length
#else
 #define LISTLINELEN 512
#endif
#define SECSPERMIN 60		// seconds per minute
#define MINSPERHOUR 60		// minutes per hour
#define MSPERDS 100			// milliseconds per decisecond, or MAD_UNITS_DECISECONDS
#define MSPERMIN 60000		// milliseconds per minute
#define MSPERHOUR 3600000	// milliseconds per hour
#define MAXLOGLINELEN (MAX_PATH + MAX_PATH)
// #if defined(AUDIO_MAC_CORE) || defined(AUDIO_PORTAUDIO) || defined(AUDIO_WIN_WAVE)
#define NSNDBUFS 3
// #endif

// gui
// for mamessageBox
#define maYES                   0x00000002
#define maOK                    0x00000004
#define maNO                    0x00000008
#define maYES_NO                (maYES | maNO)
#define maCANCEL                0x00000010
#define maICON_EXCLAMATION      0x00000100
#define maICON_HAND             0x00000200
#define maICON_QUESTION         0x00000400
#define maICON_INFORMATION      0x00000800

// for maFileDialog
enum
{
    maOPEN              = 0x0001,
    maSAVE              = 0x0002,
    maOVERWRITE_PROMPT  = 0x0004,
    maHIDE_READONLY     = 0x0008,
    maFILE_MUST_EXIST   = 0x0010,
    maMULTIPLE          = 0x0020,
    maCHANGE_DIR        = 0x0040
};

// windows enum
enum ID_WINDOW
{
	WINDOWAPP = 0,
	WINDOWLIST,
	WINDOWEQ,
	WINDOWEQ2,
	WINDOWEFFECTS,
	WINDOWABOUT,
	WINDOWREADME,
	WINDOWCATALOG,
	
	WINDOWADVANCED,
	
#if defined(MAKEYBOARD)
	WINDOWKEYBINDINGS,
#endif

#if !defined(MANOCDA) && defined(__MAUNIX__)
	WINDOWAUDIOCD,
#endif

	WINDOWLOG,
	
	WINDOWPROMPTNUM, // WINDOWOUTFIRST // only windowouts after this
	
#ifdef ENCODEMP3
	WINDOWOUTMP3,
#endif
#ifdef ENCODEOGG
	WINDOWOUTOGG,
#endif
#ifdef ENCODEFLAC
	WINDOWOUTFLAC,
#endif
#ifdef ENCODEAAC
	WINDOWOUTAAC,
#endif
#ifdef ENCODEMP4
	WINDOWOUTMP4,
#endif
#ifdef ENCODEWMA
	WINDOWOUTWMA,
#endif
	WINDOWOUTWAV,
	WINDOWOUTAIFF,

	WINDOWLAST
};


#define WINDOWOUTFIRST (WINDOWPROMPTNUM + 1)
#define WINDOWOUTLAST (WINDOWLAST - 1)
#define WINDOWOUTCUR (WINDOWOUTFIRST + g_sets.output - 1)

#define MAXOPENRECENT 10
#define OPENRECENTLENGTH MAX_PATH
// window menus enum
enum ID_MENU
{
#if defined(MAGUIOSX)
	MENUMOREAMP, // these value are put in the nib file
	MENUFILES,
	MENUMACONTROLS,
	MENUMASETS,
	MENUTOOLS,
	MENUSHOW,
	MENUWINDOW,
	MENUHELP,
#else // wx
	MENUFILES,
	MENUMACONTROLS,
	MENUMASETS,
	MENUTOOLS,
	MENUSHOW,
	MENUHELP,
	MENUTITLEINFO,
	MENUOPENRECENT,
#endif
	MENULAST
};

// with MAGUIOSX these id values must match those set manually in the IB nib files.
#if defined(MAGUIOSX)
 #define ID0 0 // changing this or defines below breaks MAGUIOSX IB nib files
#else // wx and others
 #define ID0 6000 // >wxID_HIGHEST
#endif

enum {
 ID_CHK_ADDMODE = (ID0 + 10), // ID_CHECKBOX_FIRST
 ID_CHK_ALTSIZE,
 ID_CHK_RANDOM,
 ID_CHK_REPTPLAYED,
 ID_CHK_LOOPLOADED,
 ID_CHK_LOOPLIST,
 ID_CHK_EQWINDOW,
 ID_CHK_LISTWINDOW,
 ID_CHK_BEG,
 ID_CHK_END,
 ID_CHK_MONOLEFT,
 ID_CHK_SPINDOWN, // 21 unused
 ID_CHK_MONORIGHT,
 ID_CHK_HIGHPRIORITY,
 ID_CHK_SINGLEPLAY,
 ID_CHK_EQUALIZER,
 ID_CHK_EQUALIZERB,
 ID_CHK_LIMITER,
 ID_CHK_EQEXTRA,
 ID_CHK_EQEXTRAB,
 ID_CHK_EFFECTS,
 ID_CHK_TITLEINFO,
 ID_CHK_INVERTRIGHT,
 ID_CHK_EQ31BANDS,
 ID_CHK_EQ31BANDSB,
 ID_CHK_REPTSONG,
 ID_CHK_MONODIFF,
 ID_CHK_BALANCE,
 ID_CHK_EQZOOM,
 ID_CHK_EQLINK,
 ID_CHK_SEPARATELR,
 ID_CHK_ADTS,
 ID_CHK_M4A,
 ID_CHK_PITCH,
 ID_CHK_TEMPO,
 ID_CHK_SPEED,
 ID_CHK_QUALFILTER,
 ID_CHK_QUALSPEED,
 ID_CHK_EFFECTSB,
 ID_CHK_CLOSEREOPEN,
#if !defined(MANOCDA) && defined(__MAUNIX__)
  ID_CHK_CDPARANOIA,
#endif
 ID_CHK_USEM3U,
 ID_CHK_SHOWINDEX,
 ID_CHK_SHOWDIR,
 ID_CHK_SHOWPATH // ID_CHECKBOX_LAST
};

#define ID1 (ID0 + 100)
enum {
 ID_BTN_PREVIOUS = (ID1 + 1), // ID_BUTTON_FIRST
 ID_BTN_PLAY,
 ID_BTN_QUIT,
 ID_BTN_PAUSE,
 ID_BTN_STOP,
 ID_BTN_NEXT,
 ID_BTN_LOADED,
 ID_BTN_SONGLIST,
 ID_BTN_INFO,
 ID_BTN_SONGINFO,
 ID_BTN_EQMINUS,
 ID_BTN_EQPLUS,
 ID_BTN_EQMID,
 ID_BTN_EQCOPY,
 ID_BTN_EQPASTE,
 ID_BTN_EQRESTORE,
 ID_BTN_EQSHIFTL,
 ID_BTN_EQSHIFTR,
 ID_BTN_EQINVERT,
 ID_BTN_EQ2MID,
 ID_BTN_EQ2COPY,
 ID_BTN_EQ2PASTE,
 ID_BTN_EQ2RESTORE,
 ID_BTN_FILEOUTDIR,
#if !defined(MANOCDA) && defined(__MAUNIX__)
  ID_BTN_AUDIOCDSET,
  ID_BTN_AUDIOCDCLEAR,
  ID_BTN_AUDIOCDSAVE,
  ID_BTN_AUDIOCDCLOSE,
#endif
 ID_BTN_VIEWERFIND,
 ID_BTN_EDITSAVE,
 ID_BTN_PROMPTNUMCANCEL,
 ID_BTN_PROMPTNUMOK // ID_BUTTON_LAST
};

#define ID2 (ID1 + 100)
#define ID_LIST_CTRL			(ID2 + 1)

#define ID3 (ID2 + 100)
enum {
 ID_POPUP_OUTPUT = (ID3 + 1), // ID_POPUP_FIRST
 ID_POPUP_BUFFER,
 ID_POPUP_BITRATE,
 ID_POPUP_QUALITY,
 ID_POPUP_MODE,
 ID_POPUP_SAMPLERATE,
#if !defined(MANOCDA) && defined(__MAUNIX__) 
  ID_POPUP_EQPRESET,
  ID_POPUP_AUDIOCD // ID_POPUP_LAST
#else
  ID_POPUP_EQPRESET // ID_POPUP_LAST
#endif
};

#define ID4 (ID3 + 100)
#define ID_EDITTEXT_PROMPTNUM	(ID4 + 1)
#define ID_SCROLLBAR_VIEWERV	(ID4 + 2)
#define ID_TEXTVIEW_ABOUTVIEWER (ID4 + 3)
#define ID_EDITTEXT_VIEWER		(ID4 + 4)
#define ID_EDITTEXT_EQ			(ID4 + 5)
#define ID_EDITTEXT_VIEWERFIND  (ID4 + 6)
#define ID_EDITTEXT_ABOUTVIEWER	(ID4 + 7)

#define ID5 (ID4 + 100)
enum {
 ID_SPIN_BEG = (ID5 + 1), // ID_SPIN_FIRST 
 ID_SPIN_END,
 ID_SPIN_BUFFER,
 ID_SPIN_PREA,
 ID_SPIN_SEP,
 ID_SPIN_VOLR,
 ID_SPIN_VOLL,
 ID_SPIN_EQOFFSET,
 ID_SPIN_EQ0,
 ID_SPIN_EQ1,
 ID_SPIN_EQ2,
 ID_SPIN_EQ3,
 ID_SPIN_EQ4,
 ID_SPIN_EQ5,
 ID_SPIN_EQ6,
 ID_SPIN_EQ7,
 ID_SPIN_EQ8,
 ID_SPIN_EQ9,
 ID_SPIN_EQ10,
 ID_SPIN_EQ11,
 ID_SPIN_EQ12,
 ID_SPIN_EQ13,
 ID_SPIN_EQ14,
 ID_SPIN_EQ15,
 ID_SPIN_EQ16,
 ID_SPIN_EQ17,
 ID_SPIN_EQ18,
 ID_SPIN_EQ19,
 ID_SPIN_EQ20,
 ID_SPIN_EQ21,
 ID_SPIN_EQ22,
 ID_SPIN_EQ23,
 ID_SPIN_EQ24,
 ID_SPIN_EQ25,
 ID_SPIN_EQ26,
 ID_SPIN_EQ27,
 ID_SPIN_EQ28,
 ID_SPIN_EQ29,
 ID_SPIN_EQ30,
 ID_SPIN_EQ2_0,
 ID_SPIN_EQ2_1,
 ID_SPIN_EQ2_2,
 ID_SPIN_EQ2_3,
 ID_SPIN_EQ2_4,
 ID_SPIN_EQ2_5,
 ID_SPIN_EQ2_6,
 ID_SPIN_EQ2_7,
 ID_SPIN_EQ2_8,
 ID_SPIN_EQ2_9,
 ID_SPIN_EQ2_10,
 ID_SPIN_EQ2_11,
 ID_SPIN_EQ2_12,
 ID_SPIN_EQ2_13,
 ID_SPIN_EQ2_14,
 ID_SPIN_EQ2_15,
 ID_SPIN_EQ2_16,
 ID_SPIN_EQ2_17,
 ID_SPIN_EQ2_18,
 ID_SPIN_EQ2_19,
 ID_SPIN_EQ2_20,
 ID_SPIN_EQ2_21,
 ID_SPIN_EQ2_22,
 ID_SPIN_EQ2_23,
 ID_SPIN_EQ2_24,
 ID_SPIN_EQ2_25,
 ID_SPIN_EQ2_26,
 ID_SPIN_EQ2_27,
 ID_SPIN_EQ2_28,
 ID_SPIN_EQ2_29,
 ID_SPIN_EQ2_30,
 ID_SPIN_PITCH,
 ID_SPIN_PITCH2,
 ID_SPIN_TEMPO,
 ID_SPIN_SPEED // ID_SPIN_LAST
};

#define ID6 (ID5 + 100)
enum {
 ID_SLIDER_VOLUMEL = (ID6 + 1), // ID_SLIDER_FIRST // slider ids need to be contiguous
 ID_SLIDER_VOLUMER,
 ID_SLIDER_VOLUMESEP,
 ID_SLIDER_PREAMP,
 ID_SLIDER_POSITION,
 ID_SLIDER_EQ0, // ID_SLIDER_EQ_FIRST
 ID_SLIDER_EQ1,
 ID_SLIDER_EQ2,
 ID_SLIDER_EQ3,
 ID_SLIDER_EQ4,
 ID_SLIDER_EQ5,
 ID_SLIDER_EQ6,
 ID_SLIDER_EQ7,
 ID_SLIDER_EQ8,
 ID_SLIDER_EQ9,
 ID_SLIDER_EQ10,
 ID_SLIDER_EQ11,
 ID_SLIDER_EQ12,
 ID_SLIDER_EQ13,
 ID_SLIDER_EQ14,
 ID_SLIDER_EQ15,
 ID_SLIDER_EQ16,
 ID_SLIDER_EQ17,
 ID_SLIDER_EQ18,
 ID_SLIDER_EQ19,
 ID_SLIDER_EQ20,
 ID_SLIDER_EQ21,
 ID_SLIDER_EQ22,
 ID_SLIDER_EQ23,
 ID_SLIDER_EQ24,
 ID_SLIDER_EQ25,
 ID_SLIDER_EQ26,
 ID_SLIDER_EQ27,
 ID_SLIDER_EQ28,
 ID_SLIDER_EQ29,
 ID_SLIDER_EQ30,
 ID_SLIDER_EQ2_0, // ID_SLIDER_EQ2_FIRST
 ID_SLIDER_EQ2_1,
 ID_SLIDER_EQ2_2,
 ID_SLIDER_EQ2_3,
 ID_SLIDER_EQ2_4,
 ID_SLIDER_EQ2_5,
 ID_SLIDER_EQ2_6,
 ID_SLIDER_EQ2_7,
 ID_SLIDER_EQ2_8,
 ID_SLIDER_EQ2_9,
 ID_SLIDER_EQ2_10,
 ID_SLIDER_EQ2_11,
 ID_SLIDER_EQ2_12,
 ID_SLIDER_EQ2_13,
 ID_SLIDER_EQ2_14,
 ID_SLIDER_EQ2_15,
 ID_SLIDER_EQ2_16,
 ID_SLIDER_EQ2_17,
 ID_SLIDER_EQ2_18,
 ID_SLIDER_EQ2_19,
 ID_SLIDER_EQ2_20,
 ID_SLIDER_EQ2_21,
 ID_SLIDER_EQ2_22,
 ID_SLIDER_EQ2_23,
 ID_SLIDER_EQ2_24,
 ID_SLIDER_EQ2_25,
 ID_SLIDER_EQ2_26,
 ID_SLIDER_EQ2_27,
 ID_SLIDER_EQ2_28,
 ID_SLIDER_EQ2_29,
 ID_SLIDER_EQ2_30, // ID_SLIDER_EQ2_LAST
 ID_SLIDER_PITCH,
 ID_SLIDER_PITCH2,
 ID_SLIDER_TEMPO,
 ID_SLIDER_SPEED // ID_SLIDER_LAST
};

#define ID7 (ID6 + 100)
enum {
 ID_TEXT_TIMEPOS = ID7 + 1,
 ID_TEXT_TIMEBEG,
 ID_TEXT_TIMEEND,
 ID_TEXT_ENCODING_MINBITRATE, // not used
 ID_TEXT_BUTTON_QUIT,
 ID_TEXT_BUTTON_PREVIOUS,
 ID_TEXT_BUTTON_PLAY,
 ID_TEXT_BUTTON_PAUSE,
 ID_TEXT_BUTTON_STOP, 
 ID_TEXT_BUTTON_NEXT, // ID_TEXT_BUTTON_LAST
 ID_TEXT_VOLUME,
 ID_TEXT_PREAMP,
 ID_TEXT_SEP,
 ID_TEXT_M,
 ID_TEXT_S,
 ID_TEXT_PLUS, // not used
 ID_TEXT_OUTPUT,
 ID_TEXT_BUFFER,
 ID_TEXT_100VOLL,
 ID_TEXT_100VOLR,
 ID_TEXT_100SEP,
 ID_TEXT_0,
 ID_TEXT_L2, // not used
 ID_TEXT_R2, // not used
 ID_TEXT_PREAMP2, // not used
 ID_TEXT_END, // not used
 ID_TEXT_BEG,
 ID_TEXT_PITCH0,
 ID_TEXT_PITCH02,
 ID_TEXT_TEMPO0,
 ID_TEXT_SPEED0,
 ID_TEXT_EQBUTTON_ZOOM,
 ID_TEXT_EQBUTTON_MID,
 ID_TEXT_EQBUTTON_COPY,
 ID_TEXT_EQBUTTON_PASTE,
 ID_TEXT_EQBUTTON_RESET,
 ID_TEXT_EQBUTTON_SHIFTL,
 ID_TEXT_EQBUTTON_SHIFTR,
 ID_TEXT_EQBUTTON_INVERT,
 ID_TEXT_EQPRESET,
 ID_TEXT_EQEDIT,
 ID_TEXT_EQOFFSET,
 ID_TEXT_EQOFFSETVAL,
 ID_TEXT_EQBAND0,
 ID_TEXT_EQBAND1,
 ID_TEXT_EQBAND2,
 ID_TEXT_EQBAND3,
 ID_TEXT_EQBAND4,
 ID_TEXT_EQBAND5,
 ID_TEXT_EQBAND6,
 ID_TEXT_EQBAND7,
 ID_TEXT_EQBAND8,
 ID_TEXT_EQBAND9,
 ID_TEXT_EQBAND10,
 ID_TEXT_EQBAND11,
 ID_TEXT_EQBAND12,
 ID_TEXT_EQBAND13,
 ID_TEXT_EQBAND14,
 ID_TEXT_EQBAND15,
 ID_TEXT_EQBAND16,
 ID_TEXT_EQBAND17,
 ID_TEXT_EQBAND18,
 ID_TEXT_EQBAND19,
 ID_TEXT_EQBAND20,
 ID_TEXT_EQBAND21,
 ID_TEXT_EQBAND22,
 ID_TEXT_EQBAND23,
 ID_TEXT_EQBAND24,
 ID_TEXT_EQBAND25,
 ID_TEXT_EQBAND26,
 ID_TEXT_EQBAND27,
 ID_TEXT_EQBAND28,
 ID_TEXT_EQBAND29,
 ID_TEXT_EQBAND30,
 ID_TEXT_EQ2BAND0,
 ID_TEXT_EQ2BAND1,
 ID_TEXT_EQ2BAND2,
 ID_TEXT_EQ2BAND3,
 ID_TEXT_EQ2BAND4,
 ID_TEXT_EQ2BAND5,
 ID_TEXT_EQ2BAND6,
 ID_TEXT_EQ2BAND7,
 ID_TEXT_EQ2BAND8,
 ID_TEXT_EQ2BAND9,
 ID_TEXT_EQ2BAND10,
 ID_TEXT_EQ2BAND11,
 ID_TEXT_EQ2BAND12,
 ID_TEXT_EQ2BAND13,
 ID_TEXT_EQ2BAND14,
 ID_TEXT_EQ2BAND15,
 ID_TEXT_EQ2BAND16,
 ID_TEXT_EQ2BAND17,
 ID_TEXT_EQ2BAND18,
 ID_TEXT_EQ2BAND19,
 ID_TEXT_EQ2BAND20,
 ID_TEXT_EQ2BAND21,
 ID_TEXT_EQ2BAND22,
 ID_TEXT_EQ2BAND23,
 ID_TEXT_EQ2BAND24,
 ID_TEXT_EQ2BAND25,
 ID_TEXT_EQ2BAND26,
 ID_TEXT_EQ2BAND27,
 ID_TEXT_EQ2BAND28,
 ID_TEXT_EQ2BAND29,
 ID_TEXT_EQ2BAND30,
 ID_TEXT_EQ0,
 ID_TEXT_EQ1,
 ID_TEXT_EQ2,
 ID_TEXT_EQ3,
 ID_TEXT_EQ4,
 ID_TEXT_EQ5,
 ID_TEXT_EQ6,
 ID_TEXT_EQ7,
 ID_TEXT_EQ8,
 ID_TEXT_EQ9,
 ID_TEXT_EQ10,
 ID_TEXT_EQ11,
 ID_TEXT_EQ12,
 ID_TEXT_EQ13,
 ID_TEXT_EQ14,
 ID_TEXT_EQ15,
 ID_TEXT_EQ16,
 ID_TEXT_EQ17,
 ID_TEXT_EQ18,
 ID_TEXT_EQ19,
 ID_TEXT_EQ20,
 ID_TEXT_EQ21,
 ID_TEXT_EQ22,
 ID_TEXT_EQ23,
 ID_TEXT_EQ24,
 ID_TEXT_EQ25,
 ID_TEXT_EQ26,
 ID_TEXT_EQ27,
 ID_TEXT_EQ28,
 ID_TEXT_EQ29,
 ID_TEXT_EQ30,
 ID_TEXT_EQ2_0,
 ID_TEXT_EQ2_1,
 ID_TEXT_EQ2_2,
 ID_TEXT_EQ2_3,
 ID_TEXT_EQ2_4,
 ID_TEXT_EQ2_5,
 ID_TEXT_EQ2_6,
 ID_TEXT_EQ2_7,
 ID_TEXT_EQ2_8,
 ID_TEXT_EQ2_9,
 ID_TEXT_EQ2_10,
 ID_TEXT_EQ2_11,
 ID_TEXT_EQ2_12,
 ID_TEXT_EQ2_13,
 ID_TEXT_EQ2_14,
 ID_TEXT_EQ2_15,
 ID_TEXT_EQ2_16,
 ID_TEXT_EQ2_17,
 ID_TEXT_EQ2_18,
 ID_TEXT_EQ2_19,
 ID_TEXT_EQ2_20,
 ID_TEXT_EQ2_21,
 ID_TEXT_EQ2_22,
 ID_TEXT_EQ2_23,
 ID_TEXT_EQ2_24,
 ID_TEXT_EQ2_25,
 ID_TEXT_EQ2_26,
 ID_TEXT_EQ2_27,
 ID_TEXT_EQ2_28,
 ID_TEXT_EQ2_29,
 ID_TEXT_EQ2_30,
 ID_TEXT_KEYEFECTS, // ID_TEXT_KEYEFFECTS_FIRST
 ID_TEXT_KEYPITCHSET,
 ID_TEXT_KEYPITCHUP,
 ID_TEXT_KEYPITCHDOWN,
 ID_TEXT_KEYPITCH2UP,
 ID_TEXT_KEYPITCH2DOWN,
 ID_TEXT_KEYPITCHRESET,
 ID_TEXT_KEYTEMPOSET,
 ID_TEXT_KEYTEMPOUP,
 ID_TEXT_KEYTEMPODOWN,
 ID_TEXT_KEYTEMPORESET,
 ID_TEXT_KEYSPEEDSET,
 ID_TEXT_KEYSPEEDUP,
 ID_TEXT_KEYSPEEDDOWN,
 ID_TEXT_KEYSPEEDRESET,
 ID_TEXT_FILEOUTDIR,
 ID_TEXT_VIEWERFOUND,
 ID_TEXT_PROMPTNUM // ID_TEXT_LAST
};

#define ID_SLIDER_EQ2_FIRST ID_SLIDER_EQ2_0
#define ID_SLIDER_EQ2_LAST ID_SLIDER_EQ2_30

#define ID_SPIN_FIRST ID_SPIN_BEG
#define ID_SPIN_LAST ID_SPIN_SPEED

#define ID_BUTTON_FIRST ID_BTN_PREVIOUS
#define ID_BUTTON_LAST ID_BTN_PROMPTNUMOK

#define ID_POPUP_FIRST ID_POPUP_OUTPUT
#if !defined(MANOCDA) && defined(__MAUNIX__)
 #define ID_POPUP_LAST ID_POPUP_AUDIOCD
#else
 #define ID_POPUP_LAST ID_POPUP_EQPRESET
#endif

#define ID_CHECKBOX_FIRST ID_CHK_ADDMODE
#define ID_CHECKBOX_LAST ID_CHK_SHOWPATH

#define ID_SLIDER_FIRST ID_SLIDER_VOLUMEL
#define ID_SLIDER_LAST ID_SLIDER_SPEED

#define ID_SLIDER_EQ_FIRST ID_SLIDER_EQ0
#define ID_SLIDER_EQ_LAST ID_SLIDER_EQ30

#define ID_TEXT_KEYEFFECTS_FIRST ID_TEXT_KEYEFECTS
#define ID_TEXT_KEYEFFECTS_LAST ID_TEXT_KEYSPEEDRESET

#define ID_TEXT_BUTTON_FIRST ID_TEXT_BUTTON_QUIT
#define ID_TEXT_BUTTON_LAST ID_TEXT_BUTTON_NEXT

#define ID_TEXT_LAST ID_TEXT_PROMPTNUM

// menu items
#define ID_MENU_FIRST ID_MENU_ABOUT
#define ID_MENU_LAST ID_MENU_README
enum
{
	// MoreAmp menu
	ID_MENU_ABOUT = 1, // ID_MENU_FIRST
	// File menu
	ID_MENU_OPENLIST,
	ID_MENU_MAKELIST,
	ID_MENU_SAVELISTAS,
	ID_MENU_DELETELIST,
	ID_MENU_PLAYFILE,
	ID_MENU_OPENRECENT,
	ID_SUBMENU_OPENRECENT1,
	ID_SUBMENU_OPENRECENT2,
	ID_SUBMENU_OPENRECENT3,
	ID_SUBMENU_OPENRECENT4,
	ID_SUBMENU_OPENRECENT5,
	ID_SUBMENU_OPENRECENT6,
	ID_SUBMENU_OPENRECENT7,
	ID_SUBMENU_OPENRECENT8,
	ID_SUBMENU_OPENRECENT9,
	ID_SUBMENU_OPENRECENT10, // exactly MAXOPENRECENT submenus
	ID_MENU_QUIT,
	// Controls menu
	ID_MENU_STOP,
	ID_MENU_PAUSE,
	ID_MENU_PREVIOUS,
	ID_MENU_PLAY,
	ID_MENU_NEXT,
	ID_MENU_PLAYCD,
	ID_MENU_EJECTCD,
	ID_MENU_AUDIOIN,
	// Settings menu
	ID_MENU_SAVEMASETS,
	ID_MENU_SETSAVED,
	ID_MENU_SETDEFAULT,
	ID_MENU_SETFACTORY,
	ID_MENU_SETCOPY,
	ID_MENU_SAVEMASETSDEFAULT,
#if (!defined(MANOCDA) && defined(__MAUNIX__))
	ID_MENU_SETAUDIOCD,
#endif
	ID_MENU_EFFECTS,
	ID_MENU_RANDOM,
	ID_MENU_REPTPLAYED,
	ID_MENU_LOOPLOADED,
	ID_MENU_LOOPLIST,
	ID_MENU_EQUALIZER,
	ID_MENU_EQ31BANDS,
	ID_MENU_EQEXTRA,
	ID_MENU_MONO,
	ID_MENU_INVERTRIGHT,
	ID_MENU_SINGLEPLAY,
	ID_MENU_HIPRIORITY,
	ID_MENU_TITLEINFO,
	ID_SUBMENU_TITLEINFO1,
	ID_SUBMENU_TITLEINFO2,
	ID_SUBMENU_TITLEINFO3,
	ID_MENU_AUTOSTART,
	ID_MENU_ERRLOGGING,
	ID_MENU_SETVDISK,
#if defined(MAINSTANCES)
	ID_MENU_MULTIPLEINST,
#endif
#if defined(MAKEYBOARD)
	ID_MENU_KEYBOARD,
#endif
#if defined(MAMOUSEWHEEL)
	ID_MENU_MOUSEWHEEL,
#endif
	ID_MENU_ADVANCED,
	// Tools menu
	ID_MENU_ZEROLIST,
	ID_MENU_MAKECATALOG,
	ID_MENU_VIEWCATALOG,
	ID_MENU_VIEWLOG,
	ID_MENU_CLEARLOG,
#if defined(MAKEYBOARD)
	ID_MENU_EDITKEYBINDINGS,
	ID_MENU_BLANKKEYBINDINGS,
#endif
	// Show menu
	ID_MENU_SHOWLIST,
	ID_MENU_SHOWEQ,
	ID_MENU_SHOWEFFECTS,
	ID_MENU_SHOWFILEOUT,
	ID_MENU_ALTSIZE,
	ID_MENU_SAVEDSIZE,
	ID_MENU_DEFAULTSIZE,
	ID_MENU_FACTORYSIZE,
	// Help menu
	ID_MENU_README, // ID_MENU_LAST

	ID_TIMER_PLAYSONGLIST,
	ID_TIMER_RUN,
	ID_TIMER_PLAY,
	ID_TIMER_STOP,
#if defined(MAKEYBOARD)
	ID_TIMER_KBFOCUS
#endif
};
#endif // __MADEFS_H__

//eof
