// maWriteOgg.c

/*
 * MoreAmp
 * Copyright (C) 2004-2010 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "maConfig.h" // included by all moreamp files

#ifdef __MAWIN__
 #ifdef MAUNUSEDWIN
  #pragma warning( disable : 4100 ) // unreferenced formal parameter
 #endif
 #pragma warning( disable : 4206 ) // nonstandard extension used : translation unit is empty
 #pragma warning( disable : 4305 ) // truncation from 'const double ' to 'float '
 #pragma warning( disable : 4514 ) // mad_f_mul_inline : unreferenced inline function has been removed
 #pragma warning( disable : 4706 ) // assignment within conditional expression
#endif

#ifdef ENCODEOGG

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include <math.h>

#ifdef __MAOSX__
 #include <unistd.h>
 #include <sys/stat.h>
#endif

#ifdef __MAUNIX__
 #include <unistd.h>
 #include <sys/stat.h>
 #include <sys/types.h>
#endif

#include "maDefs.h"
#include "maWriteOgg.h"
#include "maPlayer.h"
#include "maUtils.h"

#ifdef __MAWIN__
 #include "../libs/libvorbis/include/vorbis/vorbisenc.h"
#else
 #include "vorbis/vorbisenc.h"
#endif

vorbis_dsp_state l_vd; // central working state for the packet->PCM decoder
vorbis_block     l_vb; // local working space for packet->PCM decode
ogg_packet       l_op; // one raw packet of data for decode
ogg_stream_state l_os; // take physical pages, weld into a logical stream of packets
vorbis_info      l_vi; // struct that stores all the static vorbis bitstream settings
ogg_page         l_og; // one Ogg bitstream page.  Vorbis packets are inside
vorbis_comment   l_vc; // struct that stores all the user comments
int g_eos = 1;
float **l_buffer;
long l_channels;

/* MPEG modes from lame.h */
/*
typedef enum MPEG_mode_e {
  STEREO = 0,
  JOINT_STEREO,
  DUAL_CHANNEL,
  MONO,
  NOT_SET,
  MAX_INDICATOR
} MPEG_mode;
*/

int OpenWriteOgg()
{
	// MPEG_mode mode;
	int brate;
	int brate2;
	// float quality;
	int i;
	int ret;
	ogg_packet header;
	ogg_packet header_comm;
	ogg_packet header_code;
	char cstr[256];
	
	switch(g_sets.fileout[g_k[kOUTOGG]].mode)
	{
		case 0 : l_channels = 2; break; // STEREO
		/*
		case 1 : mode = JOINT_STEREO; break;
		case 2 : mode = DUAL_CHANNEL; break;
		case 3 : mode = MONO; break;
		default : mode = STEREO; break;
		*/
		default : l_channels = 1; break;
	}
	
	switch(g_sets.fileout[g_k[kOUTOGG]].bitrate)
	{
		case 0 : brate = 32000; break;
		case 1 : brate = 40000; break;
		case 2 : brate = 48000; break;
		case 3 : brate = 56000; break;
		case 4 : brate = 64000; break;
		case 5 : brate = 80000; break;
		case 6 : brate = 96000; break;
		case 7 : brate = 112000; break;
		case 9 : brate = 160000; break;
		case 10 : brate = 192000; break;
		case 11 : brate = 224000; break;
		case 12 : brate = 256000; break;
		case 13 : brate = 320000; break;
		default : brate = 128000; break;
	}
	
	/* switch(g_sets.fileout[g_k[kOUTOGG]].quality) // not used
	{
		case 0 : quality = 1.0; break; // hi
		case 1 : quality = .9; break;
		case 2 : quality = .8; break;
		case 3 : quality = .7; break;
		case 4 : quality = .6; break;
		case 6 : quality = .4; break;
		case 7 : quality = .3; break;
		case 8 : quality = .2; break;
		case 9 : quality = .1; break;
		case 10 : quality = 0; break; // lo, -.1 would be lowest
		default : quality = .5; break;
	}
	*/
	
	// Encode setup
	vorbis_info_init(&l_vi);

	/*
   ---------------------------------------------------------------------

	Encoding using a VBR quality mode.  The usable range is -.1
	(lowest quality, smallest file) to 1. (highest quality, largest file).
	Example quality mode .4: 44kHz stereo coupled, roughly 128kbps VBR 
  
	ret = vorbis_encode_init_vbr(&l_vi, 2, 44100, .4);

   ---------------------------------------------------------------------

   Encoding using an average bitrate mode (ABR).
   example: 44kHz stereo coupled, average 128kbps VBR 
  
   ret = vorbis_encode_init(&l_vi, 2, 44100, -1, 128000, -1);

   ---------------------------------------------------------------------

   Encode using a qulity mode, but select that quality mode by asking for
   an approximate bitrate.  This is not ABR, it is true VBR, but selected
   using the bitrate interface, and then turning bitrate management off:

   ret = ( vorbis_encode_setup_managed(&l_vi, 2, 44100, -1, 128000, -1) ||
           vorbis_encode_ctl(&l_vi, OV_ECTL_RATEMANAGE_AVG, NULL) ||
           vorbis_encode_setup_init(&l_vi));

   ---------------------------------------------------------------------
   */

	//ret = vorbis_encode_init_vbr(&l_vi, 2, samplerate, quality);
	//ret = vorbis_encode_init(&l_vi, 2, samplerate, -1 , brate, -1);
	/*
	ret = ( vorbis_encode_setup_managed(&l_vi, 2, g_state.insamplerate, -1, brate, -1) ||
           vorbis_encode_ctl(&l_vi, OV_ECTL_RATEMANAGE_AVG, NULL) ||
           vorbis_encode_setup_init(&l_vi));
	*/

	/* do not continue if setup failed; this can happen if we ask for a
	mode that libVorbis does not support (eg, too low a bitrate, etc,
	will return 'OV_EIMPL')
	*/

	ret = vorbis_encode_setup_managed(&l_vi, l_channels, g_state.insamplerate, -1, brate, -1);
	if(ret == OV_EIMPL) // adjust brate down and try again
  	{
		brate2 = brate;
		i = 64; // arbitrary
		while(ret && i-- > 0)
		{
			switch(brate2)
			{
				case  40000 : brate2 =  32000; break;
				case  48000 : brate2 =  40000; break;
				case  56000 : brate2 =  48000; break;
				case  64000 : brate2 =  56000; break;
				case  80000 : brate2 =  64000; break;
				case  96000 : brate2 =  80000; break;
				case 112000 : brate2 =  96000; break;
				case 128000 : brate2 = 112000; break;
				case 160000 : brate2 = 128000; break;
				case 192000 : brate2 = 160000; break;
				case 224000 : brate2 = 192000; break;
				case 256000 : brate2 = 224000; break;
				case 320000 : brate2 = 256000; break;
				default		: brate2 =      0; break;
			}
			if(brate2 == 0)
				break;
			ret = vorbis_encode_setup_managed(&l_vi, l_channels, g_state.insamplerate, -1, brate2, -1);
		}

		if(!ret)
		{
			sprintf(cstr, "OpenWriteOgg nominal bitrate set to %d instead of %d '%s'", brate2, brate, g_outputfile);
			maLog(cstr);
		}
	}

	if(ret)
 	{
		sprintf(cstr, "OpenWriteOgg vorbis_encode_setup_managed error=%d '%s'", ret, g_outputfile);
		maLog(cstr);
		return 1;
	}

	ret = vorbis_encode_ctl(&l_vi, OV_ECTL_RATEMANAGE_AVG, NULL);
	if(ret)
  	{
		sprintf(cstr, "OpenWriteOgg vorbis_encode_ctl error=%d '%s'", ret, g_outputfile);
		maLog(cstr);
		return 1;
	}

	ret = vorbis_encode_setup_init(&l_vi);
	if(ret)
  	{
		sprintf(cstr, "OpenWriteOgg vorbis_encode_setup_init error=%d '%s'", ret, g_outputfile);
		maLog(cstr);
		return 1;
	}

	// add a comment
	vorbis_comment_init(&l_vc);
#if defined(USE_LIBVORBIS_SYSTEM)
	sprintf(cstr, "%s %s", MOREAMP_NAME, MOREAMP_VERSION_STRING); // we don't know installed version
#else
	sprintf(cstr, "%s %s / libOgg-%s libVorbis-%s", MOREAMP_NAME, MOREAMP_VERSION_STRING, "1.2.0", "1.3.1"); // version in libs dir
#endif
	vorbis_comment_add_tag(&l_vc, (char *)"ENCODER", cstr);

	// set up the analysis state and auxiliary encoding storage
	vorbis_analysis_init(&l_vd, &l_vi);
	vorbis_block_init(&l_vd, &l_vb);
  
	// set up our packet->stream encoder
	// pick a random serial number; that way we can more likely build
	// chained streams just by concatenation
	// already done in OnInit_		srand(time(NULL));
	ogg_stream_init(&l_os, rand());

	/*
	Vorbis streams begin with three headers; the initial header (with
	most of the codec setup parameters) which is mandated by the Ogg
	bitstream spec.  The second header holds any comment fields.  The
	third header holds the bitstream codebook.  We merely need to
	make the headers, then pass them to libvorbis one at a time;
	libvorbis handles the additional Ogg bitstream constraints
	*/

	vorbis_analysis_headerout(&l_vd, &l_vc, &header, &header_comm, &header_code);
	ogg_stream_packetin(&l_os, &header); // automatically placed in its own page
	ogg_stream_packetin(&l_os, &header_comm);
	ogg_stream_packetin(&l_os, &header_code);

	g_eos = 0;

	// this ensures the actual audio data will start on a new page, as per spec
	while(!g_eos)
	{
		int result = ogg_stream_flush(&l_os, &l_og);
		if(result == 0)
			break;
		fwrite(l_og.header, 1, l_og.header_len, g_outputfilefp);
		fwrite(l_og.body, 1, l_og.body_len, g_outputfilefp);
	}
 
	return 0;

} // OpenWriteOgg


// from libvorbis encoder_example.c (better stuff in vorbis-tools/encode.c) :
int WriteOgg(void* pcmblock, unsigned long frames, unsigned long len)
{
#ifdef MAUNUSED
 (void)frames;
#endif
	
	int bytes;
	int i;	
	char cstr[256];
	signed char *readbuffer = (signed char *)pcmblock; // out of the data segment, not the stack

	bytes = len;
		
	if(bytes < 4)
	{
		sprintf(cstr, "WriteOgg 0 bytes");
		maLog(cstr);
		return 1;
	}
	
	// expose the buffer to submit data
	l_buffer = vorbis_analysis_buffer(&l_vd, bytes / 4);
	
	// uninterleave samples // actually, just short to float 
	if(l_channels == 1)
	{
		for(i = 0; i < bytes / 4; i++)
		{
#ifndef WORDS_BIGENDIAN // pc
			l_buffer[0][i] = ( ((readbuffer[i * 4 + 1] << 8) | (0x00ff & (int)readbuffer[ i * 4    ])) +
							 ((readbuffer[i * 4 + 3] << 8) | (0x00ff & (int)readbuffer[ i * 4 + 2])) ) / 65536.f;
#else
			l_buffer[0][i] = ( ((readbuffer[i * 4    ] << 8) | (0x00ff & (int)readbuffer[ i * 4 + 1])) +
							 ((readbuffer[i * 4 + 2] << 8) | (0x00ff & (int)readbuffer[ i * 4 + 3])) ) / 65536.f;
#endif
		}
	}
	else
	{
		for(i = 0; i < bytes / 4; i++)
		{
#ifndef WORDS_BIGENDIAN
			l_buffer[0][i] = ((readbuffer[i * 4 + 1] << 8) | (0x00ff & (int)readbuffer[ i * 4    ])) / 32768.f;
			l_buffer[1][i] = ((readbuffer[i * 4 + 3] << 8) | (0x00ff & (int)readbuffer[ i * 4 + 2])) / 32768.f;
#else
			l_buffer[0][i] = ((readbuffer[i * 4    ] << 8) | (0x00ff & (int)readbuffer[ i * 4 + 1])) / 32768.f;
			l_buffer[1][i] = ((readbuffer[i * 4 + 2] << 8) | (0x00ff & (int)readbuffer[ i * 4 + 3])) / 32768.f;
#endif
		}
	}
	
	// tell the library how much we actually submitted
	vorbis_analysis_wrote(&l_vd, i);

    /*
	vorbis does some data preanalysis, then divvies up blocks for
	more involved (potentially parallel) processing.  Get a single
	block for encoding now
	*/
    while(vorbis_analysis_blockout(&l_vd, &l_vb) == 1)
	{

		// analysis, assume we want to use bitrate management
		vorbis_analysis(&l_vb, NULL);
		vorbis_bitrate_addblock(&l_vb);

		while(vorbis_bitrate_flushpacket(&l_vd, &l_op))
		{
			// weld the packet into the bitstream
			ogg_stream_packetin(&l_os, &l_op);
	
			// write out pages (if any)
			while(!g_eos)
			{
				int result = ogg_stream_pageout(&l_os, &l_og);
				if(result == 0)
					break;
				fwrite(l_og.header, 1, l_og.header_len, g_outputfilefp);
				fwrite(l_og.body, 1, l_og.body_len, g_outputfilefp);
	  
				/*
				this could be set above, but for illustrative purposes, I do
				it here (to show that vorbis does know where the stream ends)
				*/
				if(ogg_page_eos(&l_og))
					g_eos = 1;					
			}
		}
	}

	return 0;

} // WriteOgg


int CloseWriteOgg()
{
	// same as above when eof (bytes read == 0) :

	/*
	end of file.  this can be done implicitly in the mainline,
	but it's easier to see here in non-clever fashion.
	Tell the library we're at end of stream so that it can handle
	the last frame and mark end of stream in the output properly
	*/
	vorbis_analysis_wrote(&l_vd, 0);

    /*
	vorbis does some data preanalysis, then divvies up blocks for
	more involved (potentially parallel) processing.  Get a single
	block for encoding now
	*/
    while(vorbis_analysis_blockout(&l_vd,&l_vb) == 1)
	{
		// analysis, assume we want to use bitrate management
		vorbis_analysis(&l_vb, NULL);
		vorbis_bitrate_addblock(&l_vb);

		while(vorbis_bitrate_flushpacket(&l_vd,&l_op))
		{
			// weld the packet into the bitstream
			ogg_stream_packetin(&l_os, &l_op);
	
			/* write out pages (if any) */
			while(!g_eos)
			{
				int result = ogg_stream_pageout(&l_os, &l_og);
				if(result == 0)
					break;
				fwrite(l_og.header, 1, l_og.header_len, g_outputfilefp);
				fwrite(l_og.body, 1, l_og.body_len, g_outputfilefp);
	  
				// this could be set above, but for illustrative purposes, I do
				// it here (to show that vorbis does know where the stream ends)
				if(ogg_page_eos(&l_og))
					g_eos = 1;
			}
		}
	}
	
	// clean up and exit.  vorbis_info_clear() must be called last
	ogg_stream_clear(&l_os);
	vorbis_block_clear(&l_vb);
	vorbis_dsp_clear(&l_vd);
	vorbis_comment_clear(&l_vc);
	vorbis_info_clear(&l_vi);
	
	return 0;
	
} // CloseWriteOgg

#ifdef __cplusplus
}
#endif

#endif

// eof
