// maGUIwx.cpp

/*
 * MoreAmp
 * Copyright (C) 2004-2010 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
#include "maConfig.h" // included by all moreamp files

#ifdef __MAWIN__
 #ifdef MAUNUSEDWIN
  #pragma warning( disable : 4100 ) // unreferenced formal parameter
 #endif
 #pragma warning( disable : 4706 ) // assignment within conditional expression
 #pragma warning( disable : 4127 ) // conditional expression is constant
#endif

// The MAGUINONE section of this file (below) contains the code
// to run without a gui and stubs for gui functions.

// File maGUIOSX.cpp contains the code to run with the native osx (Interface Builder) gui.

#ifdef MAGUIWX

// #define MATRACEGUIWX

// This MAGUIWX section, and file maControls.cpp,
// contain the GUI (wxWidget) dependent code.

// Platform:	gui:	defined:
// Mac OS X		WXMAC   MAGUIWX __WXMAC__
// Mac OS X		WXGTK   MAGUIWX __WXGTK__
// Mac OS X		WXX11   MAGUIWX __WXX11__
// Win32		WXMSW   MAGUIWX __WXMSW__
// unix/linux   WXGTK   MAGUIWX __WXGTK__
// unix/linux   WXX11   MAGUIWX __WXX11__

// to build moreamp on osx or unix/linux with multiple wxWidgets installations
// you can select which wx include and wx lib dirs to use with commands like :

// sudo ln -sfv /usr/local/include/wx-2.6/wx/wxGTK-2.6.3 /usr/local/include/wx-2.6/wx
// sudo ln -sfv /usr/local/lib/wx/config/mac-ansi-release-static-2.6 /usr/local/bin/wx-config
// sudo ln -sfv /usr/local/lib/wx/config/x11univ-ansi-release-static-2.6 /usr/local/bin/wx-config
// sudo ln -sfv /usr/local/lib/wx/config/gtk-ansi-release-static-2.6 /usr/local/bin/wx-config
// sudo ln -sfv /usr/local/lib/wx/config/gtk2-ansi-release-static-2.6 /usr/local/bin/wx-config

// sudo ln -sfv /usr/local/include/wx-2.8/wx/wxGTK-2.8.6 /usr/local/include/wx-2.8/wx
// sudo ln -sfv /usr/local/lib/wx/config/mac-ansi-release-static-2.8 /usr/local/bin/wx-config
// sudo ln -sfv /usr/local/lib/wx/config/gtk-ansi-release-static-2.8 /usr/local/bin/wx-config
// sudo ln -sfv /usr/local/lib/wx/config/gtk2-ansi-release-static-2.8 /usr/local/bin/wx-config

// For more info, run `wx-config --help`

#include <string.h>
#include <errno.h>
#include <stdio.h>

#ifdef __MAOSX__
 #include <unistd.h>
 #include <sys/stat.h>
#endif

#ifdef __MAUNIX__
 #include <unistd.h>
 #include <stdlib.h>
 #include <sys/stat.h>
 #include "wx/wx.h"
#else
 #include "wx/wxprec.h"
 #ifndef WX_PRECOMP
  #include "wx/wx.h"
 #endif
#endif

#if defined(__MAOSX__) && defined(__WXMAC__) && (MAGUIWX >= 8) // wx-2.8+
 #include "wx/sysopt.h" // wxSystemOptions::SetOption
#endif

#if defined(__MAOSX__) && defined(__WXMAC__)
 #include "MacWindows.h"
#endif

#ifdef __MAWIN__
 #include <SHLOBJ.H>
 #include <SHLWAPI.H>
#endif

#include "wx/image.h"
#include "wx/filename.h"
#include "wx/utils.h" // for wxGetHomeDir
#include "wx/file.h"
#include "wx/dir.h"
#include "wx/colour.h"
#include "wx/event.h"
#include "wx/process.h"
#include "wx/spinbutt.h"
#include "wx/listctrl.h"
#include "wx/settings.h" // for fonts

#define MADRAGANDDROP
#ifdef MADRAGANDDROP
 #if wxUSE_DRAG_AND_DROP
  #include "wx/dnd.h"
 #else
  #warning no wxUSE_DRAG_AND_DROP
  #undef MADRAGANDDROP
 #endif
#endif

#if defined(wxUSE_UNICODE) && (wxUSE_UNICODE != 0)
 #error wxUSE_UNICODE != 0 moreamp does not support unicode
#else

/* changed in wxMac source generic/listctrl.cpp to reduce line spacing in lists :
...
// extra margins around the text label
...
static const int EXTRA_HEIGHT = 0; // 4;  <----
*/

#if !defined(MASETFONT)
 #if defined(MASMALLERFONT)
  #include "wx/font.h"
  extern wxFont g_mafont;
  #define MASETFONT(f) f->SetFont(g_mafont)
 #else
  #define MASETFONT(f)
 #endif
#endif

// Application includes
#include "maDefs.h"
#include "maPlayer.h"
#include "maEqualizer.h"
#include "maEffects.h"
#include "maControls.h"
#include "maGUI.h"
#include "maMemFile.h"
#include "maSongList.h"
#include "maUtils.h"

#ifndef MANOCDA
 #include "maCda.h"
 #include "maPlayCda.h"
#endif

#if defined(__MAOSX__)
 #include "maAudioMac.h"
#endif

#ifdef __MAWIN__
 #include "maAudioWin.h"
#endif

#ifdef __MAUNIX__
 #include "maAudioUnix.h"
#endif

#define XBASE 2
#define YBASE 2
#define MABUTTONW 50
#define MABUTTONH 48
#define MABUTTONSIZE wxSize(MABUTTONW, MABUTTONH)

#if defined(__WXMAC__)
 #define MENUBARH 0		// mac has a menu bar at the top of the screen instead of in each window
#endif

#ifdef __MAWIN__		// MSW has menus in each window
 #define MENUBARH 19
#endif

#if defined(__WXX11__)  // X11 has menus in each window
 #define MENUBARH 19
#endif

#if defined(__WXGTK__)  // GTK has menus in each window
 #define MENUBARH 24
#endif

#if defined(MAUSEMABUTTON)
 #define MABUTTON maButton
#else
 #define MABUTTON wxButton
#endif

#if defined(MAUSEMACHECKBOX)
 #define MACHECKBOX maCheckBox
#else
 #define MACHECKBOX wxCheckBox // have large labels on mac...
#endif

#if defined(MAUSEMASLIDER)
 #define MASLIDER maSlider
#else
 #define MASLIDER wxSlider // vertical sliders are upside down...
#endif

// wx versions and platforms don't all behave the same
#if defined(MAKEYBOARD)
 #ifdef __cplusplus
  extern "C"
  {
 #endif
 void maTrace(char *str);
 #ifdef __cplusplus
  }
 #endif

 #if defined(USE_WXGTK2)
  #define MANOWXPANEL // panels eat char events on wxGTK2 ?
 #endif
#endif // MAKEYBOARD

#if defined(MANOWXPANEL)
 #define MPANEL this
#else
 #define MPANEL m_panel
#endif

void *l_theMenu[MENULAST];
#if defined(__MAWIN__) && defined(MAMOUSEWHEEL)
	MACHECKBOX *l_ChkAltSize;
#endif

class MyViewerTextCtrl;
class MyTextCtrl;
class MyKbTextCtrl;

class MyApp : public wxApp
{
public:
	bool OnInit();
#if defined(MAKEYBOARD)
	void maOnChar(wxKeyEvent& event);
	void maOnClick(wxMouseEvent &event);
#endif
#if defined(MAMOUSEWHEEL)
	void OnMouseWheel(wxMouseEvent &event);
#endif
};

DECLARE_APP(MyApp)


class MyFrame : public wxFrame
{	
public:
	MyFrame(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);

	virtual ~MyFrame();

	void OnGUICheckAltSize(wxCommandEvent& event);
	void OnGUICheckRandom(wxCommandEvent& event);
	void OnGUICheckReptPlayed(wxCommandEvent& event);
	void OnGUICheckLoopLoaded(wxCommandEvent& event);
	void OnGUICheckLoopList(wxCommandEvent& event);
	void OnGUICheckEqWindow(wxCommandEvent& event);
	void OnGUICheckListWindow(wxCommandEvent& event);
	void OnGUICheckBoxBeg(wxCommandEvent& event);
	void OnGUICheckBoxEnd(wxCommandEvent& event);
	void OnGUICheckMonoLeft(wxCommandEvent& event);
	void OnGUICheckMonoRight(wxCommandEvent& event);
	void OnGUICheckUseM3u(wxCommandEvent& event);
	void OnGUICheckSinglePlay(wxCommandEvent& event);
	void OnGUICheckEqualizer(wxCommandEvent& event);
	void OnGUICheckEffects(wxCommandEvent& event);
	void OnGUICheckLimiter(wxCommandEvent& event);
	void OnGUICheckEqExtra(wxCommandEvent& event);
	void OnGUICheckTitleInfo(wxCommandEvent& event);
	void OnGUICheckInvertRight(wxCommandEvent& event);
	void OnGUICheckEq31Bands(wxCommandEvent& event);
	void OnGUICheckReptSong(wxCommandEvent& event);
	void OnGUICheckMonoDiff(wxCommandEvent& event);
	void OnGUICheckBalance(wxCommandEvent& event);

	void OnGUIButtonQuit(wxCommandEvent& event);
	void OnGUIButtonStop(wxCommandEvent& event);
	void OnGUIButtonPrevious(wxCommandEvent& event);
	void OnGUIButtonPlay(wxCommandEvent& event);
	void OnGUIButtonPause(wxCommandEvent& event);
	void OnGUIButtonNext(wxCommandEvent& event);
	void OnGUIButtonCatalog(wxCommandEvent& event);
	
	void OnGUISliderVolumeL(wxCommandEvent& event);
	void OnGUISliderVolumeR(wxCommandEvent& event);
	void OnGUISliderSeparation(wxCommandEvent& event);
	void OnGUISliderPreamp(wxCommandEvent& event);
	void OnGUISliderPos(wxCommandEvent& event);
	
	void OnGUIPopupOutput(wxCommandEvent& event);
	void OnGUIPopupBuffer(wxCommandEvent& event);
	void OnGUISpinUpMem(wxSpinEvent& event);
	void OnGUISpinUpPreamp(wxSpinEvent& event);
	void OnGUISpinUpSep(wxSpinEvent& event);
	void OnGUISpinUpVolR(wxSpinEvent& event);
	void OnGUISpinUpVolL(wxSpinEvent& event);
	void OnGUISpinUpBeg(wxSpinEvent& event);
	void OnGUISpinUpEnd(wxSpinEvent& event);

	void OnGUISpinDownBuffer(wxSpinEvent& event);
	void OnGUISpinDownPreamp(wxSpinEvent& event);
	void OnGUISpinDownSep(wxSpinEvent& event);
	void OnGUISpinDownVolR(wxSpinEvent& event);
	void OnGUISpinDownVolL(wxSpinEvent& event);
	void OnGUISpinDownBeg(wxSpinEvent& event);
	void OnGUISpinDownEnd(wxSpinEvent& event);

	void MakeButtons();
	
#if defined(MAUSEMABUTTON)
	MABUTTON *MakeButton(char const **foreground,
						char const **disabled,
						char const **foremask, int id, bool processdownevents);
#else
	MABUTTON *MakeButton(int id, char *label);
#endif
		
	void MakeMenus();
	void MakeSubMenusRecent();
	void OnAbout(wxCommandEvent& event);
	void OnGUIMenuQuit(wxCommandEvent& event);
	void OnGUIMenuOpenList(wxCommandEvent& event);
	void OnGUIMenuMakeList(wxCommandEvent& event);
	void OnGUIMenuSaveListAs(wxCommandEvent& event);
	void OnGUIMenuDeleteList(wxCommandEvent& event);
	void OnGUIMenuPlayFile(wxCommandEvent& event);
	void OnGUIMenuOpenRecent(wxCommandEvent& event);
	void OnGUIMenuSetVDisk(wxCommandEvent& event);
#if defined(MAINSTANCES)
	void OnGUIMenuMultipleInst(wxCommandEvent& event);
#endif
#if defined(MAKEYBOARD)
	void OnGUIMenuKeyboard(wxCommandEvent& event);
	void OnGUIMenuEditKeyBindings(wxCommandEvent& event);
	void OnGUIMenuBlankKeyBindings(wxCommandEvent& event);
#endif
#if defined(MAMOUSEWHEEL)
	void OnGUIMenuMouseWheel(wxCommandEvent& event);
#endif
	void OnGUIMenuAdvanced(wxCommandEvent& event);
#if !defined(MANOCDA) && defined(__MAUNIX__)
	void OnGUIMenuSetAudioCD(wxCommandEvent& event);
#endif
	void OnGUIMenuSetFactory(wxCommandEvent& event);
	void OnGUIMenuSetDefault(wxCommandEvent& event);
	void OnGUIMenuSetSaved(wxCommandEvent& event);
	void OnGUIMenuSetCopy(wxCommandEvent& event);
	void OnGUIMenuStop(wxCommandEvent& event);
	void OnGUIMenuPause(wxCommandEvent& event);
	void OnGUIMenuPrevious(wxCommandEvent& event);
	void OnGUIMenuPlay(wxCommandEvent& event);
	void OnGUIMenuNext(wxCommandEvent& event);
	void OnGUIMenuPlayCD(wxCommandEvent& event);
	void OnGUIMenuTitleInfo(wxCommandEvent& event);
	void OnGUIMenuRandom(wxCommandEvent& event);
	void OnGUIMenuReptPlayed(wxCommandEvent& event);
	void OnGUIMenuLoopLoaded(wxCommandEvent& event);
	void OnGUIMenuLoopList(wxCommandEvent& event);
	void OnGUIMenuAutoStart(wxCommandEvent& event);
	void OnGUIMenuErrLogging(wxCommandEvent& event);
	void OnGUIMenuSinglePlay(wxCommandEvent& event);
	void OnGUIMenuHiPriority(wxCommandEvent& event);
	void OnGUIMenuEqualizer(wxCommandEvent& event);
	void OnGUIMenuEffects(wxCommandEvent& event);
	void OnGUIMenuEqExtra(wxCommandEvent& event);
	void OnGUIMenuMono(wxCommandEvent& event);
	void OnGUIMenuInvertRight(wxCommandEvent& event);
	void OnGUIMenuEq31Bands(wxCommandEvent& event);
	void OnGUIMenuSetPlayer(wxCommandEvent& event);
	void OnGUIMenuSaveSettings(wxCommandEvent& event);
	void OnGUIMenuSaveSettingsDefault(wxCommandEvent& event);
	void OnGUIMenuZeroList(wxCommandEvent& event);
	void OnGUIMenuEjectCD(wxCommandEvent& event);
	void OnGUIMenuAudioIn(wxCommandEvent& event);
	void OnGUIMenuMakeCatalog(wxCommandEvent& event);
	void OnGUIMenuReadme(wxCommandEvent& event);
	void OnGUIMenuViewCatalog(wxCommandEvent& event);
	void OnGUIMenuViewLog(wxCommandEvent& event);
	void OnGUIMenuClearLog(wxCommandEvent& event);
	void OnGUIMenuShowList(wxCommandEvent& event);
	void OnGUIMenuShowEq(wxCommandEvent& event);
	void OnGUIMenuShowEffects(wxCommandEvent& event);
	void OnGUIMenuShowFileOut(wxCommandEvent& event);
	void OnGUIMenuAltSize(wxCommandEvent& event);
	void OnGUIMenuFactorySize(wxCommandEvent& event);
	void OnGUIMenuSavedSize(wxCommandEvent& event);
	void OnGUIMenuDefaultSize(wxCommandEvent& event);

	void OnCloseWindow(wxCloseEvent &event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);

	//void DoAsyncExec(char *cmd);
	
	wxTimer *m_timerplaysonglist;
	void OnTimerPlaySonglist(wxTimerEvent& event);

	void OnTimerRunLoop(wxTimerEvent& event);
	wxTimer *m_timerrunloop;

	void OnTimerPlay(wxTimerEvent& event);
	wxTimer *m_timerplay;

	void OnTimerStop(wxTimerEvent& event);
	wxTimer *m_timerstop;

#if !defined(MANOWXPANEL)
	wxPanel *m_panel;
#endif
	
	MASLIDER *m_sliderPos;
	wxComboBox *m_ComboOutput;
	wxComboBox *m_ComboBuffer;
	wxBoxSizer *m_sizerFrame;
	wxBoxSizer *m_sizerTop;

	wxImage *m_upPattern;
	wxImage *m_downPattern;
	wxImage *m_hilitePattern;

	int m_ButtonPos;
	int m_buttonTop;

	DECLARE_EVENT_TABLE()
	
}; // class MyFrame


class MyFrameList : public wxFrame
{
public:
	MyFrameList(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);

	virtual ~MyFrameList();

	void OnGUIButtonLoaded(wxCommandEvent& event);
	void OnGUIButtonList(wxCommandEvent& event);
	void OnGUIButtonInfo(wxCommandEvent& event);
	void OnGUIButtonSong(wxCommandEvent& event);
	void OnSize(wxSizeEvent& event);
	void OnGUICheckShowIndex(wxCommandEvent& event);	
	void OnGUICheckShowDir(wxCommandEvent& event);	
	void OnGUICheckShowPath(wxCommandEvent& event);
	void OnGUICheckAddMode(wxCommandEvent& event);
	void OnGUIListSelected(wxListEvent& event);	
	void OnGUIListActivated(wxListEvent& event);
	void GetColumn0Width();
	void OnGUIColumnEndDrag(wxListEvent& event);
	void SetColumn0Width(int width);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);
	void OnCloseWindow(wxCloseEvent &event);
	
	wxListCtrl *m_list;
	
	void MakeButtonsList();

#if defined(MAKEYBOARD)
	wxCheckBox *m_cbdummy;
#endif
	
#if defined(MAUSEMABUTTON)
	MABUTTON *MakeButtonList(char const **foreground,
						char const **disabled,
						char const **foremask, int id, bool processdownevents);		
#else
	MABUTTON *MakeButtonList(int id, char *label);
#endif

#if !defined(MANOWXPANEL)
	wxPanel *m_panel;
#endif

private:
	wxImage *m_upPattern;
	wxImage *m_downPattern;
	wxImage *m_hilitePattern;
	int m_ButtonPos;
	int m_buttonTop;
	
	DECLARE_EVENT_TABLE()
	
}; // class MyFrameList


class MyFrameEq : public wxFrame
{
public:
	MyFrameEq(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);

	virtual ~MyFrameEq();

	void OnGUICheckEqZoom(wxCommandEvent& event);
	void OnGUICheckEqLink(wxCommandEvent& event);
	void OnGUICheckEqualizerB(wxCommandEvent& event);
	void OnGUICheckEq31BandsB(wxCommandEvent& event);
	void OnGUICheckEqExtraB(wxCommandEvent& event);
	void OnGUICheckSeparateLR(wxCommandEvent& event);
	void OnGUIButtonEqMinus(wxCommandEvent& event);
	void OnGUIButtonEqPlus(wxCommandEvent& event);
	void OnGUIButtonEqMid(wxCommandEvent& event);
	void OnGUIButtonEqCopy(wxCommandEvent& event);
	void OnGUIButtonEqPaste(wxCommandEvent& event);
	void OnGUIButtonEqRestore(wxCommandEvent& event);
	void OnGUIButtonEqShiftL(wxCommandEvent& event);
	void OnGUIButtonEqShiftR(wxCommandEvent& event);
	void OnGUIButtonEqInvert(wxCommandEvent& event);
	void OnGUIPopupEqPreset(wxCommandEvent& event);
	void OnGUIEditTextEq(wxCommandEvent& event);
	void OnGUISliderEq(wxCommandEvent& event);
	void OnGUISpinUpEqOffset(wxSpinEvent& event);
	void OnGUISpinUpEq(wxSpinEvent& event);
	void OnGUISpinDownEqOffset(wxSpinEvent& event);
	void OnGUISpinDownEq(wxSpinEvent& event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);
	void OnCloseWindow(wxCloseEvent &event);
	void MakeButtonsEq();
	
#if defined(MAUSEMABUTTON)
	MABUTTON *MakeButtonEq(char const **foreground,
						char const **disabled,
						char const **foremask, int id, bool processdownevents);		
#else
	MABUTTON *MakeButtonEq(int id, char *label);
#endif
	
	wxTextCtrl *m_edittexteq;
#if defined(MAKEYBOARD)
	wxTextCtrl *m_dummytexteq;
#endif

#if !defined(MANOWXPANEL)
	wxPanel *m_panel;
#endif

private:
	wxComboBox *m_ComboPreset;
	int m_numslidersEq;

	wxImage *m_upPattern;
	wxImage *m_downPattern;
	wxImage *m_hilitePattern;
	int m_ButtonPos;
	int m_buttonTop;
	
	DECLARE_EVENT_TABLE()

}; // class MyFrameEq


class MyFrameEq2 : public wxFrame
{
public:
	MyFrameEq2(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);

	virtual ~MyFrameEq2();

	void OnGUIButtonEqMid(wxCommandEvent& event);
	void OnGUIButtonEqCopy(wxCommandEvent& event);
	void OnGUIButtonEqPaste(wxCommandEvent& event);
	void OnGUIButtonEqRestore(wxCommandEvent& event);
	void OnGUISliderEq(wxCommandEvent& event);
	void OnGUISpinUpEqOffset(wxSpinEvent& event);
	void OnGUISpinUpEq(wxSpinEvent& event);
	void OnGUISpinDownEqOffset(wxSpinEvent& event);
	void OnGUISpinDownEq(wxSpinEvent& event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);
	void OnCloseWindow(wxCloseEvent &event);
	void MakeButtonsEq();
	
#if defined(MAUSEMABUTTON)
	MABUTTON *MakeButtonEq(char const **foreground,
	 					char const **disabled,
	 					char const **foremask, int id, bool processdownevents);		
#else
	MABUTTON *MakeButtonEq(int id, char *label);
#endif
	
 #if defined(MAKEYBOARD)
	wxTextCtrl *m_dummytexteq;
 #endif

#if !defined(MANOWXPANEL)
	wxPanel *m_panel;
#endif

private:
	int m_numslidersEq;

	wxImage *m_upPattern;
	wxImage *m_downPattern;
	wxImage *m_hilitePattern;
	
	int m_ButtonPos;
	int m_buttonTop;
	
	DECLARE_EVENT_TABLE()

}; // class MyFrameEq2


class MyFrameEffects : public wxFrame
{
public:
	MyFrameEffects(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);

	virtual ~MyFrameEffects();

	void OnGUISliderPitch(wxCommandEvent& event);
	void OnGUISliderPitch2(wxCommandEvent& event);
	void OnGUISliderTempo(wxCommandEvent& event);
	void OnGUISliderSpeed(wxCommandEvent& event);
	void OnGUISpinDownPitch(wxSpinEvent& event);
	void OnGUISpinDownPitch2(wxSpinEvent& event);
	void OnGUISpinDownTempo(wxSpinEvent& event);
	void OnGUISpinDownSpeed(wxSpinEvent& event);
	void OnGUISpinUpPitch(wxSpinEvent& event);
	void OnGUISpinUpPitch2(wxSpinEvent& event);
	void OnGUISpinUpTempo(wxSpinEvent& event);
	void OnGUISpinUpSpeed(wxSpinEvent& event);
	void OnGUICheckPitch(wxCommandEvent& event);
	void OnGUICheckTempo(wxCommandEvent& event);
	void OnGUICheckSpeed(wxCommandEvent& event);
	void OnGUICheckQualSpeed(wxCommandEvent& event);
	void OnGUICheckQualFilter(wxCommandEvent& event);
	void OnGUICheckEffectsB(wxCommandEvent& event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);
	void OnCloseWindow(wxCloseEvent &event);

	MACHECKBOX *m_checkbox;

private:
#if !defined(MANOWXPANEL)
	wxPanel *m_panel;
#endif

	DECLARE_EVENT_TABLE()

}; // class MyFrameEffects


#if !defined(MANOCDA) && defined(__MAUNIX__)
class MyFrameAudioCD : public wxFrame
{
public:
	MyFrameAudioCD(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);

	virtual ~MyFrameAudioCD();

	void OnGUIPopupAudioCD(wxCommandEvent& event);
	void OnGUIButtonAudioCDSet(wxCommandEvent& event);
	void OnGUIButtonAudioCDClear(wxCommandEvent& event);
	void OnGUIButtonAudioCDSave(wxCommandEvent& event);
	void OnButtonClose(wxCommandEvent& event);
	void OnGUICheckCdParanoia(wxCommandEvent& event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);
	void OnCloseWindow(wxCloseEvent &event);

private:
	wxPanel *m_panel;
	wxComboBox *m_ComboAudioCD;

	DECLARE_EVENT_TABLE()

}; // class MyFrameAudioCD
#endif


class MyFrameFileOut : public wxFrame
{
public:
	MyFrameFileOut(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);

	virtual ~MyFrameFileOut();
	void OnGUIPopupBitRate(wxCommandEvent& event);
	void OnGUIPopupQuality(wxCommandEvent& event);
	void OnGUIPopupMode(wxCommandEvent& event);
	void OnGUIPopupSampleRate(wxCommandEvent& event);
	void OnGUIButtonFileOutDir(wxCommandEvent& event);
	void OnGUICheckBoxADTS(wxCommandEvent &event);
	void OnGUICheckBoxM4A(wxCommandEvent &event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);
	void OnCloseWindow(wxCloseEvent &event);

private:
	wxPanel *m_panel;	
	wxComboBox *m_ComboBitRate;
	wxComboBox *m_ComboQuality;
	wxComboBox *m_ComboMode;
	wxComboBox *m_ComboSampleRate;

	DECLARE_EVENT_TABLE()

}; // class MyFrameFileOut


class MyFrameAbout : public wxFrame
{
public:
	MyFrameAbout(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);
	
	virtual ~MyFrameAbout();

	void OnButtonClose(wxCommandEvent& event);
	void OnCloseWindow(wxCloseEvent &event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);

private:
	wxPanel *m_panel;
	wxTextCtrl *m_aboutTextCtrl;
	wxTextCtrl *m_urlTextCtrl;
	wxButton *m_closebutton;
	
	DECLARE_EVENT_TABLE()

}; // class MyFrameAbout


class MyFrameViewer : public wxFrame
{
public:
	MyFrameViewer(int id_window, const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);
	
	virtual ~MyFrameViewer();
	void SetFindText(char *text);
	void OnButtonFind(wxCommandEvent& event);
	void OnButtonEditSave(wxCommandEvent& event);
	void OnButtonClose(wxCommandEvent& event);
	void OnCloseWindow(wxCloseEvent &event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);

private:
	int m_id_window;
	wxPanel *m_panel;
	MyViewerTextCtrl *m_viewerTextCtrl;
	MyTextCtrl *m_findTextCtrl;
	wxStaticText *m_foundStaticText;
	wxButton *m_findbutton;
	wxButton *m_editbutton;
	wxButton *m_closebutton;
	char *m_viewertarget;	
	int m_n;
	long m_ip;
	char m_fpath[MAX_PATH];
	
	DECLARE_EVENT_TABLE()

}; // class MyFrameViewer


class MyViewerTextCtrl : public wxTextCtrl
{
public:
	MyViewerTextCtrl(wxWindow *parent, wxWindowID id, const wxString &value,
						const wxPoint &pos, const wxSize &size, int style)
		: wxTextCtrl(parent, id, value, pos, size, style)
	{ }

	void OnGUIMouse(wxMouseEvent& event);
	
private:

	DECLARE_EVENT_TABLE()
};


class MyTextCtrl : public wxTextCtrl
{
public:
	MyTextCtrl(wxWindow *parent, wxWindowID id, const wxString &value,
				const wxPoint &pos, const wxSize &size)
		: wxTextCtrl(parent, id, value, pos, size)
	{ }

	void OnGUIChar(wxKeyEvent& event);
	void OnGUIMouse(wxMouseEvent& event);
	
private:

	DECLARE_EVENT_TABLE()
};


class MyFramePromptNum : public wxFrame
{
public:
	MyFramePromptNum(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize,
		long style = wxCAPTION | wxCLIP_CHILDREN);

	virtual ~MyFramePromptNum();

	void OnGUIButtonPromptNumOk(wxCommandEvent& event);
	void OnGUIButtonPromptNumCancel(wxCommandEvent& event);
	void OnGUIEditTextPromptNum(wxCommandEvent& event);
	void OnCloseWindow(wxCloseEvent &event);
	
	wxStaticText *m_textpromptnum;

#if !defined(MANOWXPANEL)
	wxPanel *m_panel;
#endif

	wxTextCtrl *m_edittextpromptnum;
	wxTextCtrl *m_dummytextpromptnum;

private:
	wxButton *m_buttonOk;
	wxButton *m_buttonCancel;
	
	DECLARE_EVENT_TABLE()

}; // class MyFramePromptNum


class MyFrameAdvanced : public wxFrame
{
public:
	MyFrameAdvanced(const wxString& title, const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);
		
	virtual ~MyFrameAdvanced();
	void OnGUICheckCloseReopen(wxCommandEvent& event);
	void OnGUICheckHighPriority(wxCommandEvent& event);
	void OnButtonClose(wxCommandEvent& event);
	void OnCloseWindow(wxCloseEvent &event);
	void OnGUISize(wxSizeEvent& event);
	void OnGUIMove(wxMoveEvent& event);
	
	wxStaticText *m_textclosereopen;

private:
	wxPanel *m_panel;

	DECLARE_EVENT_TABLE()

}; // class MyFrameAdvanced


#ifdef MADRAGANDDROP
class DnDFile: public wxFileDropTarget
{
public:
	DnDFile() {}

	virtual bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames);

private:

};


bool DnDFile::OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames)
{
#ifdef MAUNUSED
 (void)x; (void)y;
#endif

	char **pitems;
	char songlist[MAX_PATH];
	wxArrayString s = filenames;

	s.Sort();
	int nitems = (int)s.GetCount();

	if((pitems = (char **)MAMALLOC(nitems * sizeof(char *))) == NULL)
	{
		maLog("OnDropFiles MAMALLOC failed");
		return TRUE;
	}
		
	char **p = pitems;
	for(int i = 0; i < nitems; i++, p++)
		*p = (char *)((const char *)s[i]);
	
	// write a new songlist
	songlist[0] = 0;
	if(maSongListMake(nitems, pitems, songlist)) // OnDropFiles
	{
		MAFREE(pitems);
		maLog("OnDropFiles maSongListMake failed");
		return TRUE;
	}
	
	MAFREE(pitems);

	PlaySonglist(songlist);	

	return TRUE;
}
#endif


#define MAFINDSTRMAX 64 // arbitrary
void MyViewerTextCtrl::OnGUIMouse(wxMouseEvent& ev)
{
#if defined(__WXMSW__)
	if(!ev.RightDown()) // avoid copy/paste popup
		ev.Skip();
#else
	ev.Skip();
#endif

#if defined(__WXGTK__) || defined(__WXX11__)
	if(ev.LeftUp() || ev.LeftDClick())
#else
	if(ev.RightUp())
#endif
		if(GetStringSelection().Len() >= 1 && GetStringSelection().Len() <= MAFINDSTRMAX)
		{
			wxCommandEvent dummy;
			((MyFrameViewer *)((this->GetParent())->GetParent()))->SetFindText((char *)GetStringSelection().c_str());
			((MyFrameViewer *)((this->GetParent())->GetParent()))->OnButtonFind(dummy);
		}
}


void MyTextCtrl::OnGUIChar(wxKeyEvent& event)
{
	wxCommandEvent dummy;
	int code = event.GetKeyCode();
	
	switch(code)
	{
		case 10 :
		case 13 :
			((MyFrameViewer *)((this->GetParent())->GetParent()))->OnButtonFind(dummy);
		break;
		default :
			event.Skip();
		break;
	}
}


void MyTextCtrl::OnGUIMouse(wxMouseEvent& ev)
{
	wxCommandEvent dummy;

#if defined(__WXMSW__)
	if(!ev.RightDown()) // avoid copy/paste popup
		ev.Skip();
#else
	ev.Skip();
#endif

#if defined(__WXGTK__) || defined(__WXX11__)
	if(ev.LeftUp() || ev.LeftDClick())
#else
	if(ev.RightUp())
#endif
		((MyFrameViewer *)((this->GetParent())->GetParent()))->OnButtonFind(dummy);
}


MyApp *g_theApp;

#if defined(MASMALLERFONT)
 wxFont g_mafont;
#endif

#if !defined(__WXMSW__) && !defined(__WXX11__)
 #include "MoreAmpIcon.xpm"
#endif

#if(MAGUIWX == 4) // wx-2.4.2
 wxApp *wxCreateApp(); // prototype for IMPLEMENT_APP
#endif

IMPLEMENT_APP(MyApp)

#if defined(__MAOSX__)
 #include "MacWindows.h"
 WindowRef l_wrefwapp = NULL;
#endif


int	AppWindowMake()
{
	wxPoint pos; 
	wxSize  siz;
	
	pos = wxPoint(g_sets.xpos[g_sets.winconf], g_sets.ypos[g_sets.winconf]);
	siz = wxSize(g_sets.xsize[g_sets.winconf], g_sets.ysize[g_sets.winconf]);
	
	MyFrame *frame = new MyFrame(g_prognametitle, pos, siz);

	g_w[WINDOWAPP] = frame;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
	wxIcon ic(wxICON(APP_ICON));
 #else
	wxIcon ic(wxICON(MoreAmpIcon));
 #endif
	frame->SetIcon(ic);
#endif

#if defined(__MAOSX__)
	l_wrefwapp = (WindowRef)frame->MacGetWindowRef();
#endif

#if defined(__MAOSX__) && defined(__WXMAC__)
	HISize min, max;
	GetWindowResizeLimits(l_wrefwapp, &min, &max);
	min.width = 20;
	min.height = 20;
	SetWindowResizeLimits(l_wrefwapp, &min, &max);
#endif

	frame->Move(pos.x, pos.y); // need this here
	frame->Show();
	g_theApp->SetTopWindow(frame);
	
	UpdateDisplay(); // open and show other windows

#if defined(MAKEYBOARD)
	UpdateMenuKbLabels();
	UpdateButtonLabels();
#endif

	return 0;
	
} // AppWindowMake


bool MyApp::OnInit() // called by the wx framework when starting the app
{
	g_theApp = this;
	g_argc = g_theApp->argc;
	g_argv = g_theApp->argv;

#if defined(__MAOSX__) && defined(__WXMAC__) && (MAGUIWX >= 8) // wx-2.8+
	// otherwise "native", which has problems with up/down arrow keys
	wxSystemOptions::SetOption(wxT("mac.listctrl.always_use_generic"), 1);
#endif

#if defined(__MAOSX__)
	InitAppleEvents((void *)this);
#endif
		
	sprintf(&g_AboutText[strlen(g_AboutText) - 64],
#if defined(__MAOSX__) && defined(__WXMAC__) && (MAGUIWX == 6) && (wxMINOR_VERSION == 6)
											
							" wxWidgets-%d.%d.%d (modified)",  // MANOMACMLTEHIVIEW below
#else
							" wxWidgets-%d.%d.%d (as released)",
#endif
							wxMAJOR_VERSION, wxMINOR_VERSION, wxRELEASE_NUMBER);

#if defined(MASMALLERFONT)
 #if(MAGUIWX == 4)
	g_mafont = wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT);
 #else
	g_mafont = wxSystemSettingsNative::GetFont(wxSYS_DEFAULT_GUI_FONT);
 #endif
	if(g_mafont.GetPointSize() > 11)
		g_mafont.SetPointSize(11);
#endif									  

#if defined(MAKEYBOARD)
	g_theApp->Connect(wxID_ANY, wxEVT_CHAR,
		(wxObjectEventFunction)(wxEventFunction)(wxCharEventFunction) &MyApp::maOnChar, NULL);
	g_theApp->Connect(wxID_ANY, wxEVT_LEFT_UP,
		(wxObjectEventFunction)(wxEventFunction)(wxMouseEventFunction) &MyApp::maOnClick, NULL);
#endif

#if defined(MAMOUSEWHEEL)
	g_theApp->Connect(wxID_ANY, wxEVT_MOUSEWHEEL,
		(wxObjectEventFunction)(wxEventFunction)(wxMouseEventFunction) &MyApp::OnMouseWheel, NULL);
#endif

	return OnInit_() ? TRUE : FALSE;
	
} // OnInit


#if defined(MAKEYBOARD)
 void MyApp::maOnChar(wxKeyEvent& event)
 {
	void *p;
	void *parent;
	int keyval;
	if(g_sets.keyboard && event.GetEventType() == wxEVT_CHAR)
	{
		parent = p = event.GetEventObject();
		while(p && (p = ((wxWindow *)p)->GetParent()))
			parent = p;
		
		// accept only from these windows
		if((g_w[WINDOWAPP] && g_w[WINDOWAPP] == parent) ||
		   (g_w[WINDOWLIST] && g_w[WINDOWLIST] == parent) ||
		   ((g_w[WINDOWEQ] && g_w[WINDOWEQ] == parent) && ((MyFrameEq *)parent)->m_edittexteq != event.GetEventObject()) ||
		   (g_w[WINDOWEQ2] && g_w[WINDOWEQ2] == parent) ||
		   (g_w[WINDOWEFFECTS] && g_w[WINDOWEFFECTS] == parent) ||
		   (g_w[WINDOWPROMPTNUM] && g_w[WINDOWPROMPTNUM] == parent))
		{
#if(1) // let the arrow keys from other windows scroll the list 
			if((keyval = event.GetKeyCode()) == WXK_DOWN)
				keyval = MAWXK_DOWN;
			else if(keyval == WXK_UP) 
				keyval = MAWXK_UP;
			else if(keyval == WXK_RETURN)
				keyval = MAWXK_RETURN;
			{
#else // don't let the arrow keys from other windows scroll the list 
			if((keyval = event.GetKeyCode()) != WXK_UP && keyval != WXK_DOWN) // let wx handle these 
			{
				if(keyval == WXK_RETURN)
					keyval = MAWXK_RETURN;
#endif
				if(!maOnKey(0, keyval))
					return;
			}
		}
	}

	event.Skip();

 } // maOnChar


 void MyApp::maOnClick(wxMouseEvent &event)
 {
	void *p;
	void *parent;
	
	if(g_sets.keyboard && event.GetEventType() == wxEVT_LEFT_UP)
	{
		parent = p = event.GetEventObject();
		while(p && (p = ((wxWindow *)p)->GetParent()))
			parent = p;
		
		// accept only from these windows
		if(g_w[WINDOWEQ] && g_w[WINDOWEQ] == parent && // in WINDOWEQ outside m_edittexteq
			event.GetEventObject() != ((MyFrameEq *)parent)->m_edittexteq &&
			wxFindFocusDescendant((wxWindow *)parent) == ((MyFrameEq *)parent)->m_edittexteq)
		{
			// move the kb focus from m_edittexteq
			((MyFrameEq *)parent)->m_dummytexteq->SetFocus();
			return;
		}

		if(g_w[WINDOWLIST] && g_w[WINDOWLIST] == parent && // in WINDOWLIST outside m_list
			event.GetEventObject() != ((MyFrameList *)parent)->m_list &&
			wxFindFocusDescendant((wxWindow *)parent) == ((MyFrameList *)parent)->m_list)
		{
			// move the kb focus from m_list
			((MyFrameList *)parent)->m_cbdummy->SetFocus();
			return;
		}
	}

	event.Skip();

 } // maOnClick
#endif // MAKEYBOARD


#if defined(MAMOUSEWHEEL)
 void MyApp::OnMouseWheel(wxMouseEvent &event)
 {
	int wheelRotation;
	void *p;
	void *parent;
	
	if(g_sets.mousewheel && event.GetEventType() == wxEVT_MOUSEWHEEL)
	{
		parent = p = event.GetEventObject();
		while(p && (p = ((wxWindow *)p)->GetParent()))
			parent = p;
		
		// accept only from these windows
		if(((g_w[WINDOWAPP] && g_w[WINDOWAPP] == parent) ||
		
			(g_w[WINDOWLIST] && g_w[WINDOWLIST] == parent &&
				((MyFrameList *)parent)->m_list != event.GetEventObject()) ||
				
			(g_w[WINDOWEQ] && g_w[WINDOWEQ] == parent) ||
			
			(g_w[WINDOWEQ2] && g_w[WINDOWEQ2] == parent) ||
			
			(g_w[WINDOWEFFECTS] && g_w[WINDOWEFFECTS] == parent)))
		{
			if((wheelRotation = event.GetWheelRotation()) > 0)
				ChangeVolume(MAWHEELVOLUMEDELTA);
			else if(wheelRotation < 0)
				ChangeVolume(-MAWHEELVOLUMEDELTA);
			return;
		}
	}

	event.Skip();

 } // OnMouseWheel
#endif


// control sizes
#define EDSIZ wxSize(72, 23)			// edit boxes

#define SPSIZ wxSize(16, 24)			// spin controls

#if defined(MAKEYBOARD)
 #define SLSIZ wxSize(XSIZEDEF - 12, 20) // pos slider
#else
 #define SLSIZ wxSize(XSIZEDEF - 26, 20)
#endif

#define CBYSIZ 12						// checkboxes
#if !defined(MAUSEMACHECKBOX) && defined(__MAOSX__) && defined(__WXMAC__)
 #define CBXSIZ 140						// for checkboxes with large font
 #define CBSIZ (wxSize(CBXSIZ, CBYSIZ))
 #define CBSIZ2 (wxSize(CBXSIZ + 20, CBYSIZ))
 #define CBSIZ3 (wxSize(CBXSIZ - 30, CBYSIZ))
#else
 #define CBXSIZ 80
 #define CBSIZ (wxSize(CBXSIZ, CBYSIZ))
 #define CBSIZ2 (wxSize(CBXSIZ + 20, CBYSIZ))
 #define CBSIZ3 (wxSize(50, CBYSIZ))
#endif
#define CBSIZ4 (wxSize(CBYSIZ + 2, CBYSIZ))
#define CBSIZ5 (wxSize(CBYSIZ + 2 + 40, CBYSIZ))


MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
					: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	m_timerplaysonglist = new wxTimer(this, ID_TIMER_PLAYSONGLIST);
	m_timerrunloop = new wxTimer(this, ID_TIMER_RUN);
	m_timerplay = new wxTimer(this, ID_TIMER_PLAY);
	m_timerstop = new wxTimer(this, ID_TIMER_STOP);
	
	MakeMenus();
	
#if !defined(MANOWXPANEL)
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
#endif

#if defined(MAKEYBOARD)
	// having a wxListCtrl makes kb focus work...
	new wxListCtrl(MPANEL, -1, wxPoint(0, 0), wxSize(1, 1),
		wxLC_REPORT | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL | wxLC_HRULES | wxLC_NO_SORT_HEADER);
#endif

	// control positions
	#define POSX (XBASE)
	#define POSY (YBASE)
	#define BEGX (POSX +  98)
	#define ENDX (POSX + 200)

	#define BUTTONTEXTY (YBASE + MABUTTONH)

	// Alt size checkbox
#if defined(__MAWIN__) && defined(MAMOUSEWHEEL)
	l_ChkAltSize =
#endif
	new MACHECKBOX(MPANEL, ID_CHK_ALTSIZE, wxT(""), wxPoint(XBASE + 1, YBASE + MABUTTONH), CBSIZ4, 0); // in front "Quit"

	// player buttons
	m_ButtonPos = POSX;
	m_buttonTop = POSY;
	MakeButtons();

	// position slider
#if defined(MAKEYBOARD)
	#define SLIDERPOSX (POSX + 4)
#else
	#define SLIDERPOSX (POSX + 12)
#endif
	#define SLIDERPOSY (POSY + 62)
	m_sliderPos = new MASLIDER(MPANEL, ID_SLIDER_POSITION, 0, POSMIN, POSMAX, wxPoint(SLIDERPOSX, SLIDERPOSY), SLSIZ);

	// repeat controls
	#define POSY2 (POSY + 90)

	wxStaticText *t;
	t = new wxStaticText(MPANEL,   ID_TEXT_TIMEPOS,wxT(ZEROMSSTR),	wxPoint(POSX +  6,	POSY2 - 5));
	MASETFONT(t);
	StaticTextSetText(WINDOWAPP,	ID_TEXT_TIMEPOS, NOTIMESTR);
	new MACHECKBOX(MPANEL,			ID_CHK_REPTSONG, wxT("Repeat"),	wxPoint(POSX +  6,	POSY2 + 9),		CBSIZ, 1); // red
		
	wxSpinButton *s = new wxSpinButton(MPANEL, ID_SPIN_BEG,		wxPoint(BEGX +  2,	POSY2 - 4),		SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);
	t = new wxStaticText(MPANEL,   ID_TEXT_TIMEBEG,wxT(ZEROMSSTR),	wxPoint(BEGX + 20,	POSY2 - 5));
	MASETFONT(t);
	StaticTextSetText(WINDOWAPP,	ID_TEXT_TIMEBEG, NOTIMESTR);
	new MACHECKBOX(MPANEL,			ID_CHK_BEG,		wxT("Begin"),	wxPoint(BEGX + 20,	POSY2 + 9),		CBSIZ, 1); // red

	s = new wxSpinButton(MPANEL,   ID_SPIN_END,					wxPoint(ENDX +  2,	POSY2 - 4),		SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);
	t = new wxStaticText(MPANEL,   ID_TEXT_TIMEEND, wxT(ZEROMSSTR), wxPoint(ENDX + 20,	POSY2 - 5));
	MASETFONT(t);
	StaticTextSetText(WINDOWAPP,	ID_TEXT_TIMEEND, NOTIMESTR);
	new MACHECKBOX(MPANEL,			ID_CHK_END,		wxT("End"),		wxPoint(ENDX + 20,	POSY2 + 9),		CBSIZ, 1); // red

	#define POSHEIGHT 120
	
	// Volume, Separation, Preamp controls
	#define VOLY  (YBASE +  POSHEIGHT + 2)
	#define VOLX  (XBASE +  2)
	#define VOLLX (VOLX  +  0)
	#define VOLRX (VOLX  + 31)
	#define SEPX  (VOLX  + 63)
	#define PREAX (VOLX  + 93)
	
	t = new wxStaticText(MPANEL,	ID_TEXT_VOLUME, wxT("Volume dB"), wxPoint(VOLLX +  4,	VOLY -   6));
	MASETFONT(t);
	new MACHECKBOX(MPANEL,			ID_CHK_BALANCE,		wxT("Balance"),	wxPoint(VOLLX +  4,	VOLY +  10),	CBSIZ);

	new MASLIDER(MPANEL,			ID_SLIDER_VOLUMER,	(VOLUMEMAX - VOLUMEMIN) / 2, VOLUMEMIN, VOLUMEMAX,
																	wxPoint(VOLRX,		VOLY +  21),	wxSize( 20, 102),	wxSL_VERTICAL); //	| wxSL_AUTOTICKS | wxSL_LABELS | wxSL_BOTTOM);
	t = new wxStaticText(MPANEL,	ID_TEXT_100VOLR,wxT("100"),		wxPoint(VOLRX - 2,	VOLY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_VOLR,					wxPoint(VOLRX + 2,	VOLY + 137),	SPSIZ,				wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	new MASLIDER(MPANEL,			ID_SLIDER_VOLUMEL,	(VOLUMEMAX - VOLUMEMIN) / 2, VOLUMEMIN, VOLUMEMAX,
																	wxPoint(VOLLX,		VOLY +  21),	wxSize( 20, 102),	wxSL_VERTICAL); //	| wxSL_AUTOTICKS | wxSL_LABELS | wxSL_BOTTOM);
	t = new wxStaticText(MPANEL,	ID_TEXT_100VOLL,wxT("100"),		wxPoint(VOLLX - 2,	VOLY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_VOLL,					wxPoint(VOLLX + 2,	VOLY + 137),	SPSIZ,				wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	t = new wxStaticText(MPANEL,	ID_TEXT_SEP,	wxT("Sep"),		wxPoint(SEPX,		VOLY -   6));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,	ID_TEXT_S,		wxT("s"),		wxPoint(SEPX - 7,	VOLY +  21));
	MASETFONT(t);
	new MASLIDER(MPANEL,			ID_SLIDER_VOLUMESEP, (SEPARATIONMAX - SEPARATIONMIN) / 2, SEPARATIONMIN, SEPARATIONMAX,
																	wxPoint(SEPX,		VOLY +  21),	wxSize( 20, 102),	wxSL_VERTICAL); //	| wxSL_AUTOTICKS | wxSL_LABELS | wxSL_BOTTOM);
	t = new wxStaticText(MPANEL,	ID_TEXT_M,		wxT("m"),		wxPoint(SEPX - 7,	VOLY + 109));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,	ID_TEXT_100SEP, wxT("100"),		wxPoint(SEPX + 4,	VOLY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_SEP,					wxPoint(SEPX + 2,	VOLY + 137),	SPSIZ,				wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	t = new wxStaticText(MPANEL,	ID_TEXT_PREAMP, wxT("Preamp"),	wxPoint(PREAX - 2,	VOLY -   6));
	MASETFONT(t);
	new MASLIDER(MPANEL,			ID_SLIDER_PREAMP,	(PREAMPMAX - PREAMPMAX) / 2, PREAMPMIN, PREAMPMAX,
																	wxPoint(PREAX,		VOLY +  21),	wxSize( 20, 102),	wxSL_VERTICAL); //	| wxSL_AUTOTICKS | wxSL_LABELS | wxSL_BOTTOM);

	new MACHECKBOX(MPANEL,			ID_CHK_LIMITER,		wxT("Limit"),	wxPoint(PREAX - 2,	VOLY +  10), CBSIZ5);

	t = new wxStaticText(MPANEL,	ID_TEXT_0,		wxT("-00.0"),	wxPoint(PREAX,		VOLY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_PREA,					wxPoint(PREAX + 2,	VOLY + 137),	SPSIZ,				wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	// checkboxes
	#define CBWX (XBASE + 144)
	#define CBWY (YBASE + POSHEIGHT - 4)
	#define CBYDEL 17
	
	new MACHECKBOX(MPANEL, ID_CHK_EQWINDOW,	wxT("EqWindow"),		wxPoint(CBWX, CBWY),				CBSIZ);
	new MACHECKBOX(MPANEL, ID_CHK_EQUALIZER,   wxT("Equalizer"),	wxPoint(CBWX, CBWY + (1 * CBYDEL)),	CBSIZ);
	new MACHECKBOX(MPANEL, ID_CHK_EQ31BANDS,   wxT("Eq31Bands"),	wxPoint(CBWX, CBWY + (2 * CBYDEL)),	CBSIZ);
	new MACHECKBOX(MPANEL, ID_CHK_EQEXTRA,		wxT("EqExtra"),		wxPoint(CBWX, CBWY + (3 * CBYDEL)),	CBSIZ);
	new MACHECKBOX(MPANEL, ID_CHK_EFFECTS,		wxT("Effects"),		wxPoint(CBWX, CBWY + (4 * CBYDEL)),	CBSIZ, 1); // red

	#define CBXPOS (XBASE + 220)
	#define CBYPOS (cbypos += CBYDEL)
	
	int cbypos = CBWY - CBYDEL;
	
	new MACHECKBOX(MPANEL, ID_CHK_LISTWINDOW,	wxT("ListWindow"),	wxPoint(CBXPOS, CBYPOS),	CBSIZ2);
	new MACHECKBOX(MPANEL, ID_CHK_RANDOM,		wxT("Random"),		wxPoint(CBXPOS, CBYPOS),	CBSIZ2);
	new MACHECKBOX(MPANEL, ID_CHK_REPTPLAYED,	wxT("ReptPlayed"),	wxPoint(CBXPOS, CBYPOS),	CBSIZ2);
	new MACHECKBOX(MPANEL, ID_CHK_LOOPLOADED,	wxT("LoopLoaded"),	wxPoint(CBXPOS, CBYPOS),	CBSIZ2, 1); // red
	new MACHECKBOX(MPANEL, ID_CHK_LOOPLIST,		wxT("LoopList"),	wxPoint(CBXPOS, CBYPOS),	CBSIZ2);
	new MACHECKBOX(MPANEL, ID_CHK_INVERTRIGHT,	wxT("InvertRight"),	wxPoint(CBXPOS, CBYPOS),	CBSIZ2, 1); // red
	new MACHECKBOX(MPANEL, ID_CHK_SINGLEPLAY,	wxT("SinglePlay"),	wxPoint(CBXPOS, CBYPOS),	CBSIZ2, 1); // red
	new MACHECKBOX(MPANEL, ID_CHK_USEM3U,		wxT("Use m3u"),		wxPoint(CBXPOS, CBYPOS),	CBSIZ2);
	new MACHECKBOX(MPANEL, ID_CHK_TITLEINFO,	wxT("TitleInfo"),	wxPoint(CBXPOS, CBYPOS),	CBSIZ2);

	// mono/stereo
	#define MSTX (XBASE + 129)
	#define MSTY (YBASE + POSHEIGHT + 91)
	
	t = new wxStaticText(MPANEL,	ID_TEXT_OUTPUT, wxT("Output Stereo"),wxPoint(MSTX +  0, MSTY - 14));
	MASETFONT(t);
	new MACHECKBOX(MPANEL,		ID_CHK_MONOLEFT,	wxT("L"),		wxPoint(MSTX +  0, MSTY),   CBSIZ4, 1); // red
	new MACHECKBOX(MPANEL,		ID_CHK_MONORIGHT,	wxT("R"),		wxPoint(MSTX + 20, MSTY),   CBSIZ4, 1); // red
	new MACHECKBOX(MPANEL,		ID_CHK_MONODIFF,	wxT(""),			wxPoint(MSTX + 44, MSTY),   CBSIZ4, 1); // red
	
	// popuplists	
	#define POPX (XBASE + 125)
	#define POPY (YBASE + POSHEIGHT + 105)
	
	m_ComboOutput = new wxComboBox(MPANEL, ID_POPUP_OUTPUT, wxT("") ,wxPoint(POPX,   POPY),			wxSize(85, 20), 0, NULL, wxCB_READONLY);
 	MASETFONT(m_ComboOutput); // doesn't on all platforms
	m_ComboOutput->Append(wxT(g_extstrout[kOUTSOUND]));
 	char label[64];
	for(int i = kOUTFIRST; i <= kOUTLAST; i++)
	{
		sprintf(label, "%s file", &g_extstrout[i][1]);
		m_ComboOutput->Append(wxT(label));
 	}
 
	#define POPY2 (POPY + 35)
	m_ComboBuffer = new wxComboBox(MPANEL, ID_POPUP_BUFFER, wxT(""),
												wxPoint(POPX + SPSIZ.x, POPY2), wxSize(69, 20), 0, NULL, wxCB_READONLY);
 	MASETFONT(m_ComboBuffer); // doesn't on all platforms
	m_ComboBuffer->Append(wxT("Mem"));
 	m_ComboBuffer->Append(wxT("Vdisk"));
 	m_ComboBuffer->Append(wxT("Direct"));
	t = new wxStaticText(MPANEL,	ID_TEXT_BUFFER,	wxT("Buffer 2047  MB"),wxPoint(POPX,	POPY2 - 14));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_BUFFER, wxPoint(POPX, POPY2 - 1), SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);
		
	// Sizers	
	m_sizerFrame = new wxBoxSizer(wxVERTICAL);
	m_sizerFrame->Add(-1, SLIDERPOSY, 0, 0, 0); // spacer to m_sliderPos
	m_sizerTop = new wxBoxSizer(wxHORIZONTAL);
	m_sizerTop->Add(SLIDERPOSX, -1, 0, 0, 0); // spacer to left edge of m_sliderPos
	m_sizerTop->Add(m_sliderPos, 1, wxEXPAND);
	m_sizerFrame->Add(m_sizerTop, 0, wxEXPAND);
	MPANEL->SetSizer(m_sizerFrame);

#ifdef MANOCDA
	MenuDisable(MENUMACONTROLS, ID_MENU_PLAYCD);
	MenuDisable(MENUMACONTROLS, ID_MENU_EJECTCD);
#endif

#if !defined(NODECODEAUDIOIN)
#else
	MenuDisable(MENUMACONTROLS, ID_MENU_AUDIOIN);
#endif

#ifdef MADRAGANDDROP
	SetDropTarget(new DnDFile()); // does not work in main window on mac
#endif

#if defined(MAKEYBOARD)
	m_ComboOutput->SetFocus(); // for maOnChar focus
#endif

} // MyFrame


MyFrame::~MyFrame()
{
	delete m_timerplaysonglist;
	delete m_timerrunloop;
	delete m_timerplay;
	delete m_timerstop;	
}


void MyFrame::OnGUICheckAltSize(wxCommandEvent& event)
{
	OnCheckAltSize(event.IsChecked() ? 1 : 0, 0);
}


void MyFrame::OnGUICheckRandom(wxCommandEvent& event)
{
	OnCheckRandom(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckReptPlayed(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnCheckReptPlayed(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckLoopLoaded(wxCommandEvent& event)
{
	OnCheckLoopLoaded(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckLoopList(wxCommandEvent& event)
{
	OnCheckLoopList(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckEqWindow(wxCommandEvent& event)
{
	OnCheckEqWindow(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckListWindow(wxCommandEvent& event)
{
	OnCheckListWindow(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckBoxBeg(wxCommandEvent& event)
{
	OnCheckBoxBeg(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckBoxEnd(wxCommandEvent& event)
{
	OnCheckBoxEnd(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckMonoLeft(wxCommandEvent& event)
{
	OnCheckMonoLeft(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckMonoRight(wxCommandEvent& event)
{
	OnCheckMonoRight(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckUseM3u(wxCommandEvent& event)
{
	OnCheckUseM3u(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckSinglePlay(wxCommandEvent& event)
{
	OnCheckSinglePlay(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckEqualizer(wxCommandEvent& event)
{
	OnCheckEqualizer(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckEffects(wxCommandEvent& event)
{
	OnCheckEffects(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckLimiter(wxCommandEvent& event)
{
	OnCheckLimiter(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckEqExtra(wxCommandEvent& event)
{
	OnCheckEqExtra(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckTitleInfo(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnCheckTitleInfo(0);
}


void MyFrame::OnGUICheckInvertRight(wxCommandEvent& event)
{
	OnCheckInvertRight(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckEq31Bands(wxCommandEvent& event)
{
	OnCheckEq31Bands(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckReptSong(wxCommandEvent& event)
{
	OnCheckReptSong(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckMonoDiff(wxCommandEvent& event)
{
	OnCheckMonoDiff(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUICheckBalance(wxCommandEvent& event)
{
	OnCheckBalance(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIButtonQuit(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonQuit();
}


void MyFrame::OnGUIButtonStop(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonStop();
}


void MyFrame::OnGUIButtonPrevious(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPrevious();
}


void MyFrame::OnGUIButtonPlay(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPlay();
}


void MyFrame::OnGUIButtonPause(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPause();
}


void MyFrame::OnGUIButtonNext(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonNext();
}


void MyFrame::OnGUISliderVolumeL(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnSliderVolumeL(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMEL));
}


void MyFrame::OnGUISliderVolumeR(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnSliderVolumeR(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMER));
}


void MyFrame::OnGUISliderSeparation(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnSliderSeparation(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMESEP));
}


void MyFrame::OnGUISliderPreamp(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnSliderPreamp(SliderGetValue(WINDOWAPP, ID_SLIDER_PREAMP));
}


void MyFrame::OnGUISliderPos(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnSliderPosition(HSliderGetValue(WINDOWAPP, ID_SLIDER_POSITION));
}


void MyFrame::OnGUIPopupOutput(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboOutput->Refresh();
	OnPopupOutput(m_ComboOutput->GetSelection());
}


void MyFrame::OnGUIPopupBuffer(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboBuffer->Refresh();
	OnPopupBuffer(m_ComboBuffer->GetSelection());
}


void MyFrame::OnGUISpinUpMem(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowBuffer(1);
}


void MyFrame::OnGUISpinDownBuffer(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowBuffer(-1);
}


void MyFrame::OnGUISpinUpPreamp(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowPreamp(1);
}


void MyFrame::OnGUISpinDownPreamp(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowPreamp(-1);
}


void MyFrame::OnGUISpinUpSep(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowSeparation(1);
}


void MyFrame::OnGUISpinDownSep(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowSeparation(-1);
}


void MyFrame::OnGUISpinUpVolR(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowVolumeR(1);
}


void MyFrame::OnGUISpinDownVolR(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowVolumeR(-1);
}


void MyFrame::OnGUISpinUpVolL(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowVolumeL(1);
}


void MyFrame::OnGUISpinDownVolL(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowVolumeL(-1);
}


void MyFrame::OnGUISpinUpBeg(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowBegin(1);
}


void MyFrame::OnGUISpinDownBeg(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowBegin(-1);
}


void MyFrame::OnGUISpinUpEnd(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowEnd(1);
}


void MyFrame::OnGUISpinDownEnd(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowEnd(-1);
}


#if defined(MAUSEMABUTTON)
 void MyFrame::MakeButtons()
 {
	wxStaticText *t;
	char label[32];
	
	wxImage *upOriginal = new wxImage(wxBitmap(BMUpButton).ConvertToImage());
	wxImage *downOriginal = new wxImage(wxBitmap(BMDownButton).ConvertToImage());
	wxImage *hiliteOriginal = new wxImage(wxBitmap(BMHiliteButton).ConvertToImage());

 #if defined(__MAOSX__) || defined(__MAUNIX__)
	m_upPattern = upOriginal;
	m_downPattern = downOriginal;
	m_hilitePattern = hiliteOriginal;
 #else
	wxColour newColour = wxSystemSettingsNative::GetColour(wxSYS_COLOUR_3DFACE);
	m_upPattern = ChangeImageColour(upOriginal, newColour);
	m_downPattern = ChangeImageColour(downOriginal, newColour);
	m_hilitePattern = ChangeImageColour(hiliteOriginal, newColour);
 #endif

	strcpy(label, LABEL_QUIT);
 #if defined(__WXX11__)
	strcat(label, "   "); // x11 needs 3 spaces for shortcuts
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_QUIT, wxT(label), wxPoint(m_ButtonPos + 14, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton((char const **)BMQuit, (char const **)BMQuitDisabled, (char const **)BMQuitMask, ID_BTN_QUIT, true);

	strcpy(label, LABEL_PREV);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_PREVIOUS,  wxT(label), wxPoint(m_ButtonPos + 6, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton((char const **)BMRewind, (char const **)BMRewindDisabled, (char const **)BMRewindMask, ID_BTN_PREVIOUS, true);

	strcpy(label, LABEL_PLAY);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_PLAY, wxT(label),	wxPoint(m_ButtonPos + 4, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton((char const **)BMPlay, (char const **)BMPlayDisabled, (char const **)BMPlayMask, ID_BTN_PLAY, true);

	strcpy(label, LABEL_PAUSE);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_PAUSE, wxT(label), wxPoint(m_ButtonPos, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton((char const **)BMPause, (char const **)BMPauseDisabled, (char const **)BMPauseMask, ID_BTN_PAUSE, true);
	
	strcpy(label, LABEL_STOP);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_STOP, wxT(label), wxPoint(m_ButtonPos + 4, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton((char const **)BMStop, (char const **)BMStopDisabled, (char const **)BMStopMask, ID_BTN_STOP, true);

	strcpy(label, LABEL_NEXT);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_NEXT, wxT(label), wxPoint(m_ButtonPos + 4, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton((char const **)BMFFwd, (char const **)BMFFwdDisabled, (char const **)BMFFwdMask, ID_BTN_NEXT, true);

 #if defined(__MAOSX__) || defined(__MAUNIX__)
 #else
	delete m_upPattern;
	delete m_downPattern;
	delete m_hilitePattern;
 #endif

	delete upOriginal;
	delete downOriginal;
	delete hiliteOriginal;

 } // MakeButtons


 #define BUTTONOFFSETX 16
 #define BUTTONOFFSETY 16
 MABUTTON *MyFrame::MakeButton(	char const **foreground, char const **disabled,
								char const **foremask, int id, bool processdownevents)
 {
	wxImage *color		= new wxImage(wxBitmap(foreground).ConvertToImage());
	wxImage *color_dis	= new wxImage(wxBitmap(disabled).ConvertToImage());
	wxImage *mask 		= new wxImage(wxBitmap(foremask).ConvertToImage());

	wxImage *up2 		= OverlayImage(m_upPattern,		color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *hilite2 	= OverlayImage(m_hilitePattern,	color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *down2		= OverlayImage(m_downPattern,	color,		mask,	BUTTONOFFSETX + 1,	BUTTONOFFSETY + 1);
	wxImage *disable2 	= OverlayImage(m_upPattern,		color_dis,	mask,	BUTTONOFFSETX,		BUTTONOFFSETY);

	MABUTTON *button	= new MABUTTON(MPANEL, id, wxPoint(m_ButtonPos, m_buttonTop),
										MABUTTONSIZE, up2, hilite2, down2, disable2, processdownevents);

	delete color;
	delete color_dis;
	delete mask;
	delete up2;
	delete down2;
	delete hilite2;
	delete disable2;

	m_ButtonPos += MABUTTONW;
	
	return button;
	
 } // MakeButton
#else // !MAUSEMABUTTON
 void MyFrame::MakeButtons()
 {
	wxStaticText *t;
	char label[32];

	strcpy(label, LABEL_QUIT);
 #if defined(__WXX11__)
	strcat(label, "   "); // x11 needs 3 spaces for shortcuts
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_QUIT, wxT("   "), wxPoint(m_ButtonPos + 14, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton(ID_BTN_QUIT, label);

	strcpy(label, LABEL_PREV);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_PREVIOUS, wxT("   "), wxPoint(m_ButtonPos + 6, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton(ID_BTN_PREVIOUS, label);
	
	strcpy(label, LABEL_PLAY);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_PLAY, wxT("   "), wxPoint(m_ButtonPos + 4, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton(ID_BTN_PLAY, label);

	strcpy(label, LABEL_PAUSE);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_PAUSE, wxT("   "), wxPoint(m_ButtonPos, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton(ID_BTN_PAUSE, label);
	
	strcpy(label, LABEL_STOP);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_STOP, wxT("   "), wxPoint(m_ButtonPos + 4, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton(ID_BTN_STOP, label);

	strcpy(label, LABEL_NEXT);
 #if defined(__WXX11__)
	strcat(label, "   ");
 #endif
	t = new wxStaticText(MPANEL, ID_TEXT_BUTTON_NEXT, wxT("   "), wxPoint(m_ButtonPos + 4, BUTTONTEXTY));
	MASETFONT(t);
	MakeButton(ID_BTN_NEXT, label);

 } // MakeButtons


 #define BUTTONOFFSETX 16
 #define BUTTONOFFSETY 16
 MABUTTON *MyFrame::MakeButton(int id, char *label)
 {
	MABUTTON *button = new MABUTTON(MPANEL, id, wxT(label), wxPoint(m_ButtonPos, m_buttonTop), MABUTTONSIZE);

	m_ButtonPos += MABUTTONW;
	
	return button;
	
 } // MakeButton
#endif // !MAUSEMABUTTON


#if(MAGUIWX == 4) // wx-2.4.2
 #define APPENDSEPARATOR() Append(-1, wxT(""))
 #define APPENDSUBMENU(a, b, c) Append(a, b, c)
#else
 #define APPENDSEPARATOR() AppendSeparator()
 #define APPENDSUBMENU(a, b, c) Append((int)a, (wxString const&)b, (wxMenu*)c, (wxString const&)( wxT("")))
#endif

void MyFrame::MakeMenus()
{
	// submenus
	l_theMenu[MENUTITLEINFO] = new wxMenu;

	((wxMenu *)l_theMenu[MENUTITLEINFO])->Append(ID_SUBMENU_TITLEINFO1, wxT("List Name"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUTITLEINFO])->Append(ID_SUBMENU_TITLEINFO2, wxT("Song Name"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUTITLEINFO])->Append(ID_SUBMENU_TITLEINFO3, wxT("Numbers"), wxT(""), wxITEM_CHECK);

	l_theMenu[MENUOPENRECENT] = new wxMenu;
	MakeSubMenusRecent();
	
	// file menu
	l_theMenu[MENUFILES] = new wxMenu;
	((wxMenu *)l_theMenu[MENUFILES])->Append(ID_MENU_OPENLIST,  wxT("Open Song List..."));
	((wxMenu *)l_theMenu[MENUFILES])->Append(ID_MENU_MAKELIST,	wxT("Make Song List..."));
	((wxMenu *)l_theMenu[MENUFILES])->Append(ID_MENU_SAVELISTAS,wxT("Save Song List As..."));
	((wxMenu *)l_theMenu[MENUFILES])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUFILES])->Append(ID_MENU_DELETELIST,wxT("Delete Song List..."));
	((wxMenu *)l_theMenu[MENUFILES])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUFILES])->Append(ID_MENU_PLAYFILE,  wxT("Play Song Files..."));
	((wxMenu *)l_theMenu[MENUFILES])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUFILES])->APPENDSUBMENU(ID_MENU_OPENRECENT, wxT("Open Recent..."), (wxMenu *)l_theMenu[MENUOPENRECENT]);
	((wxMenu *)l_theMenu[MENUFILES])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUFILES])->Append(ID_MENU_QUIT,		wxT("Quit"));

	// controls menu
	l_theMenu[MENUMACONTROLS] = new wxMenu;
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_STOP,		wxT("Stop"));
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_PAUSE,	wxT("Pause"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_PREVIOUS,	wxT("Previous"));
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_PLAY,		wxT("Play"));
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_NEXT,		wxT("Next"));
	((wxMenu *)l_theMenu[MENUMACONTROLS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_PLAYCD,	wxT("Play CD"));
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_EJECTCD,	wxT("Eject CD"));
	((wxMenu *)l_theMenu[MENUMACONTROLS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMACONTROLS])->Append(ID_MENU_AUDIOIN,	wxT("Audio In"));

	// settings menu
	l_theMenu[MENUMASETS] = new wxMenu;
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SAVEMASETS,		wxT("Save Settings"));
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SETSAVED,			wxT("Saved Settings"));
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SETDEFAULT,		wxT("Default Settings"));
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SETFACTORY,		wxT("Factory Settings"));
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SETCOPY,			wxT("Copy Settings..."));
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SAVEMASETSDEFAULT,wxT("Save Settings As Default"));
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_EQUALIZER,		wxT("Equalizer"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_EQ31BANDS,		wxT("Eq 31 Bands"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_EQEXTRA,			wxT("EqExtra"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_EFFECTS,			wxT("Effects"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_RANDOM,			wxT("Random"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_REPTPLAYED,		wxT("Repeat Played"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_LOOPLOADED,		wxT("Loop Loaded"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_LOOPLIST,			wxT("Loop List"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_MONO,				wxT("Mono"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_INVERTRIGHT,		wxT("Invert Right"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SINGLEPLAY,		wxT("Single Play"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_HIPRIORITY,		wxT("High Priority"), wxT(""), wxITEM_CHECK);
	
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSUBMENU(ID_MENU_TITLEINFO, wxT("Title Info..."), (wxMenu *)l_theMenu[MENUTITLEINFO]);

	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_AUTOSTART,		wxT("Auto Start"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_ERRLOGGING,		wxT("Error Logging"), wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SETVDISK,			wxT("Set Virtual Disk..."));
#if !defined(MANOCDA) && defined(__MAUNIX__)
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_SETAUDIOCD,		wxT("Set Audio CD Drives..."));
#endif
#if defined(MAINSTANCES)
	if(g_thisinstance == 1)
	{
		((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
		((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_MULTIPLEINST,	wxT("Multiple Instances"), wxT(""), wxITEM_CHECK);
	}
#endif
#if defined(MAKEYBOARD)
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_KEYBOARD,		wxT("Use Keyboard"), wxT(""), wxITEM_CHECK);	
#endif
#if defined(MAMOUSEWHEEL)
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_MOUSEWHEEL,	wxT("Use MouseWheel"), wxT(""), wxITEM_CHECK);	
#endif
	((wxMenu *)l_theMenu[MENUMASETS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUMASETS])->Append(ID_MENU_ADVANCED,		wxT("Advanced Settings..."));
	// tools menu
	l_theMenu[MENUTOOLS] = new wxMenu;
	((wxMenu *)l_theMenu[MENUTOOLS])->Append(ID_MENU_ZEROLIST,		wxT("Zero List"));
	((wxMenu *)l_theMenu[MENUTOOLS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUTOOLS])->Append(ID_MENU_MAKECATALOG,   wxT("Make Catalog"));
	((wxMenu *)l_theMenu[MENUTOOLS])->Append(ID_MENU_VIEWCATALOG,   wxT("View Catalog"));
	((wxMenu *)l_theMenu[MENUTOOLS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUTOOLS])->Append(ID_MENU_VIEWLOG,		wxT("View Log"));
	((wxMenu *)l_theMenu[MENUTOOLS])->Append(ID_MENU_CLEARLOG,		wxT("Clear Log"));
#if defined(MAKEYBOARD)
	((wxMenu *)l_theMenu[MENUTOOLS])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUTOOLS])->Append(ID_MENU_EDITKEYBINDINGS,wxT("Edit Key Bindings"));
	((wxMenu *)l_theMenu[MENUTOOLS])->Append(ID_MENU_BLANKKEYBINDINGS,wxT("Blank Key Bindings"));
#endif

	// window menu
	l_theMenu[MENUSHOW] = new wxMenu;
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_SHOWLIST,		wxT("Lists"),		wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_SHOWEQ,			wxT("Equalizer"),	wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_SHOWEFFECTS,	wxT("Effects"),		wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_SHOWFILEOUT,	wxT("File Output"),  wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUSHOW])->APPENDSEPARATOR();
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_ALTSIZE,		wxT("Alt Sizes"),	 wxT(""), wxITEM_CHECK);
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_SAVEDSIZE ,		wxT("Saved Sizes"),  wxT(""));
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_DEFAULTSIZE ,	wxT("Default Sizes"),wxT(""));
	((wxMenu *)l_theMenu[MENUSHOW])->Append(ID_MENU_FACTORYSIZE,	wxT("Factory Sizes"),wxT(""));

	l_theMenu[MENUHELP] = new wxMenu;
	((wxMenu *)l_theMenu[MENUHELP])->Append(ID_MENU_README, wxT(MAREADME));
	char cstr[256];
	sprintf(cstr, "About %s", MOREAMP_NAME);
	((wxMenu *)l_theMenu[MENUHELP])->Append(ID_MENU_ABOUT, wxT(cstr));
	
#if defined(__WXMAC__)
	 // About menu item gets relocated to Apple menu
	 wxApp::s_macAboutMenuItemId = ID_MENU_ABOUT;
#endif

	// menu bar
	wxMenuBar *menuBar = new wxMenuBar();
	g_menubar = menuBar;
	menuBar->Append((wxMenu *)l_theMenu[MENUFILES],
#if defined(__WXMAC__)
															wxT("&File")); // need '&File' for Apple menu
#else
															wxT("File"));
#endif
	menuBar->Append((wxMenu *)l_theMenu[MENUMACONTROLS],	wxT("Controls"));
	menuBar->Append((wxMenu *)l_theMenu[MENUMASETS],		wxT("Settings"));
	menuBar->Append((wxMenu *)l_theMenu[MENUTOOLS],			wxT("Tools"));
	menuBar->Append((wxMenu *)l_theMenu[MENUSHOW],			wxT("Show"));
	menuBar->Append((wxMenu *)l_theMenu[MENUHELP],
#if defined(__WXMAC__)
															wxT("&Help")); // need '&Help' for Apple menu
#else
															wxT("Help"));
#endif
	SetMenuBar(menuBar);

} // MakeMenus


void MyFrame::MakeSubMenusRecent()
{
	int i, n;
	char fname[OPENRECENTLENGTH];
	char items[MAXOPENRECENT][OPENRECENTLENGTH];

	n = (int)((wxMenu *)l_theMenu[MENUOPENRECENT])->GetMenuItemCount();
	for (i = 0; i < n; i++)
		((wxMenu *)l_theMenu[MENUOPENRECENT])->Destroy(ID_SUBMENU_OPENRECENT1 + i);
		
	if(!GetRecent(items))
		for (i = 0; i < MAXOPENRECENT; i++)
		{
			if(!items[i][0])
				break;
			 FilenameFromPathname(items[i], fname);
			((wxMenu *)l_theMenu[MENUOPENRECENT])->Append(ID_SUBMENU_OPENRECENT1 + i, wxT(fname));
		}

} // MakeSubMenusRecent

	
void MyFrame::OnAbout(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	maViewAbout();
 }


void MyFrame::OnGUIMenuQuit(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonQuit();
}


void MyFrame::OnGUIMenuSetVDisk(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSetVDisk();
}


#if defined(MAINSTANCES)
void MyFrame::OnGUIMenuMultipleInst(wxCommandEvent& event)
{
	OnMenuMultipleInst(event.IsChecked() ? 1 : 0);
}
#endif


#if defined(MAKEYBOARD)
void MyFrame::OnGUIMenuKeyboard(wxCommandEvent& event)
{
	OnMenuKeyboard(event.IsChecked() ? 1 : 0);
}
#endif


#if defined(MAMOUSEWHEEL)
void MyFrame::OnGUIMenuMouseWheel(wxCommandEvent& event)
{
	OnMenuMouseWheel(event.IsChecked() ? 1 : 0);
}
#endif


void MyFrame::OnGUIMenuAdvanced(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	DoWindowAdvanced(1);
}


#if !defined(MANOCDA) && defined(__MAUNIX__)
void MyFrame::OnGUIMenuSetAudioCD(wxCommandEvent& event)
{
 (void)event;

	DoWindowAudioCD(1);
}
#endif


void MyFrame::OnGUIMenuSaveSettings(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSave();
}


void MyFrame::OnGUIMenuSaveSettingsDefault(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuAsDefaults();
}


void MyFrame::OnGUIMenuSetFactory(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSetFactory();
}


void MyFrame::OnGUIMenuSetDefault(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSetDefault();
}


void MyFrame::OnGUIMenuSetSaved(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSetSaved();
}


void MyFrame::OnGUIMenuSetCopy(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSetCopy();
}


void MyFrame::OnGUIMenuStop(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonStop();
}


void MyFrame::OnGUIMenuPause(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPause();
}


void MyFrame::OnGUIMenuPrevious(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPrevious();
}


void MyFrame::OnGUIMenuPlay(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPlay();
}


void MyFrame::OnGUIMenuNext(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonNext();
}


void MyFrame::OnGUIMenuPlayCD(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuPlayCD();
}


void MyFrame::OnGUIMenuTitleInfo(wxCommandEvent& event)
{
	if(event.GetId() == ID_SUBMENU_TITLEINFO2)
		OnCheckTitleInfo(2);
	else if(event.GetId() == ID_SUBMENU_TITLEINFO3)
		OnCheckTitleInfo(3);
	else
		OnCheckTitleInfo(1);
}


void MyFrame::OnGUIMenuRandom(wxCommandEvent& event)
{
	OnMenuRandom(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuReptPlayed(wxCommandEvent& event)
{
	OnMenuReptPlayed(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuLoopLoaded(wxCommandEvent& event)
{
	OnMenuLoopLoaded(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuLoopList(wxCommandEvent& event)
{
	OnMenuLoopList(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuAutoStart(wxCommandEvent& event)
{
	OnMenuAutoStart(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuErrLogging(wxCommandEvent& event)
{
	OnMenuErrLogging(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuSinglePlay(wxCommandEvent& event)
{
	OnMenuSinglePlay(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuHiPriority(wxCommandEvent& event)
{
	OnMenuHiPriority(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuEqualizer(wxCommandEvent& event)
{
	OnMenuEqualizer(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuEqExtra(wxCommandEvent& event)
{
	OnMenuEqExtra(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuEffects(wxCommandEvent& event)
{
	OnMenuEffects(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuMono(wxCommandEvent& event)
{
	OnMenuMono(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuInvertRight(wxCommandEvent& event)
{
	OnMenuInvertRight(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuEq31Bands(wxCommandEvent& event)
{
	OnMenuEq31Bands(event.IsChecked() ? 1 : 0);
}


void MyFrame::OnGUIMenuOpenList(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuOpenList();
}


void MyFrame::OnGUIMenuMakeList(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuMakeList();
}


void MyFrame::OnGUIMenuSaveListAs(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSaveListAs();
}


void MyFrame::OnGUIMenuDeleteList(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuDeleteList();
}


void MyFrame::OnGUIMenuPlayFile(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuPlayFile();
}


void MyFrame::OnGUIMenuOpenRecent(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuOpenRecent(event.GetId() - ID_SUBMENU_OPENRECENT1);
}


void MyFrame::OnGUIMenuZeroList(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuZero();
}


void MyFrame::OnGUIMenuEjectCD(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuEjectCD();
}


void MyFrame::OnGUIMenuAudioIn(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuAudioIn();
}


void MyFrame::OnGUIMenuMakeCatalog(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuMakeCatalog();
}


void MyFrame::OnGUIMenuShowList(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuList();
}


void MyFrame::OnGUIMenuShowEq(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuEqWindow();
}


void MyFrame::OnGUIMenuShowEffects(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuEffectsWindow();
}


void MyFrame::OnGUIMenuShowFileOut(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuFileOut();
}


void MyFrame::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonQuit();
	
}


// To toggle the window between alt sizes with the mac zoom box
// assume any resize >= maxsize  is from the zoom box.
// Settings must have sane values for alt sizes.
// (don't know how else to recognize zoom box event on Mac)
// This may not work as expected on all platforms
void MyFrame::OnGUISize(wxSizeEvent& event)
{
	if(!g_w[WINDOWAPP])
		return;
	
	wxSize s = GetSize();
	wxSize d = wxGetDisplaySize();
	wxSize maxsize = wxSize(d.x - 19, d.y - 55);
	
	if(s.x >= maxsize.x && s.y >= maxsize.y) // zoom box click (or huge window resize)
	{
		g_sets.winconf = g_sets.winconf ? 0 : 1; // toggle
		MenuSetChecked(MENUSHOW, ID_MENU_ALTSIZE, g_sets.winconf ? 1 : 0);
		CheckBoxSetValue(WINDOWAPP, ID_CHK_ALTSIZE, g_sets.winconf ? 1 : 0);
		SetSize(g_sets.xpos[g_sets.winconf], g_sets.ypos[g_sets.winconf],
										g_sets.xsize[g_sets.winconf], g_sets.ysize[g_sets.winconf]);
	}
	else
		OnSize(event);
	
	WindowGetCoordinates(WINDOWAPP, &g_sets.xpos[g_sets.winconf], &g_sets.ypos[g_sets.winconf],
									&g_sets.xsize[g_sets.winconf], &g_sets.ysize[g_sets.winconf]);

} // OnGUISize


void MyFrame::OnGUIMenuAltSize(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuAltSize(event.IsChecked() ? 1 : 0, 0);
			
} // OnGUIMenuAltSize


void MyFrame::OnGUIMenuSavedSize(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuSavedSize(0);
								
} // OnGUIMenuSavedSize


void MyFrame::OnGUIMenuDefaultSize(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuDefaultSize(0);
								
} // OnGUIMenuDefaultSize


void MyFrame::OnGUIMenuFactorySize(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuFactorySize(0);

} // OnGUIMenuFactorySize


void MyFrame::OnGUIMenuReadme(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuReadme();

} // OnGUIMenuReadme


void MyFrame::OnGUIMenuViewCatalog(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuViewCatalog();
}


void MyFrame::OnGUIMenuViewLog(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuViewLog();	
}

#if defined(MAKEYBOARD)
void MyFrame::OnGUIMenuEditKeyBindings(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuEditKeyBindings();	
}


void MyFrame::OnGUIMenuBlankKeyBindings(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuBlankKeyBindings();	
}
#endif


void MyFrame::OnGUIMenuClearLog(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnMenuClearLog();	
}


void MyFrame::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWAPP])
		return;
	
	int dummy;	
	int x, y;
	
	wxSize s = GetSize();
	wxSize d = wxGetDisplaySize();
	wxSize maxsize = wxSize(d.x - 19, d.y - 55);
	
	if(s.x >= maxsize.x && s.y >= maxsize.y) // a zoom box click moved the window
		return;
		
	x = g_sets.xpos[g_sets.winconf];
	y = g_sets.ypos[g_sets.winconf];

	WindowGetCoordinates(WINDOWAPP, &g_sets.xpos[g_sets.winconf], &g_sets.ypos[g_sets.winconf], &dummy, &dummy);

	OnWindowMoved(WINDOWAPP, g_sets.xpos[g_sets.winconf] - x, g_sets.ypos[g_sets.winconf] - y);

} // OnGUIMove


void MyFrame::OnTimerPlaySonglist(wxTimerEvent& event)
{
	(void)event;

	m_timerplaysonglist->Stop();
	PlaySonglistB(g_newsonglist);
	
} // OnTimerPlaySonglist


void MyFrame::OnTimerStop(wxTimerEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_timerstop->Stop();
	PushButtonSimulateClick(WINDOWAPP, ID_BTN_STOP);
	
} // OnTimerStop


void MyFrame::OnTimerRunLoop(wxTimerEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_timerrunloop->Stop();
	RunLoop(NULL);
	
} // OnTimerRunLoop


void MyFrame::OnTimerPlay(wxTimerEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_timerplay->Stop();
	PushButtonSimulateClick(WINDOWAPP, ID_BTN_PLAY);
	
} // OnTimerPlay


MyFrameList::MyFrameList(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
						: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	int mx; // e.g. 1024
	int my; // e.g.  768
	wxSize maxsize;
	
	DisplayGetSize(&mx, &my);
	maxsize.x = mx;
	maxsize.y = my;

#if !defined(MANOWXPANEL)
	m_panel = new wxPanel(this, -1, wxDefaultPosition, maxsize, wxCLIP_CHILDREN | wxNO_BORDER);
#endif

#if defined(MAKEYBOARD)
	m_cbdummy =  // for maOnChar focus
		new wxCheckBox(MPANEL, wxID_ANY, wxT(""), wxPoint(XBASE, YBASE + MENUBARH), wxSize(1, 1));
#endif

	// list buttons
	m_ButtonPos = XBASE;
	m_buttonTop = YBASE + MENUBARH; // line up buttons with main window buttons
	MakeButtonsList();
	
	// list checkboxes
	new MACHECKBOX(MPANEL, ID_CHK_SHOWINDEX, wxT("Show index"), wxPoint(m_ButtonPos + 4, YBASE + MENUBARH +  3), CBSIZ);
	new MACHECKBOX(MPANEL, ID_CHK_SHOWDIR,   wxT("Show dir"),   wxPoint(m_ButtonPos + 4, YBASE + MENUBARH + 19), CBSIZ);
	new MACHECKBOX(MPANEL, ID_CHK_SHOWPATH,  wxT("Show path"),  wxPoint(m_ButtonPos + 4, YBASE + MENUBARH + 35), CBSIZ);
	new MACHECKBOX(MPANEL, ID_CHK_ADDMODE,   wxT("Add mode"),   wxPoint(m_ButtonPos + 84, YBASE + MENUBARH + 3), CBSIZ);

	// list
#if(defined(__WXMAC__) || defined(__WXGTK__)) && (MAGUIWX != 4) && (LISTXSIZEDEF > 200)
	#define LISTW 200 // else vscrollbar disappears in small window
	#define LISTH 100 // else hscrollbar disappears in small window
#else
	#define LISTW LISTXSIZEDEF
	#define LISTH (LISTYSIZEDEF - MENUBARH - MABUTTONH - 4)
#endif
	#define LISTSIZE wxSize(LISTW, LISTH)
	#define LISTPOS wxPoint(XBASE, YBASE + MENUBARH + MABUTTONH + 4)

#if defined(__WXMSW__)
	#define LISTMAXW (LISTW - SCROLLERWIDTH - 10)
#else
	#define LISTMAXW LISTW
#endif
	
	m_list = new wxListCtrl(MPANEL, ID_LIST_CTRL, LISTPOS, LISTSIZE,
			wxLC_REPORT | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL | wxLC_HRULES | wxLC_NO_SORT_HEADER);
	MASETFONT(m_list);
	m_list->InsertColumn(0, wxEmptyString, wxLIST_FORMAT_LEFT, LISTMAXW);

#ifdef MADRAGANDDROP
	SetDropTarget(new DnDFile());
	m_list->SetDropTarget(new DnDFile());
#endif

#if defined(MAKEYBOARD)
	Connect(wxID_ANY, wxEVT_LEFT_UP,
		(wxObjectEventFunction)(wxEventFunction)(wxMouseEventFunction) &MyApp::maOnClick, NULL);
	m_cbdummy->SetFocus(); // for maOnChar focus
#endif

} // MyFrameList


MyFrameList::~MyFrameList()
{
}


void MyFrameList::OnGUIButtonLoaded(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonLoaded();
}


#if defined(MAUSEMABUTTON)
 void MyFrameList::MakeButtonsList()
 {
	wxImage *upOriginal = new wxImage(wxBitmap(BMUpButton).ConvertToImage());
	wxImage *downOriginal = new wxImage(wxBitmap(BMDownButton).ConvertToImage());
	wxImage *hiliteOriginal = new wxImage(wxBitmap(BMHiliteButton).ConvertToImage());

 #if defined(__MAOSX__) || defined(__MAUNIX__)
	m_upPattern = upOriginal;
	m_downPattern = downOriginal;
	m_hilitePattern = hiliteOriginal;
 #else
	wxColour newColour = wxSystemSettingsNative::GetColour(wxSYS_COLOUR_3DFACE);
	m_upPattern = ChangeImageColour(upOriginal, newColour);
	m_downPattern = ChangeImageColour(downOriginal, newColour);
	m_hilitePattern = ChangeImageColour(hiliteOriginal, newColour);
#endif

	MakeButtonList((char const **)BMInfo, (char const **)BMInfoDisabled, (char const **)BMInfoMask, ID_BTN_INFO, true);

	MakeButtonList((char const **)BMSonglist, (char const **)BMSonglistDisabled, (char const **)BMSonglistMask, ID_BTN_SONGLIST, true);

	MakeButtonList((char const **)BMLoaded, (char const **)BMLoadedDisabled, (char const **)BMLoadedMask, ID_BTN_LOADED, true);

	MakeButtonList((char const **)BMSonginfo, (char const **)BMSonginfoDisabled, (char const **)BMSonginfoMask, ID_BTN_SONGINFO, true);

 #if defined(__MAOSX__) || defined(__MAUNIX__)
 #else
	delete m_upPattern;
	delete m_downPattern;
	delete m_hilitePattern;
 #endif

	delete upOriginal;
	delete downOriginal;
	delete hiliteOriginal;

} // MakeButtonsList


MABUTTON *MyFrameList::MakeButtonList(	char const **foreground, char const **disabled,
										char const **foremask, int id, bool processdownevents)
{
	wxImage *color		= new wxImage(wxBitmap(foreground).ConvertToImage());
	wxImage *color_dis	= new wxImage(wxBitmap(disabled).ConvertToImage());
	wxImage *mask 		= new wxImage(wxBitmap(foremask).ConvertToImage());

	wxImage *up2 		= OverlayImage(m_upPattern,		color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *hilite2 	= OverlayImage(m_hilitePattern,	color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *down2		= OverlayImage(m_downPattern,	color,		mask,	BUTTONOFFSETX + 1,	BUTTONOFFSETY + 1);
	wxImage *disable2 	= OverlayImage(m_upPattern,		color_dis,	mask,	BUTTONOFFSETX,		BUTTONOFFSETY);

	MABUTTON *button	= new MABUTTON(MPANEL, id, wxPoint(m_ButtonPos, m_buttonTop),
										MABUTTONSIZE, up2, hilite2, down2, disable2, processdownevents);

	delete color;
	delete color_dis;
	delete mask;
	delete up2;
	delete down2;
	delete hilite2;
	delete disable2;

	m_ButtonPos += MABUTTONW;

	return button;
	
} // MakeButtonList
#else // !MAUSEMABUTTON
void MyFrameList::MakeButtonsList()
{
	MakeButtonList(ID_BTN_INFO, (char *)"Info");

	MakeButtonList(ID_BTN_SONGLIST, (char *)"List");

	MakeButtonList(ID_BTN_LOADED, (char *)"Load");

	MakeButtonList(ID_BTN_SONGINFO, (char *)"Song");

} // MakeButtonsList


MABUTTON *MyFrameList::MakeButtonList(int id, char *label)
{
	MABUTTON *button = new MABUTTON(MPANEL, id, wxT(label), wxPoint(m_ButtonPos, m_buttonTop), MABUTTONSIZE);

	m_ButtonPos += MABUTTONW;

	return button;

} // MakeButtonList
#endif // !MAUSEMABUTTON


void MyFrameList::OnGUIButtonList(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonList();
}


void MyFrameList::OnGUIButtonInfo(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonInfo();
}


void MyFrameList::OnGUIButtonSong(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonSong();
}


void MyFrameList::OnGUICheckShowIndex(wxCommandEvent& event)
{
	OnCheckShowIndex(event.IsChecked() ? 1 : 0);
}


void MyFrameList::OnGUICheckShowDir(wxCommandEvent& event)
{
	OnCheckShowDir(event.IsChecked() ? 1 : 0);
}


void MyFrameList::OnGUICheckShowPath(wxCommandEvent& event)
{
	OnCheckShowPath(event.IsChecked() ? 1 : 0);
}


void MyFrameList::OnGUICheckAddMode(wxCommandEvent& event)
{
	OnCheckAddMode(event.IsChecked() ? 1 : 0);
}


void MyFrameList::OnGUIListSelected(wxListEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnListWindowSingleClick(0);
}


void MyFrameList::OnGUIListActivated(wxListEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnListWindowDoubleClick();
}


void MyFrameList::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedList();
	this->Destroy();
}


void MyFrameList::GetColumn0Width()
{
	int width = m_list->GetColumnWidth(0);
	if(width < (g_sets.listxsize[g_sets.winconf] - SCROLLERWIDTH))
		width = g_sets.listxsize[g_sets.winconf] - SCROLLERWIDTH;
		
	switch(g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
	{
		case LBOXINFO:
			g_sets.listcolxsize[g_sets.winconf][0] = width;
		break;
		case LBOXLIST:
			g_sets.listcolxsize[g_sets.winconf][1] = width;
		break;
		case LBOXLOADED:
			g_sets.listcolxsize[g_sets.winconf][2] = width;
		break;
		case LBOXID3:
			g_sets.listcolxsize[g_sets.winconf][3] = width;
		break;
		default:
		break;
	}
}

void MyFrameList::OnGUIColumnEndDrag(wxListEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	GetColumn0Width();

} // OnGUIColumnEndDrag


void MyFrameList::SetColumn0Width(int width)
{
	if(!g_w[WINDOWLIST])
		return;

	if(width <= 0)
	{
		switch(g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
		{
			case LBOXINFO:
				m_list->SetColumnWidth(0, g_sets.listcolxsize[g_sets.winconf][0]);
			break;
			case LBOXLIST:
				m_list->SetColumnWidth(0, g_sets.listcolxsize[g_sets.winconf][1]);
			break;
			case LBOXLOADED:
				m_list->SetColumnWidth(0, g_sets.listcolxsize[g_sets.winconf][2]);
			break;
			case LBOXID3:
				m_list->SetColumnWidth(0, g_sets.listcolxsize[g_sets.winconf][3]);
			break;
			default:
			break;
		}
	}
	else
	{
		m_list->SetColumnWidth(0, width);
		GetColumn0Width();
	}
		
} // SetColumn0Width


void MyFrameList::OnGUISize(wxSizeEvent& event)
{
	if(!g_w[WINDOWLIST])
		return;
	
	OnSize(event);
	
	WindowGetCoordinates(WINDOWLIST, &g_sets.listxpos[g_sets.winconf], &g_sets.listypos[g_sets.winconf],
									&g_sets.listxsize[g_sets.winconf], &g_sets.listysize[g_sets.winconf]);

	SetColumn0Width(g_sets.listxsize[g_sets.winconf] - SCROLLERWIDTH);
		
} // OnGUISize


void MyFrameList::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWLIST])
		return;
	
	int dummy;	
	WindowGetCoordinates(WINDOWLIST, &g_sets.listxpos[g_sets.winconf], &g_sets.listypos[g_sets.winconf], &dummy, &dummy);

} // OnGUIMove


void MyFrameList::OnSize(wxSizeEvent& event)
{
	if(m_list)
	{
		wxSize size = GetClientSize();
		m_list->SetSize(0, MENUBARH + MABUTTONH + 4, size.x,  size.y - MENUBARH - MABUTTONH - 4);
		m_list->SetColumnWidth(0, size.x - SCROLLERWIDTH);
	}
	event.Skip();
}


MyFrameEq::MyFrameEq(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
						: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	int i;
	wxStaticText *t;
	
#if !defined(MANOWXPANEL)
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
#endif
	
#if defined(MAKEYBOARD)
	// having a wxListCtrl makes kb focus work...
	new wxListCtrl(MPANEL, -1, wxPoint(0, 0), wxSize(1, 1),
		wxLC_REPORT | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL | wxLC_HRULES | wxLC_NO_SORT_HEADER);
#endif

	// equalizer buttons
	m_ButtonPos = XBASE;
	m_buttonTop = YBASE + MENUBARH; // line up buttons with main window buttons
	MakeButtonsEq();

	#define PREX (XBASE + 544)
	#define PREY (YBASE + 29 + MENUBARH)

	// equalizer checkbox
	MACHECKBOX *c = new MACHECKBOX(MPANEL, ID_CHK_EQUALIZERB,  wxT("Equalizer"),	wxPoint(PREX - 90,  PREY - 28),	CBSIZ);
	c->SetValue((g_sets.eqflags & MAEQACTIVE) ? true : false);

				c = new MACHECKBOX(MPANEL, ID_CHK_EQ31BANDSB,  wxT("Eq31Bands"),	wxPoint(PREX - 90,  PREY - 10),	CBSIZ);
	c->SetValue((g_sets.eqflags & MAEQ31BANDS) ? true : false);

			c = new MACHECKBOX(MPANEL,		ID_CHK_EQEXTRAB,	wxT("EqExtra"),		wxPoint(PREX - 90,  PREY +  8),	CBSIZ);
	c->SetValue((g_sets.eqflags & MAEQEXTRA) ? true : false);

	// zoom checkbox
				c = new MACHECKBOX(MPANEL,		ID_CHK_EQZOOM,		wxT("Zoom"),		wxPoint(PREX - 14,	PREY - 28),	CBSIZ3);
	c->SetValue((g_sets.eqflags & MAEQZOOM) ? true : false);

	// link checkbox
				c =	new MACHECKBOX(MPANEL,		ID_CHK_EQLINK,		wxT("Link"),		wxPoint(PREX - 14,	PREY - 10),	CBSIZ3);
	c->SetValue((g_sets.eqflags & MAEQLINK) ? true : false);

	// separate left/right checkbox
				c = new MACHECKBOX(MPANEL, ID_CHK_SEPARATELR, wxT("Separate L/R"),		wxPoint(PREX - 14,  PREY + 8), CBSIZ);
	c->SetValue((g_sets.eqflags & MASEPARATELR) ? true : false);

	// offset spin
	t = new wxStaticText(MPANEL,	ID_TEXT_EQOFFSET,	wxT("Offset dB"),	wxPoint(PREX + 42,	PREY - 28));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,	ID_TEXT_EQOFFSETVAL,wxT("000"),			wxPoint(PREX + 61,	PREY - 10));
	MASETFONT(t);
	wxSpinButton *s = new wxSpinButton(MPANEL,	ID_SPIN_EQOFFSET,		wxPoint(PREX + 42,	PREY - 16),	SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);
	
	// presets popup
	t = new wxStaticText(MPANEL,	ID_TEXT_EQPRESET,	wxT("Preset"),		wxPoint(PREX + 106,	PREY - 28));
	MASETFONT(t);
	
	m_ComboPreset = new wxComboBox(MPANEL,		ID_POPUP_EQPRESET,	wxT(""),	wxPoint(PREX + 100,	PREY - 15), wxSize(88, 20), 0, NULL, wxCB_READONLY);
	MASETFONT(m_ComboPreset); // doesn't on all platforms
	
 	for(i = 0; i < EQNUMPRESETS; i++) // PopupButtonAppend
 	{
 		if(strlen(g_sets.eqpresets[i].eqname) == 0 || g_sets.eqpresets[i].eqname[0] == ' ')
 			sprintf(g_sets.eqpresets[i].eqname, "Preset%d", i + 1);
 		m_ComboPreset->Append(wxT(g_sets.eqpresets[i].eqname));
	}
	
	// preset name editor
	t = new wxStaticText(MPANEL, ID_TEXT_EQEDIT, wxT("Preset Name"), wxPoint(PREX + 106, PREY +  8));
	MASETFONT(t);
#if defined(MAKEYBOARD)
	m_dummytexteq = new wxTextCtrl(MPANEL, wxID_ANY, wxT(""), wxPoint(PREX + 108, PREY + 24), wxSize(1, 1), wxTE_PROCESS_ENTER);
#endif
	m_edittexteq = new wxTextCtrl(MPANEL, ID_EDITTEXT_EQ, wxT(""), wxPoint(PREX + 104, PREY + 20), EDSIZ, wxTE_PROCESS_ENTER);
	
	// equalizer sliders
	#define SLX (XBASE)
	#define SLXDEL 24
	#define STXPOS (stxpos += SLXDEL)
	#define SLXPOS (slxpos += SLXDEL)
	#define TEXPOS (texpos += SLXDEL)
	#define SPXPOS (spxpos += SLXDEL)
	#define T0YPOS (SLYPOS +  67)
	#define SLYPOS (YBASE + 80 + MENUBARH)

	int stxpos = SLX - SLXDEL;
	int slxpos = SLX - SLXDEL;
	int texpos = SLX - SLXDEL - 1;
	int spxpos = SLX - SLXDEL + 2;

	#define YSTAGGER 12
	int ystagger;
	
	const char *label;
	int lstyle;
	for(i = 0; i < EQBANDS31; i++)
	{
		lstyle = wxSL_VERTICAL;
		switch(i)
		{
			case  0 : label = "20Hz";   break;
			case  1 : label = "25";		break;
			case  2 : label = "31.5";	lstyle = 0x8000 | wxSL_VERTICAL; break; // use BMSliderThumbA
			case  3 : label = "40";		break;
			case  4 : label = "50";		break;
			case  5 : label = "63";		lstyle = 0x8000 | wxSL_VERTICAL; break;
			case  6 : label = "80";		break;
			case  7 : label = "100";	break;
			case  8 : label = "125";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case  9 : label = "160";	break;
			case 10 : label = "200";	break;
			case 11 : label = "250";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 12 : label = "315";	break;
			case 13 : label = "400";	break;
			case 14 : label = "500";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 15 : label = "630";	break;
			case 16 : label = "800";	break;
			case 17 : label = "1kHz";   lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 18 : label = "1.25";	break;
			case 19 : label = "1.6";	break;
			case 20 : label = "2.0";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 21 : label = "2.5";	break;
			case 22 : label = "3.15";	break;
			case 23 : label = "4.0";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 24 : label = "5.0";	break;
			case 25 : label = "6.3";	break;
			case 26 : label = "8.0";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 27 : label = "10";		break;
			case 28 : label = "12.5";	break;
			case 29 : label = "16";		lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 30 : label = "20";		break;
			default : label = "";		break;
		}
		
		if(i % 2)
			ystagger = YSTAGGER;
		else
			ystagger = 0;
		
		t = new wxStaticText(MPANEL, ID_TEXT_EQBAND0 + i, wxT(label), wxPoint(STXPOS, SLYPOS - 6 + ystagger));
		MASETFONT(t);
	
		new MASLIDER(MPANEL, ID_SLIDER_EQ0 + i, (DBSLIDERMAX - DBSLIDERMIN) / 2, DBSLIDERMIN, DBSLIDERMAX,
																	wxPoint(SLXPOS, SLYPOS + 21), wxSize(20, 102), lstyle);

		t = new wxStaticText(MPANEL, ID_TEXT_EQ0 + i, wxT("0000"),		wxPoint(TEXPOS, SLYPOS + 124 + ystagger), wxDefaultSize, wxALIGN_CENTRE);
		MASETFONT(t);
	
		s = new wxSpinButton(MPANEL, ID_SPIN_EQ0 + i, wxPoint(SPXPOS + 2, SLYPOS + 137 + YSTAGGER), SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
		s->SetRange(INT_MIN, INT_MAX);
		s->SetValue(0);
	}

#if defined(MAKEYBOARD)
	m_ComboPreset->SetFocus(); // for maOnChar focus
#endif

} // MyFrameEq


MyFrameEq::~MyFrameEq()
{
}


#if defined(MAUSEMABUTTON)
void MyFrameEq::MakeButtonsEq()
{
	wxStaticText *t;
	
	wxImage *upOriginal = new wxImage(wxBitmap(BMUpButton).ConvertToImage());
	wxImage *downOriginal = new wxImage(wxBitmap(BMDownButton).ConvertToImage());
	wxImage *hiliteOriginal = new wxImage(wxBitmap(BMHiliteButton).ConvertToImage());

#if defined(__MAOSX__) || defined(__MAUNIX__)
	m_upPattern = upOriginal;
	m_downPattern = downOriginal;
	m_hilitePattern = hiliteOriginal;
#else
	wxColour newColour = wxSystemSettingsNative::GetColour(wxSYS_COLOUR_3DFACE);
	m_upPattern = ChangeImageColour(upOriginal, newColour);
	m_downPattern = ChangeImageColour(downOriginal, newColour);
	m_hilitePattern = ChangeImageColour(hiliteOriginal, newColour);
#endif

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_ZOOM,	wxT("- Zoom/Offset +"),  wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq(BMMinus, (char const **)BMMinusDisabled,   (char const **)BMMinusMask, ID_BTN_EQMINUS, true);
	MakeButtonEq((char const **)BMPlus, (char const **)BMPlusDisabled,  (char const **)BMPlusMask,  ID_BTN_EQPLUS, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_MID,		wxT("Mid"),			wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMMid, (char const **)BMMidMask,		(char const **)BMMidMask,   ID_BTN_EQMID, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_COPY,	wxT("Copy"),			wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMCopy, (char const **)BMCopyDisabled,  (char const **)BMCopyMask,  ID_BTN_EQCOPY, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_PASTE,   wxT("Paste"),		wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMPaste, (char const **)BMPasteDisabled,(char const **)BMPasteMask, ID_BTN_EQPASTE, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_RESET,   wxT("Reset"),		wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMReset, (char const **)BMResetDisabled,(char const **)BMResetMask, ID_BTN_EQRESTORE, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_SHIFTL,  wxT("ShiftLeft"),	wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMShiftL, (char const **)BMShiftLMask,  (char const **)BMShiftLMask, ID_BTN_EQSHIFTL, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_SHIFTR,  wxT("ShiftRigh"),	wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMShiftR, (char const **)BMShiftRMask,  (char const **)BMShiftRMask, ID_BTN_EQSHIFTR, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_INVERT,  wxT(" Invert"),		wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMInvert, (char const **)BMInvertMask,  (char const **)BMInvertMask, ID_BTN_EQINVERT, true);

#if defined(__MAOSX__) || defined(__MAUNIX__)
#else
	delete m_upPattern;
	delete m_downPattern;
	delete m_hilitePattern;
#endif

	delete upOriginal;
	delete downOriginal;
	delete hiliteOriginal;

} // MakeButtonsEq


MABUTTON *MyFrameEq::MakeButtonEq(	char const **foreground, char const **disabled,
									char const **foremask, int id, bool processdownevents)
{
	wxImage *color		= new wxImage(wxBitmap(foreground).ConvertToImage());
	wxImage *color_dis	= new wxImage(wxBitmap(disabled).ConvertToImage());
	wxImage *mask 		= new wxImage(wxBitmap(foremask).ConvertToImage());

	wxImage *up2 		= OverlayImage(m_upPattern,		color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *hilite2 	= OverlayImage(m_hilitePattern,	color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *down2		= OverlayImage(m_downPattern,	color,		mask,	BUTTONOFFSETX + 1,	BUTTONOFFSETY + 1);
	wxImage *disable2 	= OverlayImage(m_upPattern,		color_dis,	mask,	BUTTONOFFSETX,		BUTTONOFFSETY);

	MABUTTON *button	= new MABUTTON(MPANEL, id, wxPoint(m_ButtonPos, m_buttonTop),
										MABUTTONSIZE, up2, hilite2, down2, disable2, processdownevents);
	delete color;
	delete color_dis;
	delete mask;
	delete up2;
	delete down2;
	delete hilite2;
	delete disable2;

	m_ButtonPos += MABUTTONW;

	return button;
	
} // MakeButtonEq
#else // !MAUSEMABUTTON
void MyFrameEq::MakeButtonsEq()
{
	MakeButtonEq(ID_BTN_EQMINUS, (char *)"Zoom -");
	MakeButtonEq(ID_BTN_EQPLUS, (char *)"Zoom +");
	MakeButtonEq(ID_BTN_EQMID, (char *)"Mid");
	MakeButtonEq(ID_BTN_EQCOPY, (char *)"Copy");
	MakeButtonEq(ID_BTN_EQPASTE, (char *)"Paste");
	MakeButtonEq(ID_BTN_EQRESTORE, (char *)"Reset");
	MakeButtonEq(ID_BTN_EQSHIFTL, (char *)"ShiftLeft");
	MakeButtonEq(ID_BTN_EQSHIFTR, (char *)"ShiftRigh");
	MakeButtonEq(ID_BTN_EQINVERT, (char *)"Invert");

} // MakeButtonsEq


MABUTTON *MyFrameEq::MakeButtonEq(int id, char *label)
{
	MABUTTON *button = new MABUTTON(MPANEL, id, wxT(label), wxPoint(m_ButtonPos, m_buttonTop), MABUTTONSIZE);

	m_ButtonPos += MABUTTONW;

	return button;
	
} // MakeButtonEq
#endif // !MAUSEMABUTTON


void MyFrameEq::OnGUICheckEqZoom(wxCommandEvent& event)
{
	OnCheckEqZoom(event.IsChecked() ? 1 : 0);
}


void MyFrameEq::OnGUICheckEqLink(wxCommandEvent& event)
{
	OnCheckEqLink(event.IsChecked() ? 1 : 0);
}


void MyFrameEq::OnGUICheckEqualizerB(wxCommandEvent& event)
{
	OnCheckEqualizerB(event.IsChecked() ? 1 : 0);
}


void MyFrameEq::OnGUICheckEq31BandsB(wxCommandEvent& event)
{
	OnCheckEq31BandsB(event.IsChecked() ? 1 : 0);
}


void MyFrameEq::OnGUICheckEqExtraB(wxCommandEvent& event)
{
	OnCheckEqExtraB(event.IsChecked() ? 1 : 0);
}


void MyFrameEq::OnGUICheckSeparateLR(wxCommandEvent& event)
{
	OnCheckSeparateLR(event.IsChecked() ? 1 : 0);
}


void MyFrameEq::OnGUIButtonEqMinus(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqMinus();
}


void MyFrameEq::OnGUIButtonEqPlus(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqPlus();
}


void MyFrameEq::OnGUIButtonEqMid(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqMid();
}


void MyFrameEq::OnGUIButtonEqCopy(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqCopy();
}


void MyFrameEq::OnGUIButtonEqPaste(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqPaste();
}


void MyFrameEq::OnGUIButtonEqRestore(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqRestore();
}


void MyFrameEq::OnGUIButtonEqShiftL(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqShiftL();
}


void MyFrameEq::OnGUIButtonEqShiftR(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqShiftR();
}


void MyFrameEq::OnGUIButtonEqInvert(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEqInvert();
}


void MyFrameEq::OnGUIPopupEqPreset(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboPreset->Refresh();
	OnPopupEqPreset(m_ComboPreset->GetSelection());
}


void MyFrameEq::OnGUIEditTextEq(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif
	OnEditTextEq();
}


void MyFrameEq::OnGUISliderEq(wxCommandEvent& event)
{
	OnSliderEq(event.GetId() - ID_SLIDER_EQ0, SliderGetValue(WINDOWEQ, event.GetId()), 0);
}


void MyFrameEq::OnGUISpinUpEqOffset(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowEqOffset(1);
}


void MyFrameEq::OnGUISpinDownEqOffset(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowEqOffset(-1);
}


void MyFrameEq::OnGUISpinUpEq(wxSpinEvent& event)
{
	OnLittleArrowEq(event.GetId() - ID_SPIN_EQ0, 1);
}


void MyFrameEq::OnGUISpinDownEq(wxSpinEvent& event)
{
	OnLittleArrowEq(event.GetId() - ID_SPIN_EQ0, -1);
}


void MyFrameEq::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedEq();
	this->Destroy();
}


void MyFrameEq::OnGUISize(wxSizeEvent& event)
{
	int dummy;
	
	if(!g_w[WINDOWEQ])
		return;
	
	OnSize(event);
	
	WindowGetCoordinates(WINDOWEQ, &dummy, &dummy, &g_sets.eqxsize[g_sets.winconf], &g_sets.eqysize[g_sets.winconf]);

} // OnGUISize


void MyFrameEq::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWEQ])
		return;
	
	int dummy;	
	WindowGetCoordinates(WINDOWEQ, &g_sets.eqxpos[g_sets.winconf], &g_sets.eqypos[g_sets.winconf], &dummy, &dummy);

} // OnGUIMove



MyFrameEq2::MyFrameEq2(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
						: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	int i;
	wxStaticText *t;
	
#if !defined(MANOWXPANEL)
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
#endif
	
#if defined(MAKEYBOARD)
	// having a wxListCtrl makes kb focus work...
	new wxListCtrl(MPANEL, -1, wxPoint(0, 0), wxSize(1, 1),
		wxLC_REPORT | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL | wxLC_HRULES | wxLC_NO_SORT_HEADER);
#endif

	// equalizer buttons
	m_ButtonPos = XBASE + MABUTTONW + MABUTTONW;
	m_buttonTop = YBASE + MENUBARH; // line up buttons with main window buttons
	MakeButtonsEq();

	#define PREX (XBASE + 544)
	#define PREY (YBASE + 29 + MENUBARH)

	// equalizer2 sliders
	#define SLX (XBASE)
	#define SLXDEL 24
	#define STXPOS (stxpos += SLXDEL)
	#define SLXPOS (slxpos += SLXDEL)
	#define TEXPOS (texpos += SLXDEL)
	#define SPXPOS (spxpos += SLXDEL)
	#define T0YPOS (SLYPOS +  67)
	#define SLYPOS (YBASE + 80 + MENUBARH)

	int stxpos = SLX - SLXDEL;
	int slxpos = SLX - SLXDEL;
	int texpos = SLX - SLXDEL - 1;
	int spxpos = SLX - SLXDEL + 2;

	#define YSTAGGER 12
	int ystagger;
	
	const char *label;
	int lstyle;
	for(i = 0; i < EQBANDS31; i++)
	{
		lstyle = wxSL_VERTICAL;
		switch(i)
		{
			case  0 : label = "20Hz";   break;
			case  1 : label = "25";		break;
			case  2 : label = "31.5";	lstyle = 0x8000 | wxSL_VERTICAL; break; // use BMSliderThumbA
			case  3 : label = "40";		break;
			case  4 : label = "50";		break;
			case  5 : label = "63";		lstyle = 0x8000 | wxSL_VERTICAL; break;
			case  6 : label = "80";		break;
			case  7 : label = "100";	break;
			case  8 : label = "125";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case  9 : label = "160";	break;
			case 10 : label = "200";	break;
			case 11 : label = "250";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 12 : label = "315";	break;
			case 13 : label = "400";	break;
			case 14 : label = "500";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 15 : label = "630";	break;
			case 16 : label = "800";	break;
			case 17 : label = "1kHz";   lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 18 : label = "1.25";	break;
			case 19 : label = "1.6";	break;
			case 20 : label = "2.0";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 21 : label = "2.5";	break;
			case 22 : label = "3.15";	break;
			case 23 : label = "4.0";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 24 : label = "5.0";	break;
			case 25 : label = "6.3";	break;
			case 26 : label = "8.0";	lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 27 : label = "10";		break;
			case 28 : label = "12.5";	break;
			case 29 : label = "16";		lstyle = 0x8000 | wxSL_VERTICAL; break;
			case 30 : label = "20";		break;
			default : label = "";		break;
		}
		
		if(i % 2)
			ystagger = YSTAGGER;
		else
			ystagger = 0;
		
		t = new wxStaticText(MPANEL, ID_TEXT_EQ2BAND0 + i, wxT(label), wxPoint(STXPOS, SLYPOS - 6 + ystagger));
		MASETFONT(t);
	
		new MASLIDER(MPANEL, ID_SLIDER_EQ2_0 + i, (DBSLIDERMAX - DBSLIDERMIN) / 2, DBSLIDERMIN, DBSLIDERMAX,
																	wxPoint(SLXPOS, SLYPOS + 21), wxSize(20, 102), lstyle);

		t = new wxStaticText(MPANEL, ID_TEXT_EQ2_0 + i, wxT("0000"),		wxPoint(TEXPOS, SLYPOS + 124 + ystagger), wxDefaultSize, wxALIGN_CENTRE);
		MASETFONT(t);
	
		wxSpinButton *s = new wxSpinButton(MPANEL, ID_SPIN_EQ2_0 + i, wxPoint(SPXPOS + 2, SLYPOS + 137 + YSTAGGER), SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
		s->SetRange(INT_MIN, INT_MAX);
		s->SetValue(0);
	}

} // MyFrameEq2


MyFrameEq2::~MyFrameEq2()
{
}


#if defined(MAUSEMABUTTON)
void MyFrameEq2::MakeButtonsEq()
{
	wxStaticText *t;
	
	wxImage *upOriginal = new wxImage(wxBitmap(BMUpButton).ConvertToImage());
	wxImage *downOriginal = new wxImage(wxBitmap(BMDownButton).ConvertToImage());
	wxImage *hiliteOriginal = new wxImage(wxBitmap(BMHiliteButton).ConvertToImage());

#if defined(__MAOSX__) || defined(__MAUNIX__)
	m_upPattern = upOriginal;
	m_downPattern = downOriginal;
	m_hilitePattern = hiliteOriginal;
#else
	wxColour newColour = wxSystemSettingsNative::GetColour(wxSYS_COLOUR_3DFACE);
	m_upPattern = ChangeImageColour(upOriginal, newColour);
	m_downPattern = ChangeImageColour(downOriginal, newColour);
	m_hilitePattern = ChangeImageColour(hiliteOriginal, newColour);
#endif

	/*
	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_ZOOM,	wxT("- Zoom/Offset +"),  wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq(BMMinus, (char const **)BMMinusDisabled,   (char const **)BMMinusMask, ID_BTN_EQMINUS, true);
	MakeButtonEq((char const **)BMPlus, (char const **)BMPlusDisabled,  (char const **)BMPlusMask,  ID_BTN_EQPLUS, true);
	*/
	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_MID,		wxT("Mid"),			wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMMid, (char const **)BMMidMask,		(char const **)BMMidMask,   ID_BTN_EQ2MID, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_COPY,	wxT("Copy"),			wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMCopy, (char const **)BMCopyDisabled,  (char const **)BMCopyMask,  ID_BTN_EQ2COPY, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_PASTE,   wxT("Paste"),		wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMPaste, (char const **)BMPasteDisabled,(char const **)BMPasteMask, ID_BTN_EQ2PASTE, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_RESET,   wxT("Reset"),		wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMReset, (char const **)BMResetDisabled,(char const **)BMResetMask, ID_BTN_EQ2RESTORE, true);
	/*
	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_SHIFTL,  wxT("ShiftLeft"),	wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMShiftL, (char const **)BMShiftLMask,  (char const **)BMShiftLMask, ID_BTN_EQSHIFTL, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_SHIFTR,  wxT("ShiftRigh"),	wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMShiftR, (char const **)BMShiftRMask,  (char const **)BMShiftRMask, ID_BTN_EQSHIFTR, true);

	t = new wxStaticText(MPANEL, ID_TEXT_EQBUTTON_INVERT,  wxT(" Invert"),		wxPoint(m_ButtonPos, BUTTONTEXTY + MENUBARH));
	MASETFONT(t);
	MakeButtonEq((char const **)BMInvert, (char const **)BMInvertMask,  (char const **)BMInvertMask, ID_BTN_EQINVERT, true);
	*/
	
#if defined(__MAOSX__) || defined(__MAUNIX__)
#else
	delete m_upPattern;
	delete m_downPattern;
	delete m_hilitePattern;
#endif

	delete upOriginal;
	delete downOriginal;
	delete hiliteOriginal;

} // MakeButtonsEq


MABUTTON *MyFrameEq2::MakeButtonEq(	char const **foreground, char const **disabled,
									char const **foremask, int id, bool processdownevents)
{
	wxImage *color		= new wxImage(wxBitmap(foreground).ConvertToImage());
	wxImage *color_dis	= new wxImage(wxBitmap(disabled).ConvertToImage());
	wxImage *mask 		= new wxImage(wxBitmap(foremask).ConvertToImage());

	wxImage *up2 		= OverlayImage(m_upPattern,		color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *hilite2 	= OverlayImage(m_hilitePattern,	color,		mask,	BUTTONOFFSETX,		BUTTONOFFSETY);
	wxImage *down2		= OverlayImage(m_downPattern,	color,		mask,	BUTTONOFFSETX + 1,	BUTTONOFFSETY + 1);
	wxImage *disable2 	= OverlayImage(m_upPattern,		color_dis,	mask,	BUTTONOFFSETX,		BUTTONOFFSETY);

	MABUTTON *button	= new MABUTTON(MPANEL, id, wxPoint(m_ButtonPos, m_buttonTop),
										MABUTTONSIZE, up2, hilite2, down2, disable2, processdownevents);
	delete color;
	delete color_dis;
	delete mask;
	delete up2;
	delete down2;
	delete hilite2;
	delete disable2;

	m_ButtonPos += MABUTTONW;

	return button;
	
} // MakeButtonEq
#else // !MAUSEMABUTTON
void MyFrameEq2::MakeButtonsEq()
{
	MakeButtonEq(ID_BTN_EQ2MID, (char *)"Mid");
	MakeButtonEq(ID_BTN_EQ2COPY, (char *)"Copy");
	MakeButtonEq(ID_BTN_EQ2PASTE, (char *)"Paste");
	MakeButtonEq(ID_BTN_EQRESTORE, (char *)"Reset");
	/*
	MakeButtonEq(ID_BTN_EQSHIFTL, (char *)"ShiftLeft");
	MakeButtonEq(ID_BTN_EQSHIFTR, (char *)"ShiftRigh");
	MakeButtonEq(ID_BTN_EQINVERT, (char *)"Invert");
	*/
} // MakeButtonsEq


MABUTTON *MyFrameEq2::MakeButtonEq(int id, char *label)
{
	MABUTTON *button = new MABUTTON(MPANEL, id, wxT(label), wxPoint(m_ButtonPos, m_buttonTop), MABUTTONSIZE);

	m_ButtonPos += MABUTTONW;

	return button;
	
} // MakeButtonEq
#endif // !MAUSEMABUTTON


void MyFrameEq2::OnGUIButtonEqMid(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEq2Mid();
}


void MyFrameEq2::OnGUIButtonEqCopy(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEq2Copy();
}


void MyFrameEq2::OnGUIButtonEqPaste(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEq2Paste();
}


void MyFrameEq2::OnGUIButtonEqRestore(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonEq2Restore();
}


void MyFrameEq2::OnGUISliderEq(wxCommandEvent& event)
{
	OnSliderEq2(event.GetId() - ID_SLIDER_EQ0, SliderGetValue(WINDOWEQ2, event.GetId()), 0);
}


void MyFrameEq2::OnGUISpinUpEqOffset(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowEq2Offset(1);
}


void MyFrameEq2::OnGUISpinDownEqOffset(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowEq2Offset(-1);
}


void MyFrameEq2::OnGUISpinUpEq(wxSpinEvent& event)
{
	OnLittleArrowEq2(event.GetId() - ID_SPIN_EQ0, 1);
}


void MyFrameEq2::OnGUISpinDownEq(wxSpinEvent& event)
{
	OnLittleArrowEq2(event.GetId() - ID_SPIN_EQ0, -1);
}


void MyFrameEq2::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedEq2();
	this->Destroy();
}


void MyFrameEq2::OnGUISize(wxSizeEvent& event)
{
	int dummy;
	
	if(!g_w[WINDOWEQ2])
		return;
	
	OnSize(event);
	
	WindowGetCoordinates(WINDOWEQ2, &dummy, &dummy, &g_sets.eq2xsize[g_sets.winconf], &g_sets.eq2ysize[g_sets.winconf]);

} // OnGUISize


void MyFrameEq2::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWEQ2])
		return;
	
	int dummy;	
	WindowGetCoordinates(WINDOWEQ2, &g_sets.eq2xpos[g_sets.winconf], &g_sets.eq2ypos[g_sets.winconf], &dummy, &dummy);

} // OnGUIMove


MyFrameEffects::MyFrameEffects(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
						: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	#define EFFX  (XBASE + 32)
	#define EFFY  (YBASE + 22)
	#define EFFDELX (60)
	#define EFFCBY (EFFY + 167)
	wxSpinButton *s;
	wxStaticText *t;
	
#if !defined(MANOWXPANEL)
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
#endif
	
#if defined(MAKEYBOARD)
	// having a wxListCtrl makes kb focus work...
	new wxListCtrl(MPANEL, -1, wxPoint(0, 0), wxSize(1, 1),
		wxLC_REPORT | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL | wxLC_HRULES | wxLC_NO_SORT_HEADER);
#endif

	// pitch
	t = new wxStaticText(MPANEL,   -1,				wxT("Pitch"),		wxPoint(EFFX - 2,				EFFY -  16));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   -1,				wxT("   semitones"), wxPoint(EFFX - 2,				EFFY -   1));
	MASETFONT(t);
	new MASLIDER(MPANEL,			ID_SLIDER_PITCH, EFFECTSPITCHMAX / 2, EFFECTSPITCHMIN, EFFECTSPITCHMAX,
																		wxPoint(EFFX,					EFFY +  21),	wxSize( 20, 102), wxSL_VERTICAL);
	t = new wxStaticText(MPANEL,   ID_TEXT_PITCH0, wxT("-000"),		wxPoint(EFFX,					EFFY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_PITCH,						wxPoint(EFFX + 2,				EFFY + 137), SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	t = new wxStaticText(MPANEL,   -1,				wxT("Pitch"),		wxPoint(EFFX + EFFDELX - 2,		EFFY -  16));
	MASETFONT(t);
	new MASLIDER(MPANEL,			ID_SLIDER_PITCH2, EFFECTSMAX / 2, EFFECTSMIN, EFFECTSMAX,
																		wxPoint(EFFX + EFFDELX,			EFFY +  21),	wxSize( 20, 102), wxSL_VERTICAL);
	t = new wxStaticText(MPANEL,   ID_TEXT_PITCH02, wxT("-00.0"),		wxPoint(EFFX + EFFDELX,			EFFY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_PITCH2,						wxPoint(EFFX + EFFDELX + 2,		EFFY + 137), SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	// duplicate main effects switch
	m_checkbox =
	new MACHECKBOX(MPANEL,			ID_CHK_EFFECTSB, wxT("Effects"),	wxPoint(EFFX + 2, EFFCBY),	CBSIZ, 1); // red
	
	new MACHECKBOX(MPANEL,			ID_CHK_PITCH,   wxT("Pitch"),		wxPoint(EFFX + EFFDELX + 2, EFFCBY), CBSIZ);

	// tempo
	t = new wxStaticText(MPANEL,   -1,				wxT("Tempo"),		wxPoint(EFFX + 2 * EFFDELX - 2, EFFY -  16));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   -1,				wxT("  x"),			wxPoint(EFFX + 2 * EFFDELX - 2, EFFY -   1));
	MASETFONT(t);
	new MASLIDER(MPANEL,			ID_SLIDER_TEMPO, EFFECTSMAX / 2, EFFECTSMIN, EFFECTSMAX,
																		wxPoint(EFFX + 2 * EFFDELX,		EFFY +  21), wxSize( 20, 102), wxSL_VERTICAL);
	t = new wxStaticText(MPANEL,   ID_TEXT_TEMPO0, wxT("-000"),		wxPoint(EFFX + 2 * EFFDELX,		EFFY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_TEMPO,						wxPoint(EFFX + 2 * EFFDELX + 2, EFFY + 137), SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	new MACHECKBOX(MPANEL,			ID_CHK_TEMPO,   wxT("Tempo"),		wxPoint(EFFX + 2 * EFFDELX + 2, EFFCBY), CBSIZ);

	// speed
	t = new wxStaticText(MPANEL,   -1,				wxT("Speed"),		wxPoint(EFFX + 3 * EFFDELX - 2,	EFFY -  16));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   -1,				wxT("   x"),		wxPoint(EFFX + 3 * EFFDELX - 2, EFFY -   1));
	MASETFONT(t);
	new MASLIDER(MPANEL,			ID_SLIDER_SPEED, EFFECTSMAX / 2, EFFECTSMIN, EFFECTSMAX,
																		wxPoint(EFFX + 3 * EFFDELX,		EFFY +  21), wxSize( 20, 102), wxSL_VERTICAL);
	t = new wxStaticText(MPANEL,   ID_TEXT_SPEED0, wxT("-000"),		wxPoint(EFFX + 3 * EFFDELX,		EFFY + 124));
	MASETFONT(t);
	s = new wxSpinButton(MPANEL,	ID_SPIN_SPEED,						wxPoint(EFFX + 3 * EFFDELX + 2,	EFFY + 137), SPSIZ, wxSP_VERTICAL | wxSP_WRAP);
	s->SetRange(INT_MIN, INT_MAX);
	s->SetValue(0);

	new MACHECKBOX(MPANEL,			ID_CHK_SPEED, wxT("Speed"),			wxPoint(EFFX + 3 * EFFDELX + 2,	EFFCBY), CBSIZ);

	// quality
	new MACHECKBOX(MPANEL,			ID_CHK_QUALFILTER, wxT("No AA Filter"),  wxPoint(EFFX + 2,				EFFCBY + 30), CBSIZ, 1); // red
	new MACHECKBOX(MPANEL,			ID_CHK_QUALSPEED, wxT("Low Qual Tempo"), wxPoint(EFFX + 2 * EFFDELX + 2, EFFCBY + 30), CBSIZ, 1); // red
	
	// keyboard shortcut labels
	#undef EFFX
	#define EFFX (XBASE + 32 + 22)
	#undef EFFY
	#define EFFY  (YBASE + 22 + 137)

	t = new wxStaticText(MPANEL,   ID_TEXT_KEYEFECTS,		wxT(""),		wxPoint(EFFX - 20,				EFFY + 43));
	MASETFONT(t);

	t = new wxStaticText(MPANEL,   ID_TEXT_KEYPITCHUP,		wxT(""),		wxPoint(EFFX - 2,				EFFY + 0));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYPITCHDOWN,   wxT(""),		wxPoint(EFFX - 2,				EFFY + 11));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYPITCHSET,	wxT(""),		wxPoint(EFFX + EFFDELX - 20,	EFFY + 43));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYPITCH2UP,	wxT(""),		wxPoint(EFFX + EFFDELX - 2,		EFFY + 0));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYPITCH2DOWN,  wxT(""),		wxPoint(EFFX + EFFDELX - 2,		EFFY + 11));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYPITCHRESET,  wxT(""),		wxPoint(EFFX + EFFDELX - 0,		EFFY - 71));
	MASETFONT(t);

	t = new wxStaticText(MPANEL,   ID_TEXT_KEYTEMPOSET,	wxT(""),		wxPoint(EFFX + 2 * EFFDELX - 20,EFFY + 43));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYTEMPOUP,		wxT(""),		wxPoint(EFFX + 2 * EFFDELX - 2, EFFY + 0));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYTEMPODOWN,   wxT(""),		wxPoint(EFFX + 2 * EFFDELX - 2,	EFFY + 11));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYTEMPORESET,  wxT(""),		wxPoint(EFFX + 2 * EFFDELX - 0,	EFFY - 51));
	MASETFONT(t);

	t = new wxStaticText(MPANEL,   ID_TEXT_KEYSPEEDSET,	wxT(""),		wxPoint(EFFX + 3 * EFFDELX - 20,EFFY + 43));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYSPEEDUP,		wxT(""),		wxPoint(EFFX + 3 * EFFDELX - 2, EFFY + 0));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYSPEEDDOWN,   wxT(""),		wxPoint(EFFX + 3 * EFFDELX - 2,	EFFY + 11));
	MASETFONT(t);
	t = new wxStaticText(MPANEL,   ID_TEXT_KEYSPEEDRESET,  wxT(""),		wxPoint(EFFX + 3 * EFFDELX - 0,	EFFY - 51));
	MASETFONT(t);
	
#if defined(MAKEYBOARD)
	m_checkbox->SetFocus(); // for maOnChar focus
#endif

} // MyFrameEffects


MyFrameEffects::~MyFrameEffects()
{
}


void MyFrameEffects::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedEffects();
	this->Destroy();
}


void MyFrameEffects::OnGUISliderPitch(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(event.GetInt() == -1) // double-clicked to reset to saved value
	{
		SliderSetValue(WINDOWEFFECTS, ID_SLIDER_PITCH, g_setsbu.pitchslider);
		OnSliderPitch(g_setsbu.pitchslider);
	}
	else
		OnSliderPitch(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_PITCH));
}


void MyFrameEffects::OnGUISliderPitch2(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(event.GetInt() == -1) // double-clicked to reset to saved value
	{
		SliderSetValue(WINDOWEFFECTS, ID_SLIDER_PITCH2, g_setsbu.pitchslider2);
		OnSliderPitch2(g_setsbu.pitchslider2);
	}
	else
		OnSliderPitch2(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_PITCH2));
}


void MyFrameEffects::OnGUISliderTempo(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(event.GetInt() == -1) // double-clicked to reset to saved value
	{
		SliderSetValue(WINDOWEFFECTS, ID_SLIDER_TEMPO, g_setsbu.temposlider);
		OnSliderTempo(g_setsbu.temposlider);
	}
	else
		OnSliderTempo(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_TEMPO));
}


void MyFrameEffects::OnGUISliderSpeed(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(event.GetInt() == -1) // double-clicked to reset to saved value
	{
		SliderSetValue(WINDOWEFFECTS, ID_SLIDER_SPEED, g_setsbu.speedslider);
		OnSliderSpeed(g_setsbu.speedslider);
	}
	else
		OnSliderSpeed(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_SPEED));
}


void MyFrameEffects::OnGUISpinDownPitch(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowPitch(-1);
}


void MyFrameEffects::OnGUISpinDownPitch2(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowPitch2(-1);
}


void MyFrameEffects::OnGUISpinDownTempo(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowTempo(-1);
}


void MyFrameEffects::OnGUISpinDownSpeed(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowSpeed(-1);
}


void MyFrameEffects::OnGUISpinUpPitch(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowPitch(1);
}


void MyFrameEffects::OnGUISpinUpPitch2(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowPitch2(1);
}


void MyFrameEffects::OnGUISpinUpTempo(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowTempo(1);
}


void MyFrameEffects::OnGUISpinUpSpeed(wxSpinEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnLittleArrowSpeed(1);
}


void MyFrameEffects::OnGUICheckPitch(wxCommandEvent& event)
{
	OnCheckPitch(event.IsChecked() ? 1 : 0);
}


void MyFrameEffects::OnGUICheckTempo(wxCommandEvent& event)
{
	OnCheckTempo(event.IsChecked() ? 1 : 0);
}


void MyFrameEffects::OnGUICheckSpeed(wxCommandEvent& event)
{
	OnCheckSpeed(event.IsChecked() ? 1 : 0);
}


void MyFrameEffects::OnGUICheckQualSpeed(wxCommandEvent& event)
{
	OnCheckQualSpeed(event.IsChecked() ? 1 : 0);
}


void MyFrameEffects::OnGUICheckQualFilter(wxCommandEvent& event)
{
	OnCheckQualFilter(event.IsChecked() ? 1 : 0);
}


void MyFrameEffects::OnGUICheckEffectsB(wxCommandEvent& event)
{
	OnCheckEffectsB(event.IsChecked() ? 1 : 0);
}


void MyFrameEffects::OnGUISize(wxSizeEvent& event)
{
	int dummy;
	
	if(!g_w[WINDOWEFFECTS])
		return;
	
	OnSize(event);
	
	WindowGetCoordinates(WINDOWEFFECTS, &dummy, &dummy, &g_sets.effectsxsize[g_sets.winconf], &g_sets.effectsysize[g_sets.winconf]);

} // OnGUISize


void MyFrameEffects::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWEFFECTS])
		return;
	
	int dummy;	
	WindowGetCoordinates(WINDOWEFFECTS, &g_sets.effectsxpos[g_sets.winconf], &g_sets.effectsypos[g_sets.winconf], &dummy, &dummy);

} // OnGUIMove


#if !defined(MANOCDA) && defined(__MAUNIX__)
MyFrameAudioCD::MyFrameAudioCD(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
								: wxFrame((wxWindow *)NULL, -1, title, pos, siz, style)
{
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);

	m_ComboAudioCD = new wxComboBox(m_panel, ID_POPUP_AUDIOCD,  wxT(""), wxPoint(130, 11), wxSize(120, 20), 0, NULL, wxCB_READONLY);
	MASETFONT(m_ComboAudioCD); // doesn't on all platforms
	
	new wxButton(m_panel, ID_BTN_AUDIOCDSET,	wxT("Set the drive"),	wxPoint(5, 10));

	new wxButton(m_panel, wxID_OK,				wxT("Close"),			wxPoint(130, 90));

	new wxButton(m_panel, ID_BTN_AUDIOCDCLEAR,  wxT("Clear the drive"),  wxPoint(5, 50));

	new wxButton(m_panel, ID_BTN_AUDIOCDSAVE,   wxT("Save settings"),	wxPoint(5, 90));

	new MACHECKBOX(m_panel, ID_CHK_CDPARANOIA,  wxT("CD Paranoia"),		wxPoint(138, 55), CBSIZ, 1); // red
	
} // MyFrameAudioCD


MyFrameAudioCD::~MyFrameAudioCD()
{
}


void MyFrameAudioCD::OnButtonClose(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	this->Destroy();
	g_w[WINDOWAUDIOCD] = NULL;
}


void MyFrameAudioCD::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedAudioCD();
	this->Destroy();
}


void MyFrameAudioCD::OnGUIPopupAudioCD(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboAudioCD->Refresh();
	OnPopupAudioCD(m_ComboAudioCD->GetSelection());
}


void MyFrameAudioCD::OnGUIButtonAudioCDSet(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonAudioCDSet();
}

void MyFrameAudioCD::OnGUIButtonAudioCDClear(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonAudioCDClear();
}


void MyFrameAudioCD::OnGUIButtonAudioCDSave(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonAudioCDSave();
}


void MyFrameAudioCD::OnGUICheckCdParanoia(wxCommandEvent& event)
{
	OnCheckCdParanoia(event.IsChecked() ? 1 : 0);
}

void MyFrameAudioCD::OnGUISize(wxSizeEvent& event)
{
	int dummy;
	
	if(!g_w[WINDOWAUDIOCD])
		return;
	
	OnSize(event);
	
	WindowGetCoordinates(WINDOWAUDIOCD, &dummy, &dummy, &g_setscdrom.winw[g_sets.winconf],
														&g_setscdrom.winh[g_sets.winconf]);

} // OnGUISize


void MyFrameAudioCD::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWAUDIOCD])
		return;
	
	int dummy;	
	WindowGetCoordinates(WINDOWAUDIOCD, &g_setscdrom.winx[g_sets.winconf],
										&g_setscdrom.winy[g_sets.winconf], &dummy, &dummy);

} // OnGUIMove
#endif


MyFrameFileOut::MyFrameFileOut(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
				: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	wxStaticText *t;
	
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
	
	#undef POPX
	#undef POPY
	#define POPX (XBASE + 20)
	#define POPY (-20)
	#define POPW (160)
	#define POPH (20)
	#define POPXT (POPX)
	#define POPYT (POPY - 12)
	#define YDEL 34
		
	t = new wxStaticText(   m_panel, -1,				wxT("Put new files in folder"),				wxPoint(POPXT,  POPYT + 1 * YDEL + 2));
	MASETFONT(t);
	t = new wxStaticText(   m_panel, ID_TEXT_FILEOUTDIR ,wxT(g_sets.fileout[g_k[g_sets.output]].outdir),  wxPoint(POPXT,  POPYT + 1 * YDEL + 18));
	MASETFONT(t);
						
	new wxButton(		m_panel, ID_BTN_FILEOUTDIR, wxT("Change folder"),							wxPoint(POPXT,  POPYT + 2 * YDEL));
	

#if defined(ENCODEMP3) || defined(ENCODEOGG) || defined(ENCODAAC) || defined(ENCODEMP4)
		switch(g_sets.output)
		{		
 #ifdef ENCODEMP3
			case kOUTMP3 :
						 t = new wxStaticText(  m_panel, -1,		wxT("Bitrate"),  wxPoint(POPXT,  POPYT + 3 * YDEL));
						 MASETFONT(t);
		m_ComboBitRate = new wxComboBox(		m_panel, ID_POPUP_BITRATE,  wxT(""), wxPoint(POPX,   POPY  + 3 * YDEL),   wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboBitRate); // doesn't on all platforms
		m_ComboBitRate->Append(wxT("32 (lower quality, smaller files)"));
		m_ComboBitRate->Append(wxT("40"));
		m_ComboBitRate->Append(wxT("48"));
		m_ComboBitRate->Append(wxT("56"));
		m_ComboBitRate->Append(wxT("64"));
		m_ComboBitRate->Append(wxT("80"));
		m_ComboBitRate->Append(wxT("96"));
		m_ComboBitRate->Append(wxT("112"));
		m_ComboBitRate->Append(wxT("128 (default)"));
		m_ComboBitRate->Append(wxT("160"));
		m_ComboBitRate->Append(wxT("192"));
		m_ComboBitRate->Append(wxT("224"));
		m_ComboBitRate->Append(wxT("256"));
		m_ComboBitRate->Append(wxT("320 (high quality, bigger files)"));

							t = new wxStaticText(   m_panel, -1,		wxT("Quality"),  wxPoint(POPXT,  POPYT + 4 * YDEL));
							MASETFONT(t);
		m_ComboQuality =	new wxComboBox(		m_panel, ID_POPUP_QUALITY,  wxT(""),		wxPoint(POPX,   POPY  + 4 * YDEL),  wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboQuality); // doesn't on all platforms
		m_ComboQuality->Append(wxT("0 (high quality, slow encode)"));
		m_ComboQuality->Append(wxT("1"));
		m_ComboQuality->Append(wxT("2 (default)"));
		m_ComboQuality->Append(wxT("3"));
		m_ComboQuality->Append(wxT("4"));
		m_ComboQuality->Append(wxT("5"));
		m_ComboQuality->Append(wxT("6"));
		m_ComboQuality->Append(wxT("7"));
		m_ComboQuality->Append(wxT("8"));
		m_ComboQuality->Append(wxT("9"));
		m_ComboQuality->Append(wxT("10 (lower quality, fast encode)"));

					  t = new wxStaticText( m_panel, -1,		wxT("Mode"), wxPoint(POPXT,  POPYT + 5 * YDEL));
					  MASETFONT(t);
		m_ComboMode = new wxComboBox(   m_panel, ID_POPUP_MODE, wxT(""),		wxPoint(POPX,   POPY  + 5 * YDEL),  wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboMode); // doesn't on all platforms
		m_ComboMode->Append(wxT("Stereo (default)"));
		m_ComboMode->Append(wxT("Joint Stereo"));
		m_ComboMode->Append(wxT("Dual Stereo"));
		m_ComboMode->Append(wxT("Mono"));

							t = new wxStaticText(m_panel, -1,   wxT("Sample Rate"),	wxPoint(POPXT,  POPYT + 6 * YDEL));
							MASETFONT(t);
		m_ComboSampleRate = new wxComboBox(  m_panel, ID_POPUP_SAMPLERATE, wxT(""),  wxPoint(POPX,   POPY  + 6 * YDEL),  wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboSampleRate); // doesn't on all platforms
		m_ComboSampleRate->Append(wxT("Auto"));
		//m_ComboSampleRate->Append(wxT(" 8000")); // crashes on OSX
		m_ComboSampleRate->Append(wxT("11025"));
		m_ComboSampleRate->Append(wxT("12000"));
		m_ComboSampleRate->Append(wxT("16000"));
		m_ComboSampleRate->Append(wxT("22050"));
		m_ComboSampleRate->Append(wxT("24000"));
		m_ComboSampleRate->Append(wxT("32000"));
		m_ComboSampleRate->Append(wxT("44100 (default)"));
		m_ComboSampleRate->Append(wxT("48000"));
		m_ComboSampleRate->Append(wxT("Same as input"));

			break;
 #endif
 
 #ifdef ENCODEOGG
			case kOUTOGG :
						 t = new wxStaticText(  m_panel, -1,			wxT("Bitrate"),  wxPoint(POPXT,  POPYT + 3 * YDEL));
						 MASETFONT(t);
		m_ComboBitRate = new wxComboBox(	m_panel, ID_POPUP_BITRATE,  wxT(""),			wxPoint(POPX,   POPY  + 3 * YDEL),   wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboBitRate); // doesn't on all platforms
		m_ComboBitRate->Append(wxT("32 (lower quality, smaller files)"));
		m_ComboBitRate->Append(wxT("40"));
		m_ComboBitRate->Append(wxT("48"));
		m_ComboBitRate->Append(wxT("56"));
		m_ComboBitRate->Append(wxT("64"));
		m_ComboBitRate->Append(wxT("80"));
		m_ComboBitRate->Append(wxT("96"));
		m_ComboBitRate->Append(wxT("112"));
		m_ComboBitRate->Append(wxT("128 (default)"));
		m_ComboBitRate->Append(wxT("160"));
		m_ComboBitRate->Append(wxT("192"));
		m_ComboBitRate->Append(wxT("224"));
		m_ComboBitRate->Append(wxT("256"));
		m_ComboBitRate->Append(wxT("320 (high quality, bigger files)"));

		/* not used
							t = new wxStaticText(   m_panel, -1,			wxT("Quality"),  wxPoint(POPXT,  POPYT + 4 * YDEL));
							MASETFONT(t);
		m_ComboQuality =	new wxComboBox(		m_panel, ID_POPUP_QUALITY,  wxT(""),			wxPoint(POPX,   POPY  + 4 * YDEL),  wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboQuality); // doesn't on all platforms
		m_ComboQuality->Append(wxT("0 (high quality, slow encode)"));
		m_ComboQuality->Append(wxT("1"));
		m_ComboQuality->Append(wxT("2"));
		m_ComboQuality->Append(wxT("3"));
		m_ComboQuality->Append(wxT("4"));
		m_ComboQuality->Append(wxT("5 (default)"));
		m_ComboQuality->Append(wxT("6"));
		m_ComboQuality->Append(wxT("7"));
		m_ComboQuality->Append(wxT("8"));
		m_ComboQuality->Append(wxT("9"));
		m_ComboQuality->Append(wxT("10 (lower quality, fast encode)"));
		*/
					  t = new wxStaticText( m_panel, -1,		wxT("Mode"), wxPoint(POPXT,  POPYT + 5 * YDEL));
					  MASETFONT(t);
		m_ComboMode = new wxComboBox(   m_panel, ID_POPUP_MODE, wxT(""),		wxPoint(POPX,   POPY  + 5 * YDEL),  wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboMode); // doesn't on all platforms
		m_ComboMode->Append(wxT("Stereo (default)"));
		// m_ComboMode->Append(wxT("Joint Stereo"));
		// m_ComboMode->Append(wxT("Dual Stereo"));
		m_ComboMode->Append(wxT("Mono"));
			break;
 #endif
 
 #ifdef ENCODEAAC
			case kOUTAAC :
		new MACHECKBOX(m_panel, ID_CHK_ADTS,		wxT("   ADTS Headers"),  wxPoint(POPXT, POPYT + 3 * YDEL), CBSIZ, 0);
		t = new wxStaticText(m_panel, -1,					wxT("Quality"),  wxPoint(POPXT, POPYT + 4 * YDEL));
		MASETFONT(t);
		m_ComboQuality = new wxComboBox( m_panel, ID_POPUP_QUALITY, wxT(""), wxPoint(POPX,  POPY  + 4 * YDEL), wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboQuality); // doesn't on all platforms
		m_ComboQuality->Append(wxT("130 (~218 kbps)"));
		m_ComboQuality->Append(wxT("120 (~194 kbps)"));
		m_ComboQuality->Append(wxT("110 (~158 kbps)"));
		m_ComboQuality->Append(wxT("100 (~129 kbps default)"));
		m_ComboQuality->Append(wxT(" 90 (~103 kbps)"));
		m_ComboQuality->Append(wxT(" 80 (~79 kbps)"));
		m_ComboQuality->Append(wxT(" 70 (~62 kbps)"));
			break;
 #endif
 
 #ifdef ENCODEMP4
			case kOUTMP4 :
		new MACHECKBOX(m_panel, ID_CHK_M4A,		wxT("   .m4a extension"),	wxPoint(POPXT, POPYT + 3 * YDEL), CBSIZ, 0);
		t = new wxStaticText( m_panel, -1,		wxT("Quality"),				wxPoint(POPXT, POPYT + 4 * YDEL));
		MASETFONT(t);
		m_ComboQuality = new wxComboBox(m_panel, ID_POPUP_QUALITY,  wxT(""), wxPoint(POPX,  POPY  + 4 * YDEL), wxSize(POPW, POPH), 0, NULL, wxCB_READONLY);
		MASETFONT(m_ComboQuality); // doesn't on all platforms
		m_ComboQuality->Append(wxT("130 (~218 kbps)"));
		m_ComboQuality->Append(wxT("120 (~194 kbps)"));
		m_ComboQuality->Append(wxT("110 (~158 kbps)"));
		m_ComboQuality->Append(wxT("100 (~129 kbps default)"));
		m_ComboQuality->Append(wxT(" 90 (~103 kbps)"));
		m_ComboQuality->Append(wxT(" 80 (~79 kbps)"));
		m_ComboQuality->Append(wxT(" 70 (~62 kbps)"));
			break;
 #endif
 
			default :
			break;
		} // switch
#endif
	
} // MyFrameFileOut


MyFrameFileOut::~MyFrameFileOut()
{
}


void MyFrameFileOut::OnGUIPopupBitRate(wxCommandEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboBitRate->Refresh();
	OnPopupBitRate(m_ComboBitRate->GetSelection());
}


void MyFrameFileOut::OnGUIPopupQuality(wxCommandEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboQuality->Refresh();
	OnPopupQuality(m_ComboQuality->GetSelection());
}


void MyFrameFileOut::OnGUIPopupMode(wxCommandEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboMode->Refresh();
	OnPopupMode(m_ComboMode->GetSelection());
}


void MyFrameFileOut::OnGUIPopupSampleRate(wxCommandEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	m_ComboSampleRate->Refresh();
	OnPopupSampleRate(m_ComboSampleRate->GetSelection());
}


void MyFrameFileOut::OnGUIButtonFileOutDir(wxCommandEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonFileOutDir();
	
} // OnGUIButtonFileOutDir


void MyFrameFileOut::OnGUICheckBoxADTS(wxCommandEvent &event)
{
	OnCheckBoxADTS(event.IsChecked() ? 1 : 0);

} // OnGUICheckBoxADTS


void MyFrameFileOut::OnGUICheckBoxM4A(wxCommandEvent &event)
{
	OnCheckBoxM4A(event.IsChecked() ? 1 : 0);

} // OnGUICheckBoxM4A


void MyFrameFileOut::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedFileOut();
	this->Destroy();
}


void MyFrameFileOut::OnGUISize(wxSizeEvent& event)
{
	int dummy;
	
	if(!g_w[WINDOWOUTCUR])
		return;
	
	OnSize(event);
	
	WindowGetCoordinates(WINDOWOUTCUR, &dummy, &dummy, &g_sets.fileoutxsize[g_sets.winconf],
													   &g_sets.fileoutysize[g_sets.winconf]);

} // OnGUISize


void MyFrameFileOut::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	int dummy;	

	if(!g_w[WINDOWOUTCUR])
		return;
	
	WindowGetCoordinates(WINDOWOUTCUR, &g_sets.fileoutxpos[g_sets.winconf],
									   &g_sets.fileoutypos[g_sets.winconf], &dummy, &dummy);

} // OnGUIMove


MyFrameAbout::MyFrameAbout(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
			: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
	
#if defined(__WXMSW__) || (defined(__WXMAC__) && (MAGUIWX != 4))
 #define MAABOUTWINY 26 // otherwise close button is not visible
#else
 #define MAABOUTWINY 1 // otherwise close button is not visible
#endif
#define MAABOUTWINX 1
#define MAURLHEIGHT 26

	wxSize bsize = wxButton::GetDefaultSize();

	m_closebutton = new wxButton(m_panel, wxID_OK, wxT("Close"),
							wxPoint((siz.x - bsize.x) / 2, siz.y - bsize.y - MAABOUTWINY));
	
	m_urlTextCtrl = new wxTextCtrl(m_panel, -1, wxT(MOREAMP_HOME_URL),
							wxPoint(MAABOUTWINX, siz.y - MAURLHEIGHT - 2 - bsize.y - MAABOUTWINY),
							wxSize(siz.x - (2 * MAABOUTWINX), MAURLHEIGHT));
	MASETFONT(m_urlTextCtrl);

	m_aboutTextCtrl = new wxTextCtrl(m_panel, -1, wxT(g_AboutText), wxPoint(MAABOUTWINX, -1),
		wxSize(siz.x - (2 * MAABOUTWINX), siz.y - 2 - MAURLHEIGHT - 2 - bsize.y - MAABOUTWINY),
									wxTE_AUTO_SCROLL | wxTE_READONLY | wxTE_MULTILINE);
	MASETFONT(m_aboutTextCtrl);

	m_aboutTextCtrl->SetFocus();

} // MyFrameAbout
		

MyFrameAbout::~MyFrameAbout()
{
}


void MyFrameAbout::OnButtonClose(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	this->Destroy();
	g_w[WINDOWABOUT] = NULL;
}


void MyFrameAbout::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	this->Destroy();
	g_w[WINDOWABOUT] = NULL;
}


void MyFrameAbout::OnGUISize(wxSizeEvent& event)
{
	int x;
	int y;
	int xdelta;
	int ydelta;
	int *pxsize;
	int *pysize;
	
	if(!g_w[WINDOWABOUT])
		return;
	
	OnSize(event);
	
	pxsize = &g_sets.aboutxsize;
	pysize = &g_sets.aboutysize;
	
	xdelta = *pxsize;
	ydelta = *pysize;
	WindowGetCoordinates(WINDOWABOUT, &x, &y, pxsize, pysize);
	xdelta = *pxsize - xdelta;
	ydelta = *pysize - ydelta;
	
	// move urltext and buttons
	m_urlTextCtrl->GetPosition(&x, &y);
	m_urlTextCtrl->Move(x, y + ydelta);
	m_closebutton->GetPosition(&x, &y);
	m_closebutton->Move(x + xdelta / 2, y + ydelta);
		
	// resize abouttext and urltext
	m_aboutTextCtrl->GetSize(&x, &y);
	m_aboutTextCtrl->SetSize(x + xdelta, y + ydelta);
	m_urlTextCtrl->GetSize(&x, &y);
	m_urlTextCtrl->SetSize(x + xdelta, y);
	

} // OnGUISize

void MyFrameAbout::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWABOUT])
		return;
	
	int dummy;	
	WindowGetCoordinates(WINDOWABOUT, &g_sets.aboutxpos, &g_sets.aboutypos, &dummy, &dummy);

} // OnGUIMove


#if defined(__MAOSX__) && defined(__WXMAC__) && (MAGUIWX == 6) && (wxMINOR_VERSION == 6)
 #define MANOMACMLTEHIVIEW "mac.textcontrol-use-mlte"
#endif

#define MAEOL 0x0a // 0x0d
MyFrameViewer::MyFrameViewer(int id_window, const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
				: wxFrame((wxWindow *)NULL, id_window, title, pos, siz, style)
{
	size_t fsize;
	FILE *fp = NULL;
	int islog = 0;
	char *p, *q;
	char *pmem = NULL;
	char *pcstr = NULL;
	char cstr[MAX_PATH + 256];

	switch(id_window)
	{
		case WINDOWREADME:
			strcpy(m_fpath, g_readmepath);
			m_viewertarget = g_readmefind;
		break;
		
		case WINDOWCATALOG:
			if(FilenameFromPathname(g_songlist, cstr))
			{
				sprintf(cstr, "MyFrameViewer FilenameFromPathname failed on '%s'", g_songlist);
				maLog(cstr);
				return;
			}
			if((p = strstr(cstr, g_extstr[kMAMAF])))
				*p = 0;
			sprintf(m_fpath, "%s%c%s.txt", g_madir, FILESEP, cstr);
			m_viewertarget = g_catalogfind;
		break;
		
		case WINDOWLOG:
			islog = 1;
			strcpy(m_fpath, g_logpath);
			m_viewertarget = g_logfind;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			strcpy(m_fpath, g_keybindingspath);
			m_viewertarget = g_keybindingsfind;
		break;
#endif

		default:
			m_fpath[0] = 0;
		return;
	}
	
	if(!maFileExists(m_fpath))
	{
		if(islog)
			sprintf(cstr, "NO ERRORS = no log file '%s'", m_fpath);
		else
			sprintf(cstr, "File '%s' not found", m_fpath);
		pcstr = cstr;
	}
	else
	{
		if((fp = mafopen(m_fpath, "rb")) == NULL)
		{
			sprintf(cstr, "MyFrameViewer mafopen failed on '%s'", m_fpath);
			maLog(cstr);
			pcstr = cstr;
		}
		else
		{
			fsize = maGetFileSize(fp, 0, 1);

			if((pmem = (char *)MAMALLOC(fsize + 2)) == NULL)
			{
				sprintf(cstr, "MyFrameViewer MAMALLOC failed fsize=%d", (int)fsize);
				maLog(cstr);
				pcstr = cstr;
			}
			else
			{
				if(fread(pmem, 1, fsize, fp) != fsize)
				{
					fclose(fp);
					fp = NULL;
					MAFREE(pmem);
					pmem = NULL;
					sprintf(cstr, "MyFrameViewer fread failed '%s'", m_fpath);
					maLog(cstr);
					pcstr = cstr;
				}
				else
				{
					pmem[fsize] = 0;
					p = pmem; // crlf -> spMAEOL
					cstr[0] = 0x0d;
					cstr[1] = 0x0a;
					cstr[2] = 0;
					while((q = strstr(p, cstr)))
					{
						*q++ = ' ';
						*q++ = MAEOL;
						p = q;
					}
					p = pmem; // lfcr -> spMAEOL
					cstr[0] = 0x0a;
					cstr[1] = 0x0d;
					while((q = strstr(p, cstr)))
					{
						*q++ = ' ';
						*q++ = MAEOL;
						p = q;
					}
					p = pmem;
					if(MAEOL != 0x0d)
					{
						while((q = strchr(p, 0x0d))) // cr -> MAEOL
						{
							*q++ = MAEOL;
							p = q;
						}
					}
					else // MAEOL != 0x0a
					{
						while((q = strchr(p, 0x0a))) // lf -> MAEOL
						{
							*q++ = MAEOL;
							p = q;
						}
					}
					pcstr = pmem;
				}
			}		
		}
	}
	
	if(fp)
		fclose(fp);

	m_id_window = id_window;
	
	m_n = 0;
	
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
	
#if defined(__WXMSW__) || (defined(__WXMAC__) && (MAGUIWX != 4))
 #define MAVIEWERWINY 26 // otherwise close button is not visible
#else
 #define MAVIEWERWINY 1
#endif
#define MAVIEWERWINX 1
#define MAFINDEIGHT 26

#if defined(__WXX11__)
  #define MAVIEWERTEOPTIONS wxTE_NOHIDESEL | wxTE_AUTO_SCROLL | wxTE_MULTILINE // | otherwise cannot select text
#else
 #define MAVIEWERTEOPTIONS wxTE_NOHIDESEL | wxTE_AUTO_SCROLL | wxTE_MULTILINE | wxTE_READONLY
#endif

	wxSize bsize = wxButton::GetDefaultSize();
	
	m_viewerTextCtrl = new MyViewerTextCtrl(m_panel, -1,
#if defined(__MAOSX__) && defined(__WXMAC__) && (MAGUIWX == 6) && (wxMINOR_VERSION == 6)
			wxT(MANOMACMLTEHIVIEW), // works with change to src/mac/carbon/textctrl.cpp
#else	
			wxT(""),
#endif
			wxPoint(MAVIEWERWINX, -1),
			wxSize(siz.x - (2 * MAVIEWERWINX),
				siz.y - 2 - MAFINDEIGHT - 2 - bsize.y - MAVIEWERWINY), MAVIEWERTEOPTIONS);

	m_viewerTextCtrl->SetEditable(false);

	m_viewerTextCtrl->Freeze(); // may or may not help speed
	MASETFONT(m_viewerTextCtrl);
	m_viewerTextCtrl->SetValue(pcstr);
	m_viewerTextCtrl->Thaw();

	m_findTextCtrl = new MyTextCtrl(m_panel, ID_EDITTEXT_VIEWERFIND, wxT(m_viewertarget),
						wxPoint(MAVIEWERWINX, siz.y - MAFINDEIGHT - 2 - bsize.y - MAVIEWERWINY),
						wxSize(siz.x - (2 * MAVIEWERWINX), MAFINDEIGHT));
	// MASETFONT(m_findTextCtrl);
	
	m_findbutton = new wxButton(m_panel, ID_BTN_VIEWERFIND, wxT("Find"),
					wxPoint(MAVIEWERWINX + 2, siz.y - bsize.y - MAVIEWERWINY));
		
	m_foundStaticText = new wxStaticText(m_panel, ID_TEXT_VIEWERFOUND, wxT(""),
					wxPoint(MAVIEWERWINX + bsize.x + 2, siz.y - bsize.y - MAVIEWERWINY)
#if defined(__WXX11__)
	, wxSize(200, -1));
#else
	);
#endif
	
	// MASETFONT(m_foundStaticText);
	
	m_editbutton = new wxButton(m_panel, ID_BTN_EDITSAVE, wxT("Edit"),
					wxPoint(siz.x -  bsize.x - 2 -  bsize.x - MAVIEWERWINX, siz.y - bsize.y - MAVIEWERWINY));

	m_closebutton = new wxButton(m_panel, wxID_OK, wxT("Close"),
					wxPoint(siz.x -  bsize.x - 2 - MAVIEWERWINX, siz.y - bsize.y - MAVIEWERWINY));
	
	if(pmem)
		MAFREE(pmem);
	
	m_ip = -1;
	
	m_viewerTextCtrl->SetFocus();	

} // MyFrameViewer
		

MyFrameViewer::~MyFrameViewer()
{
}


void MyFrameViewer::SetFindText(char *text)
{
	EditTextSetText(m_id_window, ID_EDITTEXT_VIEWERFIND, text);
}


void MyFrameViewer::OnButtonFind(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	char *p;
	char *p0;
	char findstr[256];
	long findlen;
	long findfrom;
	long from;
	long to;
	int line;
	char maeol;

	wxString content = m_viewerTextCtrl->GetRange(0, m_viewerTextCtrl->GetLastPosition());

	p0 = (char *)content.c_str();
	
	if(strchr(p0, 0x0a)) // assert m_viewerTextCtrl changed 0x0d or 0x0a to only one of 0x0d or 0x0a
	{
		maeol = 0x0a;
		if(strchr(p0, 0x0d))
			maLog("OnButtonFind both cr and lf");
	}
	else
	{
		maeol = 0x0d;
		if(!strchr(p0, 0x0d))
			maLog("OnButtonFind no cr and no lf");
	}
	
	// the text in the find edit box is the target text
	EditTextGetText(m_id_window, ID_EDITTEXT_VIEWERFIND, findstr, 255, &findlen);
	if(findlen < 1)
	{
		StaticTextSetText(m_id_window, ID_TEXT_VIEWERFOUND, (char *)"Nothing to find.");
		return;
	}

	if(findlen > MAFINDSTRMAX)
	{
		findstr[MAFINDSTRMAX] = 0;
		findlen = MAFINDSTRMAX;
		EditTextSetText(m_id_window, ID_EDITTEXT_VIEWERFIND, findstr);
	}

	if(m_ip < 0)
	{
		m_ip = 0;
		findfrom = 0;
	}
	else
	{
		m_viewerTextCtrl->GetSelection(&from, &to);
		if(from == to) // no selection, find from insertion point
		{
			if((findfrom = m_viewerTextCtrl->GetInsertionPoint()) == m_ip)
				findfrom += 1;
		}
		else
			findfrom = to;
	}
		
	// if target string has changed, recount targets
	if(m_n <= 0 || mastrcasecmp(findstr, m_viewertarget))
	{
		p = p0;
		m_n = 0;
		strcpy(m_viewertarget, findstr);
		while((p = mastrcasestr(p, m_viewertarget)))
		{
			m_n++;
			p += findlen + 1;
		}
	}

	if(m_n <= 0)
	{
		StaticTextSetText(m_id_window, ID_TEXT_VIEWERFOUND, (char *)"0");
		return;
	}

	// start looking for target string at findfrom
#ifdef __MAWIN__ // adjust insertion position position for crlf
	char *q = p0;
	p = q + findfrom;
	while(q < p)
		if(*q++ == maeol)
		{
			findfrom--;
			p--;
		}
#endif

	p = p0 + findfrom;

	if((p = mastrcasestr(p, m_viewertarget)))
	{
		findfrom = 0;

		line = 1;
		char *q = p0;
		while(q < p)
			if(*q++ == maeol)
			{
				line++;
#ifdef __MAWIN__ // adjust selection position for crlf
				findfrom++;
#endif
			}
		findfrom += (long)(p - p0); 
		m_ip = findfrom; // found m_viewertarget at p0[m_ip]

// try to make this work platform by platform and wx version by wx version 
#if defined(__MAOSX__)
		m_viewerTextCtrl->SetInsertionPoint(m_ip);	// this also scrolls to make the ip visible
		m_viewerTextCtrl->SetSelection(m_ip, m_ip + findlen);
#endif

#if defined(__MAUNIX__)
 #if defined(__WXGTK__)
		m_viewerTextCtrl->SetInsertionPoint(m_ip);	// this also scrolls to make the ip visible
		m_viewerTextCtrl->SetSelection(m_ip, m_ip + findlen);
 #endif
 #if defined(__WXX11__)
		m_viewerTextCtrl->SetInsertionPoint(m_ip);	// this also scrolls to make the ip visible
		m_viewerTextCtrl->SetSelection(m_ip, m_ip + findlen);
 #endif
#endif // __MAUNIX__

#if defined(__WXMSW__)
		m_viewerTextCtrl->SetInsertionPoint(m_ip);	// this also scrolls to make the ip visible
		m_viewerTextCtrl->SetSelection(m_ip, m_ip + findlen);
#endif

		sprintf(findstr, "%d (L%d)", m_n, line);
		StaticTextSetText(m_id_window, ID_TEXT_VIEWERFOUND, findstr);
		m_ip++; // next findfrom
	}
	else
	{
		StaticTextSetText(m_id_window, ID_TEXT_VIEWERFOUND, (char *)"At bottom.");
		m_ip = -1;
	}

	m_findTextCtrl->SetFocus();
	
} // OnButtonFind


void MyFrameViewer::OnButtonEditSave(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	size_t len;
	char *p;
	FILE *fp;
	wxString s;
	
	char cstr[MAX_PATH + 256];
	
	if(m_viewerTextCtrl->IsEditable())
	{
		m_viewerTextCtrl->SetEditable(false);
		
		// rewrite file
		if((fp = mafopen(m_fpath, "wb")) == NULL)
		{
			sprintf(cstr, "MyFrameViewer OnButtonEditSave mafopen failed on '%s'", m_fpath);
			maLog(cstr);
		}
		else
		{
			s = m_viewerTextCtrl->GetValue();
			p = (char *)s.c_str();
			len = s.Len();
				
			if(fwrite(p, 1, len, fp) != len)
			{
				sprintf(cstr, "MyFrameViewer OnButtonEditSave fwrite errno=%d '%s'", errno, m_fpath);
				maLog(cstr);
			}

			if(fclose(fp) != 0)
			{
				sprintf(cstr, "MyFrameViewer OnButtonEditSave fclose errno=%d '%s'", errno, m_fpath);
				maLog(cstr);
			}
			
#if defined(MAKEYBOARD)
			// reload
			if(!strcmp(g_keybindingspath, m_fpath))
			{
				// int ret;
				if((/* ret = */ LoadKeyBindings(1)) == 1)
					maLog("MyFrameViewer OnButtonEditSave LoadKeyBindings failed");
				// else if(ret == 2) // fopen failed
				// else if(ret == 3) // no valid entries
				// else if(ret == 4) // duplicate entries
			}
#endif
		}

		m_editbutton->SetLabel("Edit");
	}
	else
	{
		m_viewerTextCtrl->SetEditable(true);
		m_editbutton->SetLabel("Save");
	}	
	
	m_foundStaticText->SetFocus();

} // OnButtonEditSave


void MyFrameViewer::OnButtonClose(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	this->Destroy();
	g_w[m_id_window] = NULL;
}


void MyFrameViewer::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	this->Destroy();
	g_w[m_id_window] = NULL;
}


void MyFrameViewer::OnGUISize(wxSizeEvent& event)
{
	int x;
	int y;
	int xdelta;
	int ydelta;
	int *pxsize;
	int *pysize;
	int window = event.GetId();
	
	if(!g_w[window])
		return;
	
	OnSize(event);
	
#if defined(MAKEYBOARD)
	if(window == WINDOWKEYBINDINGS)
	{
		pxsize = &g_sets.keybindingsxsize;
		pysize = &g_sets.keybindingsysize;
	}
	else
#endif
	{
		pxsize = &g_sets.viewerxsize;
		pysize = &g_sets.viewerysize;
	}
	
	xdelta = *pxsize;
	ydelta = *pysize;
	WindowGetCoordinates(window, &x, &y, pxsize, pysize);
	xdelta = *pxsize - xdelta;
	ydelta = *pysize - ydelta;
	
	// move buttons, static text and findtext
	m_findTextCtrl->GetPosition(&x, &y);
	m_findTextCtrl->Move(x, y + ydelta);
	m_findbutton->GetPosition(&x, &y);
	m_findbutton->Move(x, y + ydelta);
	m_foundStaticText->GetPosition(&x, &y);
	m_foundStaticText->Move(x, y + ydelta);
	m_editbutton->GetPosition(&x, &y);
	m_editbutton->Move(x + xdelta, y + ydelta);
	m_closebutton->GetPosition(&x, &y);
	m_closebutton->Move(x + xdelta, y + ydelta);
		
	// resize edittext and findtext
	m_findTextCtrl->GetSize(&x, &y);
	m_findTextCtrl->SetSize(x + xdelta, y);
	m_viewerTextCtrl->GetSize(&x, &y);
	m_viewerTextCtrl->SetSize(x + xdelta, y + ydelta);
	
} // OnGUISize


void MyFrameViewer::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	int dummy;	
	int window = event.GetId();
	
	if(!g_w[window])
		return;
	
#if defined(MAKEYBOARD)
	if(window == WINDOWKEYBINDINGS)
		WindowGetCoordinates(WINDOWKEYBINDINGS, &g_sets.keybindingsxpos, &g_sets.keybindingsypos, &dummy, &dummy);
	else
#endif
		WindowGetCoordinates(window, &g_sets.viewerxpos, &g_sets.viewerypos, &dummy, &dummy);

} // OnGUIMove


#define PROMPTNUMDEFXSIZE 354 
#define PROMPTNUMDEFYSIZE 144
#define PROMPTNUMBUTTONW 60
#ifdef __MAWIN__
 #define PROMPTNUMBUTTONH 30
#else
 #define PROMPTNUMBUTTONH 48
#endif
MyFramePromptNum::MyFramePromptNum(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
						: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
#if !defined(MANOWXPANEL)
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
#endif
	
	// having a wxListCtrl makes kb focus work...
	new wxListCtrl(MPANEL, -1, wxPoint(0, 0), wxSize(1, 1),
		wxLC_REPORT | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL | wxLC_HRULES | wxLC_NO_SORT_HEADER);

	// msg text
	m_textpromptnum = new wxStaticText(MPANEL, ID_TEXT_PROMPTNUM,	wxT("Preset"), wxPoint(10, 10));
	MASETFONT(m_textpromptnum);
	
	// text editor
	m_dummytextpromptnum = new wxTextCtrl(MPANEL, wxID_ANY,					wxT(""), wxPoint(14, 44),  wxSize(1, 1), wxTE_PROCESS_ENTER);
	m_edittextpromptnum  = new wxTextCtrl(MPANEL, ID_EDITTEXT_PROMPTNUM,	wxT(""), wxPoint(10, 40), wxSize(PROMPTNUMDEFXSIZE - 20, 26), wxTE_PROCESS_ENTER);
	
	// buttons
	m_buttonCancel = new wxButton(MPANEL, ID_BTN_PROMPTNUMCANCEL, wxT("Cancel"), wxPoint(PROMPTNUMDEFXSIZE - 2 * (PROMPTNUMBUTTONW + 10),
												PROMPTNUMDEFYSIZE - (PROMPTNUMBUTTONH + 10)), wxSize(PROMPTNUMBUTTONW, PROMPTNUMBUTTONH));
	m_buttonOk     = new wxButton(MPANEL, ID_BTN_PROMPTNUMOK,     wxT("Ok"),     wxPoint(PROMPTNUMDEFXSIZE -     (PROMPTNUMBUTTONW + 10),
												PROMPTNUMDEFYSIZE - (PROMPTNUMBUTTONH + 10)), wxSize(PROMPTNUMBUTTONW, PROMPTNUMBUTTONH));

	m_edittextpromptnum->SetFocus(); // for maOnChar focus

} // MyFramePromptNum


MyFramePromptNum::~MyFramePromptNum()
{
}


void MyFramePromptNum::OnGUIButtonPromptNumOk(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPromptNum(1); // Ok
}


void MyFramePromptNum::OnGUIButtonPromptNumCancel(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	OnButtonPromptNum(0); // Cancel
}


void MyFramePromptNum::OnGUIEditTextPromptNum(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif
	OnEditTextPromptNum();
}


void MyFramePromptNum::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedPromptNum();
	this->Destroy();
}


MyFrameAdvanced::MyFrameAdvanced(const wxString& title, const wxPoint& pos, const wxSize& siz, long style)
						: wxFrame((wxWindow *)NULL, wxID_ANY, title, pos, siz, style)
{
	m_panel = new wxPanel(this, -1, wxDefaultPosition, siz, wxCLIP_CHILDREN | wxNO_BORDER);
	
	// closereopen checkbox
	new MACHECKBOX(m_panel, ID_CHK_CLOSEREOPEN,	
#if defined(MACLOSESOUNDDEF) && (MACLOSESOUNDDEF == 0)
	wxT(" Close and re-open sound channel between songs (default no)"),
#else
	wxT(" Close and re-open sound channel between songs (default yes)"),
#endif
		wxPoint(10, 20), CBSIZ, 0);

	// hi priority checkbox
	new MACHECKBOX(m_panel, ID_CHK_HIGHPRIORITY, wxT(" HiPriority (default no)"), wxPoint(10, 40), CBSIZ, 0);

	// close window button
	new wxButton(m_panel, wxID_OK, wxT("Close"), wxPoint(g_sets.advancedxsize / 2 - 30, g_sets.advancedysize - 60));

} // MyFrameAdvanced


MyFrameAdvanced::~MyFrameAdvanced()
{
}


void MyFrameAdvanced::OnGUICheckCloseReopen(wxCommandEvent& event)
{
	OnCheckCloseReopen(event.IsChecked() ? 1 : 0);
}


void MyFrameAdvanced::OnGUICheckHighPriority(wxCommandEvent& event)
{
	OnCheckHighPriority(event.IsChecked() ? 1 : 0);
}


void MyFrameAdvanced::OnButtonClose(wxCommandEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedAdvanced();
	this->Destroy();
}


void MyFrameAdvanced::OnCloseWindow(wxCloseEvent &event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	this->Hide();
	OnWindowClosedAdvanced();
	this->Destroy();
}


void MyFrameAdvanced::OnGUISize(wxSizeEvent& event)
{
	int dummy;
	
	if(!g_w[WINDOWADVANCED])
		return;
	
	OnSize(event);
	
	WindowGetCoordinates(WINDOWADVANCED, &dummy, &dummy, &g_sets.advancedxsize, &g_sets.advancedysize);

} // OnGUISize


void MyFrameAdvanced::OnGUIMove(wxMoveEvent& event)
{
#ifdef MAUNUSED
 (void)event;
#endif

	if(!g_w[WINDOWADVANCED])
		return;
	
	int dummy;	
	WindowGetCoordinates(WINDOWADVANCED, &g_sets.advancedxpos, &g_sets.advancedypos, &dummy, &dummy);

} // OnGUIMove


BEGIN_EVENT_TABLE(MyFrame, wxFrame)
	EVT_CHECKBOX(ID_CHK_ALTSIZE,		MyFrame::OnGUICheckAltSize) 
	EVT_CHECKBOX(ID_CHK_RANDOM,			MyFrame::OnGUICheckRandom)
	EVT_CHECKBOX(ID_CHK_REPTPLAYED,		MyFrame::OnGUICheckReptPlayed)
	EVT_CHECKBOX(ID_CHK_LOOPLOADED,		MyFrame::OnGUICheckLoopLoaded)
	EVT_CHECKBOX(ID_CHK_LOOPLIST,		MyFrame::OnGUICheckLoopList)
	EVT_CHECKBOX(ID_CHK_EQWINDOW,		MyFrame::OnGUICheckEqWindow)
	EVT_CHECKBOX(ID_CHK_LISTWINDOW,		MyFrame::OnGUICheckListWindow)
	EVT_CHECKBOX(ID_CHK_BEG,			MyFrame::OnGUICheckBoxBeg)
	EVT_CHECKBOX(ID_CHK_END,			MyFrame::OnGUICheckBoxEnd)
	EVT_CHECKBOX(ID_CHK_MONOLEFT,		MyFrame::OnGUICheckMonoLeft)
	EVT_CHECKBOX(ID_CHK_MONORIGHT,		MyFrame::OnGUICheckMonoRight)
	EVT_CHECKBOX(ID_CHK_USEM3U,			MyFrame::OnGUICheckUseM3u)
	EVT_CHECKBOX(ID_CHK_SINGLEPLAY,		MyFrame::OnGUICheckSinglePlay)
	EVT_CHECKBOX(ID_CHK_EQUALIZER,		MyFrame::OnGUICheckEqualizer)
	EVT_CHECKBOX(ID_CHK_EFFECTS,		MyFrame::OnGUICheckEffects)
	EVT_CHECKBOX(ID_CHK_LIMITER,		MyFrame::OnGUICheckLimiter)
	EVT_CHECKBOX(ID_CHK_EQEXTRA,		MyFrame::OnGUICheckEqExtra)
	EVT_CHECKBOX(ID_CHK_TITLEINFO,		MyFrame::OnGUICheckTitleInfo)
	EVT_CHECKBOX(ID_CHK_INVERTRIGHT,	MyFrame::OnGUICheckInvertRight)
	EVT_CHECKBOX(ID_CHK_EQ31BANDS,		MyFrame::OnGUICheckEq31Bands)
	EVT_CHECKBOX(ID_CHK_REPTSONG,		MyFrame::OnGUICheckReptSong)
	EVT_CHECKBOX(ID_CHK_MONODIFF,		MyFrame::OnGUICheckMonoDiff)
	EVT_CHECKBOX(ID_CHK_BALANCE,		MyFrame::OnGUICheckBalance)

	EVT_BUTTON(ID_BTN_PREVIOUS,			MyFrame::OnGUIButtonPrevious)
	EVT_BUTTON(ID_BTN_PLAY,				MyFrame::OnGUIButtonPlay)
	EVT_BUTTON(ID_BTN_QUIT,				MyFrame::OnGUIButtonQuit)
	EVT_BUTTON(ID_BTN_PAUSE,			MyFrame::OnGUIButtonPause)
	EVT_BUTTON(ID_BTN_STOP,				MyFrame::OnGUIButtonStop)
	EVT_BUTTON(ID_BTN_NEXT,				MyFrame::OnGUIButtonNext)

	EVT_SLIDER(ID_SLIDER_VOLUMEL,		MyFrame::OnGUISliderVolumeL)
	EVT_SLIDER(ID_SLIDER_VOLUMER,		MyFrame::OnGUISliderVolumeR)
	EVT_SLIDER(ID_SLIDER_VOLUMESEP,		MyFrame::OnGUISliderSeparation)
	EVT_SLIDER(ID_SLIDER_PREAMP,		MyFrame::OnGUISliderPreamp)
	EVT_SLIDER(ID_SLIDER_POSITION,		MyFrame::OnGUISliderPos)	
	
	EVT_COMBOBOX(ID_POPUP_OUTPUT,		MyFrame::OnGUIPopupOutput)
	EVT_COMBOBOX(ID_POPUP_BUFFER,		MyFrame::OnGUIPopupBuffer)

	EVT_SPIN_UP(ID_SPIN_BUFFER,			MyFrame::OnGUISpinUpMem)
	EVT_SPIN_UP(ID_SPIN_PREA,			MyFrame::OnGUISpinUpPreamp)
	EVT_SPIN_UP(ID_SPIN_SEP,			MyFrame::OnGUISpinUpSep)
	EVT_SPIN_UP(ID_SPIN_VOLR,			MyFrame::OnGUISpinUpVolR)
	EVT_SPIN_UP(ID_SPIN_VOLL,			MyFrame::OnGUISpinUpVolL)
	EVT_SPIN_UP(ID_SPIN_BEG,			MyFrame::OnGUISpinUpBeg)
	EVT_SPIN_UP(ID_SPIN_END,			MyFrame::OnGUISpinUpEnd)

	EVT_SPIN_DOWN(ID_SPIN_BUFFER,		MyFrame::OnGUISpinDownBuffer)
	EVT_SPIN_DOWN(ID_SPIN_PREA,			MyFrame::OnGUISpinDownPreamp)
	EVT_SPIN_DOWN(ID_SPIN_SEP,			MyFrame::OnGUISpinDownSep)
	EVT_SPIN_DOWN(ID_SPIN_VOLR,			MyFrame::OnGUISpinDownVolR)
	EVT_SPIN_DOWN(ID_SPIN_VOLL,			MyFrame::OnGUISpinDownVolL)
	EVT_SPIN_DOWN(ID_SPIN_BEG,			MyFrame::OnGUISpinDownBeg)
	EVT_SPIN_DOWN(ID_SPIN_END,			MyFrame::OnGUISpinDownEnd)

	EVT_MENU(ID_MENU_ABOUT,				MyFrame::OnAbout)
	EVT_MENU(ID_MENU_QUIT,				MyFrame::OnGUIMenuQuit)
	EVT_MENU(ID_MENU_OPENLIST,			MyFrame::OnGUIMenuOpenList)
	EVT_MENU(ID_MENU_MAKELIST,			MyFrame::OnGUIMenuMakeList)
	EVT_MENU(ID_MENU_SAVELISTAS,		MyFrame::OnGUIMenuSaveListAs)
	EVT_MENU(ID_MENU_DELETELIST,		MyFrame::OnGUIMenuDeleteList)
	EVT_MENU(ID_MENU_PLAYFILE,			MyFrame::OnGUIMenuPlayFile)
	EVT_MENU(ID_SUBMENU_OPENRECENT1,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT2,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT3,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT4,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT5,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT6,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT7,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT8,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT9,	MyFrame::OnGUIMenuOpenRecent)
	EVT_MENU(ID_SUBMENU_OPENRECENT10,	MyFrame::OnGUIMenuOpenRecent)

	EVT_MENU(ID_MENU_SETVDISK,			MyFrame::OnGUIMenuSetVDisk)

#if defined(MAINSTANCES)
	EVT_MENU(ID_MENU_MULTIPLEINST,		MyFrame::OnGUIMenuMultipleInst)
#endif

#if defined(MAKEYBOARD)
	EVT_MENU(ID_MENU_KEYBOARD,			MyFrame::OnGUIMenuKeyboard)
#endif

#if defined(MAMOUSEWHEEL)
	EVT_MENU(ID_MENU_MOUSEWHEEL,		MyFrame::OnGUIMenuMouseWheel)
#endif

	EVT_MENU(ID_MENU_ADVANCED,			MyFrame::OnGUIMenuAdvanced)

#if !defined(MANOCDA) && defined(__MAUNIX__)
	EVT_MENU(ID_MENU_SETAUDIOCD,		MyFrame::OnGUIMenuSetAudioCD)
#endif
	
	EVT_MENU(ID_MENU_SETFACTORY,		MyFrame::OnGUIMenuSetFactory)
	EVT_MENU(ID_MENU_SETDEFAULT,		MyFrame::OnGUIMenuSetDefault)
	EVT_MENU(ID_MENU_SETSAVED,			MyFrame::OnGUIMenuSetSaved)
	EVT_MENU(ID_MENU_SETCOPY,			MyFrame::OnGUIMenuSetCopy)
	
	EVT_MENU(ID_MENU_STOP,				MyFrame::OnGUIMenuStop)
	EVT_MENU(ID_MENU_PAUSE,				MyFrame::OnGUIMenuPause)
	EVT_MENU(ID_MENU_PREVIOUS,			MyFrame::OnGUIMenuPrevious)
	EVT_MENU(ID_MENU_PLAY,				MyFrame::OnGUIMenuPlay)
	EVT_MENU(ID_MENU_NEXT,				MyFrame::OnGUIMenuNext)
	EVT_MENU(ID_MENU_PLAYCD,			MyFrame::OnGUIMenuPlayCD)
	EVT_MENU(ID_MENU_EJECTCD,			MyFrame::OnGUIMenuEjectCD)
	EVT_MENU(ID_MENU_AUDIOIN,			MyFrame::OnGUIMenuAudioIn)

	EVT_MENU(ID_SUBMENU_TITLEINFO1,		MyFrame::OnGUIMenuTitleInfo)
	EVT_MENU(ID_SUBMENU_TITLEINFO2,		MyFrame::OnGUIMenuTitleInfo)
	EVT_MENU(ID_SUBMENU_TITLEINFO3,		MyFrame::OnGUIMenuTitleInfo)

	EVT_MENU(ID_MENU_RANDOM,			MyFrame::OnGUIMenuRandom)
	EVT_MENU(ID_MENU_REPTPLAYED,		MyFrame::OnGUIMenuReptPlayed)
	EVT_MENU(ID_MENU_LOOPLOADED,		MyFrame::OnGUIMenuLoopLoaded)
	EVT_MENU(ID_MENU_LOOPLIST,			MyFrame::OnGUIMenuLoopList)
	EVT_MENU(ID_MENU_AUTOSTART,			MyFrame::OnGUIMenuAutoStart)
	EVT_MENU(ID_MENU_ERRLOGGING,		MyFrame::OnGUIMenuErrLogging)
	EVT_MENU(ID_MENU_SINGLEPLAY,		MyFrame::OnGUIMenuSinglePlay)
	EVT_MENU(ID_MENU_HIPRIORITY,		MyFrame::OnGUIMenuHiPriority)
	EVT_MENU(ID_MENU_EQUALIZER,			MyFrame::OnGUIMenuEqualizer)
	EVT_MENU(ID_MENU_EFFECTS,			MyFrame::OnGUIMenuEffects)
	EVT_MENU(ID_MENU_EQEXTRA,			MyFrame::OnGUIMenuEqExtra)
	EVT_MENU(ID_MENU_MONO,				MyFrame::OnGUIMenuMono)
	EVT_MENU(ID_MENU_INVERTRIGHT,		MyFrame::OnGUIMenuInvertRight)
	EVT_MENU(ID_MENU_EQ31BANDS,			MyFrame::OnGUIMenuEq31Bands)
	
	EVT_MENU(ID_MENU_SAVEMASETS,		MyFrame::OnGUIMenuSaveSettings)
	EVT_MENU(ID_MENU_SAVEMASETSDEFAULT,	MyFrame::OnGUIMenuSaveSettingsDefault)
	EVT_MENU(ID_MENU_ZEROLIST,			MyFrame::OnGUIMenuZeroList)
	EVT_MENU(ID_MENU_MAKECATALOG,		MyFrame::OnGUIMenuMakeCatalog)
	EVT_MENU(ID_MENU_VIEWCATALOG,		MyFrame::OnGUIMenuViewCatalog)
	EVT_MENU(ID_MENU_VIEWLOG,			MyFrame::OnGUIMenuViewLog)
#if defined(MAKEYBOARD)
	EVT_MENU(ID_MENU_EDITKEYBINDINGS,	MyFrame::OnGUIMenuEditKeyBindings)
	EVT_MENU(ID_MENU_BLANKKEYBINDINGS,	MyFrame::OnGUIMenuBlankKeyBindings)
#endif
	EVT_MENU(ID_MENU_CLEARLOG,			MyFrame::OnGUIMenuClearLog)
	EVT_MENU(ID_MENU_SHOWLIST,			MyFrame::OnGUIMenuShowList)
	EVT_MENU(ID_MENU_SHOWEQ,			MyFrame::OnGUIMenuShowEq)
	EVT_MENU(ID_MENU_SHOWEFFECTS,		MyFrame::OnGUIMenuShowEffects)
	EVT_MENU(ID_MENU_SHOWFILEOUT,		MyFrame::OnGUIMenuShowFileOut)
	EVT_MENU(ID_MENU_ALTSIZE,			MyFrame::OnGUIMenuAltSize)
	EVT_MENU(ID_MENU_SAVEDSIZE,			MyFrame::OnGUIMenuSavedSize)
	EVT_MENU(ID_MENU_DEFAULTSIZE,		MyFrame::OnGUIMenuDefaultSize)
	EVT_MENU(ID_MENU_FACTORYSIZE,		MyFrame::OnGUIMenuFactorySize)

	EVT_MENU(ID_MENU_README,			MyFrame::OnGUIMenuReadme)

	EVT_TIMER(ID_TIMER_PLAYSONGLIST,	MyFrame::OnTimerPlaySonglist)
	EVT_TIMER(ID_TIMER_RUN,				MyFrame::OnTimerRunLoop)
	EVT_TIMER(ID_TIMER_PLAY,			MyFrame::OnTimerPlay)
	EVT_TIMER(ID_TIMER_STOP,			MyFrame::OnTimerStop)
	EVT_CLOSE(							MyFrame::OnCloseWindow)
	EVT_SIZE(							MyFrame::OnGUISize)
	EVT_MOVE(							MyFrame::OnGUIMove)
END_EVENT_TABLE()


BEGIN_EVENT_TABLE(MyFrameList, wxFrame)
	EVT_BUTTON(ID_BTN_INFO,					MyFrameList::OnGUIButtonInfo)
	EVT_BUTTON(ID_BTN_SONGLIST,				MyFrameList::OnGUIButtonList)
	EVT_BUTTON(ID_BTN_LOADED,				MyFrameList::OnGUIButtonLoaded)
	EVT_BUTTON(ID_BTN_SONGINFO,				MyFrameList::OnGUIButtonSong)
	EVT_CHECKBOX(ID_CHK_SHOWINDEX,			MyFrameList::OnGUICheckShowIndex)
	EVT_CHECKBOX(ID_CHK_SHOWDIR,			MyFrameList::OnGUICheckShowDir)
	EVT_CHECKBOX(ID_CHK_SHOWPATH,			MyFrameList::OnGUICheckShowPath)
	EVT_CHECKBOX(ID_CHK_ADDMODE,			MyFrameList::OnGUICheckAddMode)
	EVT_LIST_COL_END_DRAG(ID_LIST_CTRL,		MyFrameList::OnGUIColumnEndDrag)
	EVT_LIST_ITEM_SELECTED(ID_LIST_CTRL,	MyFrameList::OnGUIListSelected)
	EVT_LIST_ITEM_ACTIVATED(ID_LIST_CTRL,	MyFrameList::OnGUIListActivated)
	EVT_CLOSE(								MyFrameList::OnCloseWindow)
	EVT_SIZE(								MyFrameList::OnGUISize)
	EVT_MOVE(								MyFrameList::OnGUIMove)
END_EVENT_TABLE()


BEGIN_EVENT_TABLE(MyFrameEq, wxFrame)
	EVT_CHECKBOX(ID_CHK_EQZOOM,		MyFrameEq::OnGUICheckEqZoom)
	EVT_CHECKBOX(ID_CHK_EQLINK,		MyFrameEq::OnGUICheckEqLink)
	EVT_CHECKBOX(ID_CHK_EQUALIZERB, MyFrameEq::OnGUICheckEqualizerB)
	EVT_CHECKBOX(ID_CHK_EQ31BANDSB,	MyFrameEq::OnGUICheckEq31BandsB)
	EVT_CHECKBOX(ID_CHK_EQEXTRAB,   MyFrameEq::OnGUICheckEqExtraB)
	EVT_CHECKBOX(ID_CHK_SEPARATELR, MyFrameEq::OnGUICheckSeparateLR)

	EVT_BUTTON(ID_BTN_EQMINUS,		MyFrameEq::OnGUIButtonEqMinus)
	EVT_BUTTON(ID_BTN_EQPLUS,		MyFrameEq::OnGUIButtonEqPlus)
	EVT_BUTTON(ID_BTN_EQMID,		MyFrameEq::OnGUIButtonEqMid)
	EVT_BUTTON(ID_BTN_EQCOPY,		MyFrameEq::OnGUIButtonEqCopy)
	EVT_BUTTON(ID_BTN_EQPASTE,		MyFrameEq::OnGUIButtonEqPaste)
	EVT_BUTTON(ID_BTN_EQRESTORE,	MyFrameEq::OnGUIButtonEqRestore)
	EVT_BUTTON(ID_BTN_EQSHIFTL,		MyFrameEq::OnGUIButtonEqShiftL)
	EVT_BUTTON(ID_BTN_EQSHIFTR,		MyFrameEq::OnGUIButtonEqShiftR)
	EVT_BUTTON(ID_BTN_EQINVERT,		MyFrameEq::OnGUIButtonEqInvert)

	EVT_COMBOBOX(ID_POPUP_EQPRESET,	MyFrameEq::OnGUIPopupEqPreset)
	EVT_TEXT_ENTER(ID_EDITTEXT_EQ,	MyFrameEq::OnGUIEditTextEq)
	EVT_SLIDER(ID_SLIDER_EQ0,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ1,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ3,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ4,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ5,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ6,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ7,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ8,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ9,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ10,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ11,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ12,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ13,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ14,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ15,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ16,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ17,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ18,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ19,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ20,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ21,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ22,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ23,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ24,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ25,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ26,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ27,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ28,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ29,		MyFrameEq::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ30,		MyFrameEq::OnGUISliderEq)
	
	EVT_SPIN_UP(ID_SPIN_EQOFFSET,	MyFrameEq::OnGUISpinUpEqOffset)
	
	EVT_SPIN_UP(ID_SPIN_EQ0,		MyFrameEq::OnGUISpinUpEq) 
	EVT_SPIN_UP(ID_SPIN_EQ1,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ3,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ4,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ5,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ6,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ7,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ8,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ9,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ10,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ11,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ12,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ13,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ14,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ15,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ16,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ17,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ18,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ19,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ20,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ21,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ22,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ23,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ24,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ25,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ26,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ27,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ28,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ29,		MyFrameEq::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ30,		MyFrameEq::OnGUISpinUpEq)
	
	EVT_SPIN_DOWN(ID_SPIN_EQOFFSET,	MyFrameEq::OnGUISpinDownEqOffset)

	EVT_SPIN_DOWN(ID_SPIN_EQ0,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ1,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ3,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ4,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ5,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ6,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ7,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ8,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ9,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ10,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ11,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ12,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ13,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ14,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ15,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ16,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ17,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ18,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ19,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ20,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ21,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ22,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ23,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ24,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ25,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ26,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ27,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ28,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ29,		MyFrameEq::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ30,		MyFrameEq::OnGUISpinDownEq)
	EVT_CLOSE(						MyFrameEq::OnCloseWindow)
	EVT_SIZE(						MyFrameEq::OnGUISize)
	EVT_MOVE(						MyFrameEq::OnGUIMove)
END_EVENT_TABLE()
	

BEGIN_EVENT_TABLE(MyFrameEq2, wxFrame)
	EVT_BUTTON(ID_BTN_EQ2MID,		MyFrameEq2::OnGUIButtonEqMid)
	EVT_BUTTON(ID_BTN_EQ2COPY,		MyFrameEq2::OnGUIButtonEqCopy)
	EVT_BUTTON(ID_BTN_EQ2PASTE,		MyFrameEq2::OnGUIButtonEqPaste)
	EVT_BUTTON(ID_BTN_EQ2RESTORE,	MyFrameEq2::OnGUIButtonEqRestore)

	EVT_SLIDER(ID_SLIDER_EQ2_0,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_1,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_2,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_3,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_4,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_5,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_6,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_7,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_8,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_9,		MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_10,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_11,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_12,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_13,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_14,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_15,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_16,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_17,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_18,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_19,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_20,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_21,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_22,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_23,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_24,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_25,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_26,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_27,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_28,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ2_29,	MyFrameEq2::OnGUISliderEq)
	EVT_SLIDER(ID_SLIDER_EQ30,		MyFrameEq2::OnGUISliderEq)
	
	EVT_SPIN_UP(ID_SPIN_EQ2_0,		MyFrameEq2::OnGUISpinUpEq) 
	EVT_SPIN_UP(ID_SPIN_EQ2_1,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_2,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_3,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_4,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_5,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_6,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_7,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_8,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_9,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_10,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_11,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_12,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_13,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_14,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_15,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_16,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_17,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_18,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_19,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_20,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_21,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_22,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_23,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_24,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_25,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_26,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_27,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_28,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_29,		MyFrameEq2::OnGUISpinUpEq)
	EVT_SPIN_UP(ID_SPIN_EQ2_30,		MyFrameEq2::OnGUISpinUpEq)
	
	EVT_SPIN_DOWN(ID_SPIN_EQ2_0,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_1,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_2,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_3,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_4,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_5,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_6,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_7,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_8,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_9,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_10,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_11,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_12,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_13,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_14,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_15,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_16,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_17,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_18,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_19,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_20,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_21,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_22,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_23,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_24,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_25,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_26,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_27,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_28,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_29,	MyFrameEq2::OnGUISpinDownEq)
	EVT_SPIN_DOWN(ID_SPIN_EQ2_30,	MyFrameEq2::OnGUISpinDownEq)
	EVT_CLOSE(						MyFrameEq2::OnCloseWindow)
	EVT_SIZE(						MyFrameEq2::OnGUISize)
	EVT_MOVE(						MyFrameEq2::OnGUIMove)
END_EVENT_TABLE()
	

BEGIN_EVENT_TABLE(MyFrameEffects, wxFrame)
	EVT_SLIDER(ID_SLIDER_PITCH,		MyFrameEffects::OnGUISliderPitch)
	EVT_SLIDER(ID_SLIDER_PITCH2,	MyFrameEffects::OnGUISliderPitch2)
	EVT_SLIDER(ID_SLIDER_TEMPO,		MyFrameEffects::OnGUISliderTempo)
	EVT_SLIDER(ID_SLIDER_SPEED,		MyFrameEffects::OnGUISliderSpeed)

	EVT_SPIN_DOWN(ID_SPIN_PITCH,	MyFrameEffects::OnGUISpinDownPitch)
	EVT_SPIN_DOWN(ID_SPIN_PITCH2,	MyFrameEffects::OnGUISpinDownPitch2)
	EVT_SPIN_DOWN(ID_SPIN_TEMPO,	MyFrameEffects::OnGUISpinDownTempo)
	EVT_SPIN_DOWN(ID_SPIN_SPEED,	MyFrameEffects::OnGUISpinDownSpeed)
	EVT_SPIN_UP(ID_SPIN_PITCH,		MyFrameEffects::OnGUISpinUpPitch)
	EVT_SPIN_UP(ID_SPIN_PITCH2,		MyFrameEffects::OnGUISpinUpPitch2)
	EVT_SPIN_UP(ID_SPIN_TEMPO,		MyFrameEffects::OnGUISpinUpTempo)
	EVT_SPIN_UP(ID_SPIN_SPEED,		MyFrameEffects::OnGUISpinUpSpeed)

	EVT_CHECKBOX(ID_CHK_PITCH,		MyFrameEffects::OnGUICheckPitch)
	EVT_CHECKBOX(ID_CHK_TEMPO,		MyFrameEffects::OnGUICheckTempo)
	EVT_CHECKBOX(ID_CHK_SPEED,		MyFrameEffects::OnGUICheckSpeed)
	EVT_CHECKBOX(ID_CHK_QUALSPEED,	MyFrameEffects::OnGUICheckQualSpeed)
	EVT_CHECKBOX(ID_CHK_QUALFILTER, MyFrameEffects::OnGUICheckQualFilter)
	EVT_CHECKBOX(ID_CHK_EFFECTSB,   MyFrameEffects::OnGUICheckEffectsB)

	EVT_CLOSE(						MyFrameEffects::OnCloseWindow)
	EVT_SIZE(						MyFrameEffects::OnGUISize)
	EVT_MOVE(						MyFrameEffects::OnGUIMove)
END_EVENT_TABLE()
	

#if !defined(MANOCDA) && defined(__MAUNIX__)
BEGIN_EVENT_TABLE(MyFrameAudioCD, wxFrame)
	EVT_COMBOBOX(ID_POPUP_AUDIOCD,	MyFrameAudioCD::OnGUIPopupAudioCD)
	EVT_BUTTON(ID_BTN_AUDIOCDSET,	MyFrameAudioCD::OnGUIButtonAudioCDSet)
	EVT_BUTTON(ID_BTN_AUDIOCDCLEAR,	MyFrameAudioCD::OnGUIButtonAudioCDClear)
	EVT_BUTTON(ID_BTN_AUDIOCDSAVE,	MyFrameAudioCD::OnGUIButtonAudioCDSave)
	EVT_BUTTON(wxID_OK,				MyFrameAudioCD::OnButtonClose)
	
	EVT_CHECKBOX(ID_CHK_CDPARANOIA,	MyFrameAudioCD::OnGUICheckCdParanoia)
	EVT_CLOSE(						MyFrameAudioCD::OnCloseWindow)
	EVT_SIZE(						MyFrameAudioCD::OnGUISize)
	EVT_MOVE(						MyFrameAudioCD::OnGUIMove)
END_EVENT_TABLE()
#endif


BEGIN_EVENT_TABLE(MyFrameFileOut, wxFrame)
	EVT_COMBOBOX(ID_POPUP_BITRATE,		MyFrameFileOut::OnGUIPopupBitRate)
	EVT_COMBOBOX(ID_POPUP_QUALITY,		MyFrameFileOut::OnGUIPopupQuality)
	EVT_COMBOBOX(ID_POPUP_MODE,			MyFrameFileOut::OnGUIPopupMode)
	EVT_COMBOBOX(ID_POPUP_SAMPLERATE,   MyFrameFileOut::OnGUIPopupSampleRate)
	EVT_BUTTON(ID_BTN_FILEOUTDIR,		MyFrameFileOut::OnGUIButtonFileOutDir)
	EVT_CHECKBOX(ID_CHK_ADTS,			MyFrameFileOut::OnGUICheckBoxADTS)	
	EVT_CHECKBOX(ID_CHK_M4A,			MyFrameFileOut::OnGUICheckBoxM4A)
	EVT_CLOSE(							MyFrameFileOut::OnCloseWindow)
	EVT_SIZE(							MyFrameFileOut::OnGUISize)
	EVT_MOVE(							MyFrameFileOut::OnGUIMove)
END_EVENT_TABLE()
	

BEGIN_EVENT_TABLE(MyFrameAbout, wxFrame)
	EVT_BUTTON(wxID_OK,	MyFrameAbout::OnButtonClose)
	EVT_CLOSE(			MyFrameAbout::OnCloseWindow)
	EVT_SIZE(			MyFrameAbout::OnGUISize)
	EVT_MOVE(			MyFrameAbout::OnGUIMove)
END_EVENT_TABLE()


BEGIN_EVENT_TABLE(MyFrameViewer, wxFrame)
	EVT_BUTTON(ID_BTN_VIEWERFIND,   MyFrameViewer::OnButtonFind)
	EVT_BUTTON(wxID_OK,				MyFrameViewer::OnButtonClose)
	EVT_BUTTON(ID_BTN_EDITSAVE,		MyFrameViewer::OnButtonEditSave)
	EVT_CLOSE(						MyFrameViewer::OnCloseWindow)
	EVT_SIZE(						MyFrameViewer::OnGUISize)
	EVT_MOVE(						MyFrameViewer::OnGUIMove)
END_EVENT_TABLE() 


BEGIN_EVENT_TABLE(MyViewerTextCtrl, wxTextCtrl)
	EVT_MOUSE_EVENTS(MyViewerTextCtrl::OnGUIMouse)
END_EVENT_TABLE()


BEGIN_EVENT_TABLE(MyTextCtrl, wxTextCtrl)
	EVT_CHAR(MyTextCtrl::OnGUIChar)
	EVT_MOUSE_EVENTS(MyTextCtrl::OnGUIMouse)
END_EVENT_TABLE()


BEGIN_EVENT_TABLE(MyFramePromptNum, wxFrame)
	EVT_BUTTON(ID_BTN_PROMPTNUMCANCEL,		MyFramePromptNum::OnGUIButtonPromptNumCancel)
	EVT_BUTTON(ID_BTN_PROMPTNUMOK,			MyFramePromptNum::OnGUIButtonPromptNumOk)
	EVT_TEXT_ENTER(ID_EDITTEXT_PROMPTNUM,	MyFramePromptNum::OnGUIEditTextPromptNum)
	EVT_CLOSE(								MyFramePromptNum::OnCloseWindow)
END_EVENT_TABLE()


BEGIN_EVENT_TABLE(MyFrameAdvanced, wxFrame)
	EVT_CHECKBOX(ID_CHK_CLOSEREOPEN,		MyFrameAdvanced::OnGUICheckCloseReopen)
	EVT_CHECKBOX(ID_CHK_HIGHPRIORITY,		MyFrameAdvanced::OnGUICheckHighPriority)
	EVT_BUTTON(wxID_OK,						MyFrameAdvanced::OnButtonClose)
	EVT_CLOSE(								MyFrameAdvanced::OnCloseWindow)
	EVT_SIZE(								MyFrameAdvanced::OnGUISize)
	EVT_MOVE(								MyFrameAdvanced::OnGUIMove)
END_EVENT_TABLE()

#ifdef __cplusplus
extern "C"
{
#endif

// api
/* not used void SpinButtonEnable(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonEnable");
#endif
	PushButtonEnable(window, button);
}


void SpinButtonDisable(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("SpinButtonDisable");
#endif
	PushButtonDisable(window, button);
}
*/


void PushButtonPaintUp(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonPaintUp");
#endif
#if defined(MAUSEMABUTTON)
	wxWindow *pb = ((wxWindow *)g_w[window])->FindWindowById(button, (wxWindow *)g_w[window]);
	
	if(pb)
		((MABUTTON *)pb)->PaintUp();
	else
		maLogAPI("PushButtonPaintUp nopb", window, button);
#else
 #ifdef MAUNUSED
  (void)window; (void)button;
 #endif
#endif
}


void PushButtonPaintDown(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonPaintDown");
#endif
#if defined(MAUSEMABUTTON)
	wxWindow *pb = ((wxWindow *)g_w[window])->FindWindowById(button, (wxWindow *)g_w[window]);
	
	if(pb)
		((MABUTTON *)pb)->PaintDown();
	else
		maLogAPI("PushButtonPaintDown nopb", window, button);
#else
 #ifdef MAUNUSED
  (void)window; (void)button;
 #endif
#endif
}


/*
void PushButtonPopup(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonPopup");
#endif
	wxWindow *pb = ((wxWindow *)g_w[window])->FindWindowById(button, (wxWindow *)g_w[window]);
	
	if(pb)
		((MABUTTON *)pb)->PopUp();
	else
		maLogAPI("PushButtonPopup nopb", window, button);
}
*/

void PushButtonEnable(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonEnable");
#endif
	wxWindow *pb = ((wxWindow *)g_w[window])->FindWindowById(button, (wxWindow *)g_w[window]);
	
	if(pb)
		pb->Enable(TRUE);
	else
		maLogAPI("PushButtonEnable nopb", window, button);
}


void PushButtonDisable(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonDisable");
#endif
	wxWindow *pb = ((wxWindow *)g_w[window])->FindWindowById(button, (wxWindow *)g_w[window]);	
	if(pb)
		pb->Disable();
	else
		maLogAPI("PushButtonDisable nopb", window, button);
}


void PushButtonSimulateClick(int window, int button)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonSimulateClick");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(button, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		wxCommandEvent event(wxEVT_COMMAND_BUTTON_CLICKED, button);
		event.SetEventObject(cb);
		((wxButton *)cb)->Command(event);
	}
	else
		maLogAPI("PushButtonSimulateClick nocb", window, button);
}


void PushButtonSetDescriptor(int window, int button, char *desc)
{
#ifdef MATRACEGUIWX
	maTrace("PushButtonSetDescriptor");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(button, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxButton *)cb)->SetLabel(desc);
	else
		maLogAPI("PushButtonSetDescriptor nocb", window, button);
}


void PopupButtonEnable(int window, int popup)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonEnable");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxComboBox *)cb)->Enable();
	else
		maLogAPI("PopupButtonEnable nocb", window, popup);
}


void PopupButtonDisable(int window, int popup)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonDisable");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		((wxComboBox *)cb)->Disable();

		// workaround for problem where ComboBox traps mousewheel when disabled
#if defined(__MAWIN__) && defined(MAMOUSEWHEEL)
		if(popup == ID_POPUP_OUTPUT || popup == ID_POPUP_BUFFER)
			if(l_ChkAltSize)
				l_ChkAltSize->SetFocus(); // move focus elsewhere, alt size checkbox is as good as any
#endif
	}
	else
		maLogAPI("PopupButtonDisable nocb", window, popup);
}


void PopupButtonClear(int window, int popup)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonClear");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxComboBox *)cb)->Clear();
	else
		maLogAPI("PopupButtonClear nocb", window, popup);
}


void PopupButtonAppend(int window, int popup, char *text)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonAppend");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxComboBox *)cb)->Append(text);
	else
		maLogAPI("PopupButtonAppend nocb", window, popup);
}


void PopupButtonSetValue(int window, int popup, int value)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonSetValue");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxComboBox *)cb)->SetSelection(value);
	else
		maLogAPI("PopupButtonSetValue nocb", window, popup);
}


/*
void PopupButtonSetText(int window, int popup, int item, char *text)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonSetText");
#endif
#if !defined(__WXGTK__) // don't have SetString
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxComboBox *)cb)->SetString(item, text);
	else
		maLogAPI("PopupButtonSetText nocb", window, popup);
#endif
}
*/

#if !defined(MANOCDA) && defined(__MAUNIX__)
void PopupButtonGetSelection(int window, int popup, int *item)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonGetSelection");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
		*item = ((wxComboBox *)cb)->GetSelection();
	else
	{
		*item = -1;
		maLogAPI("PopupButtonGetSelection nocb", window, popup);
	}
}


void PopupButtonSetSelection(int window, int popup, int item)
{
#ifdef MATRACEGUIWX
	maTrace("PopupButtonSetSelection");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(popup, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxComboBox *)cb)->SetSelection(item);
	else
		maLogAPI("PopupButtonSetSelection nocb", window, popup);
}
#endif


/*
void PopupButtonGetText(int window, int edittext, int item, char *outBuffer, int inBufferLength, long *outTextLength)
{
#ifdef MAUNUSED
 (void)inBufferLength
#endif
	
#ifdef MATRACEGUIWX
	maTrace("PopupButtonGetText");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(edittext, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		strcpy(outBuffer, ((wxComboBox *)cb)->GetString(item));
		*outTextLength = strlen(outBuffer);
	}
	else
		maLogAPI("PopupButtonGetText nocb", window, edittext);
}
*/

void LittleArrowEnable(int window, int arrow)
{
#ifdef MATRACEGUIWX
	maTrace("LittleArrowEnable");
#endif
	wxWindow *cb;
	cb = ((wxWindow *)g_w[window])->FindWindowById(arrow, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxSpinButton *)cb)->Enable();
	else
		maLogAPI("LittleArrowEnable nocb", window, arrow);
}


void LittleArrowDisable(int window, int arrow)
{
#ifdef MATRACEGUIWX
	maTrace("LittleArrowDisable");
#endif
	wxWindow *cb;
	cb = ((wxWindow *)g_w[window])->FindWindowById(arrow, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxSpinButton *)cb)->Disable();
	else
		maLogAPI("LittleArrowDisable nocb", window, arrow);
}


void StaticTextEnable(int window, int statictext)
{
#ifdef MATRACEGUIWX
	maTrace("StaticTextEnable");
#endif
	wxWindow *cb;
	cb = ((wxWindow *)g_w[window])->FindWindowById(statictext, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxStaticText *)cb)->Enable();
	else
		maLogAPI("StaticTextEnable nocb", window, statictext);
}


void StaticTextDisable(int window, int statictext)
{
#ifdef MATRACEGUIWX
	maTrace("StaticTextDisable");
#endif
	wxWindow *cb;
	cb = ((wxWindow *)g_w[window])->FindWindowById(statictext, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxStaticText *)cb)->Disable();
	else
		maLogAPI("StaticTextDisable nocb", window, statictext);
}


void StaticTextSetText(int window, int statictext, char *text)
{
#ifdef MATRACEGUIWX
	maTrace("StaticTextSetText");
#endif
	wxWindow *cb;
	cb = ((wxWindow *)g_w[window])->FindWindowById(statictext, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		((wxStaticText *)cb)->SetLabel(text);
		((wxStaticText *)cb)->Refresh();
	}
	else
		maLogAPI("StaticTextSetText nocb", window, statictext);
}


void StaticTextSetValue(int window, int statictext, int value)
{
#ifdef MATRACEGUIWX
	maTrace("StaticTextSetValue");
#endif
	wxWindow *cb;
	cb = ((wxWindow *)g_w[window])->FindWindowById(statictext, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		char cstr[64];
		sprintf(cstr, "%d", value);
		((wxStaticText *)cb)->SetLabel(cstr);
		((wxStaticText *)cb)->Refresh();
	}
	else
		maLogAPI("StaticTextSetValue nocb", window, statictext);
}


void StaticTextRefresh(int window, int statictext)
{
#ifdef MATRACEGUIWX
	maTrace("StaticTextRefresh");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(statictext, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxStaticText *)cb)->Refresh();
	else
		maLogAPI("StaticTextRefresh nocb", window, statictext);
}


void EditTextSetText(int window, int edittext, char *text)
{
#ifdef MATRACEGUIWX
	maTrace("EditTextSetText");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(edittext, (wxWindow *)g_w[window]);
	
	if(cb)
		((wxTextCtrl *)cb)->SetValue(text);
	else
		maLogAPI("EditTextSetText nocb", window, edittext);
}


void EditTextGetText(int window, int edittext, char *outBuffer, int inBufferLength, long *outTextLength)
{
#ifdef MATRACEGUIWX
	maTrace("EditTextGetText");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(edittext, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		strncpy(outBuffer, ((wxTextCtrl *)cb)->GetValue(), inBufferLength);
		outBuffer[inBufferLength - 1] = 0;
		*outTextLength = strlen(outBuffer);
	}
	else
		maLogAPI("EditTextGetText nocb", window, edittext);
}


void ListAppend(int window, int list, char *text)
{
#ifdef MATRACEGUIWX
	maTrace("ListAppend");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		long i = ((wxListCtrl *)cb)->GetItemCount();
		((wxListCtrl *)cb)->InsertItem(i, text, 0);
	}
	else
		maLogAPI("ListAppend nocb", window, list);
}


void ListClear(int window, int list)
{
#ifdef MATRACEGUIWX
	maTrace("ListClear");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		int w = ((wxListCtrl *)cb)->GetColumnWidth(0); // we have a one-column list
		if(((wxListCtrl *)cb)->GetSelectedItemCount() > 0)
			((wxListCtrl *)cb)->EnsureVisible(0); // scroll to top of list (mac needs this)
		((wxListCtrl *)cb)->ClearAll();
		
		/*
	char header[32];
		header[0] = 0;
		if(g_sets.listwindow & LBOXINDEX)
			strcpy(header, "Index  ");
		if(g_sets.listwindow & LBOXPATH)
			strcat(header, "File path");
		else
			strcat(header, "File name");
		((wxListCtrl *)cb)->InsertColumn(0, wxT(header), wxLIST_FORMAT_LEFT, w);
		*/
		
		((wxListCtrl *)cb)->InsertColumn(0, wxEmptyString, wxLIST_FORMAT_LEFT, w);
	}
	else
		maLogAPI("ListClear nocb", window, list);
}


int ListGetRowSelected(int window, int list)
{
#ifdef MATRACEGUIWX
	maTrace("ListGetRowSelected");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		if(((wxListCtrl *)cb)->GetSelectedItemCount() <= 0)
			return -1; // none selected
#if(MAGUIWX >= 8) // wx-2.8+
		long r = -1;
		if((r = ((wxListCtrl *)cb)->GetNextItem(r, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED)) != -1) 
			return (int)r;
#else
		for(int r = 0; r < ((wxListCtrl *)cb)->GetItemCount(); r++)
			if((((wxListCtrl *)cb)->GetItemState(r, wxLIST_STATE_SELECTED)) & wxLIST_STATE_SELECTED)
				return r;
#endif
		maLogAPI("ListGetRowSelected not found", window, list);
	}
	else
		maLogAPI("ListGetRowSelected nocb", window, list);

	return -1;
}


void ListEnsureVisible(int window, int list, int row)
{
#ifdef MATRACEGUIWX
	maTrace("ListEnsureVisible");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		if(row + 1 > ((wxListCtrl *)cb)->GetItemCount())
			return;
		((wxListCtrl *)cb)->EnsureVisible(row);
	}
	else
		maLogAPI("ListEnsureVisible nocb", window, list);
}


void ListSelect(int window, int list, int row)
{
#ifdef MATRACEGUIWX
	maTrace("ListSelect");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		if(row + 1 > ((wxListCtrl *)cb)->GetItemCount())
			return;
		g_listselect++;
		((wxListCtrl *)cb)->SetItemState(row, wxLIST_STATE_SELECTED, wxLIST_STATE_SELECTED);
	}
	else
		maLogAPI("ListSelect nocb", window, list);
}


void ListGetText(int window, int list, int row, char *text)
{
#ifdef MATRACEGUIWX
	maTrace("ListGetText");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		if(row >= 0 && row < ((wxListCtrl *)cb)->GetItemCount())
		{
			wxListItem info;
			info.m_itemId = row;
			info.m_col = 0; // we use column 0
			info.m_mask = wxLIST_MASK_TEXT;
			if(((wxListCtrl *)cb)->GetItem(info))
			{
				strncpy(text, info.m_text.c_str(), LISTLINELEN);
				text[LISTLINELEN] = 0;
				return;
			}
		}
		maLogAPI("ListGetText failed to get text", window, list);
	}
	else
		maLogAPI("ListGetText nocb", window, list);
}


/* not used void ListSetText(int window, int list, int row, char *text)
{
#ifdef MATRACEGUIWX
	maTrace("ListSetText");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		if(row >= 0 && row < ((wxListCtrl *)cb)->GetItemCount())
		{
			wxListItem info;
			info.m_itemId = row;
			info.m_col = 0; // we use column 0
			info.m_mask = wxLIST_MASK_TEXT;
			info.m_text = text;
			if(((wxListCtrl *)cb)->SetItem(info))
				return;
		}
		maLogAPI("ListSetText failed to get text", window, list);
	}
	else
		maLogAPI("ListSetText nocb", window, list);
}
*/


void ListSetHeader(int window, int list, int col, char *header)
{
#ifdef MATRACEGUIWX
	maTrace("ListSetHeader");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(list, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		wxListItem itemCol;
		itemCol.m_mask = wxLIST_MASK_TEXT | wxLIST_MASK_IMAGE;
		itemCol.m_text = wxT(header);
		itemCol.m_image = -1;
		if(((wxListCtrl *)cb)->SetColumn(col, itemCol))
			return;

		maLogAPI("ListSetHeader failed to set header", window, list);
	}
	else
		maLogAPI("ListSetHeader nocb", window, list);
}


void ListSetColumnWidth()
{
#ifdef MATRACEGUIWX
	maTrace("ListSetColumnWidth");
#endif
	if(g_w[WINDOWLIST])
		((MyFrameList *)g_w[WINDOWLIST])->SetColumn0Width(0);
}


void MenuSetChecked(int menu, int item, int value)
{
#ifdef MATRACEGUIWX
	maTrace("MenuSetChecked");
#endif
	((wxMenu *)l_theMenu[menu])->Check(item, (value == 0) ? false : true);
}


int MenuIsChecked(int menu, int item)
{
#ifdef MATRACEGUIWX
	maTrace("MenuIsChecked");
#endif
	return ((wxMenu *)l_theMenu[menu])->IsChecked(item);
}


void MenuEnable(int menu, int item)
{
#ifdef MATRACEGUIWX
	maTrace("MenuEnable");
#endif
	((wxMenu *)l_theMenu[menu])->Enable(item, true);
}


void MenuDisable(int menu, int item)
{
#ifdef MATRACEGUIWX
	maTrace("MenuDisable");
#endif
	((wxMenu *)l_theMenu[menu])->Enable(item, false);
}


void MenuSetLabel(int item, char *label)
{
#ifdef MATRACEGUIWX
	maTrace("MenuSetLabel");
#endif
	if(g_menubar)
		((wxMenuBar *)g_menubar)->SetLabel(item, label);
}


void MenuGetLabel(int item, char *label)
{
#ifdef MATRACEGUIWX
	maTrace("MenuGetLabel");
#endif
	if(g_menubar)
		strcpy(label, ((wxMenuBar *)g_menubar)->GetLabel(item).c_str());
	else
		*label = 0;
}


void UpdateSubMenusRecent()
{
#ifdef MATRACEGUIWX
	maTrace("UpdateSubMenusRecent");
#endif
	if(g_w[WINDOWAPP])
		((MyFrame *)g_w[WINDOWAPP])->MakeSubMenusRecent();
}


void CheckBoxSetValue(int window, int checkbox, int value)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxSetValue");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	if(cb)
		((MACHECKBOX *)cb)->SetValue((value == 0) ? false : true);
	else
		maLogAPI("CheckBoxSetValue nocb", window, checkbox);
}


int CheckBoxGetValue(int window, int checkbox)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxGetValue");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	
	if(cb)
		return ((MACHECKBOX *)cb)->IsChecked();

	maLogAPI("CheckBoxGetValue nocb", window, checkbox);

	return 0;
}


void CheckBoxSetDescriptor(int window, int checkbox, char *desc)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxSetDescriptor");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	
	if(cb)
		((MACHECKBOX *)cb)->SetLabel(desc);
	else
		maLogAPI("CheckBoxSetDescriptor nocb", window, checkbox);
}


void CheckBoxToggle(int window, int checkbox)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxToggle");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	
	if(cb)
		((MACHECKBOX *)cb)->SetValue(((MACHECKBOX *)cb)->GetValue() ? FALSE : TRUE);
	else
		maLogAPI("CheckBoxToggle nocb", window, checkbox);
}


void CheckBoxHide(int window, int checkbox)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxHide");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		((MACHECKBOX *)cb)->Hide();
#if defined(MAUSEMACHECKBOX)
		((MACHECKBOX *)cb)->LabelHide();
#endif
	}
	else
		maLogAPI("CheckBoxHide nocb", window, checkbox);
}


void CheckBoxShow(int window, int checkbox)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxShow");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		((MACHECKBOX *)cb)->Show();
#if defined(MAUSEMACHECKBOX)
		((MACHECKBOX *)cb)->LabelShow();
#endif
	}
	else
		maLogAPI("CheckBoxShow nocb", window, checkbox);
}


void CheckBoxEnable(int window, int checkbox)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxEnable");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	
	if(cb)
		((MACHECKBOX *)cb)->Enable(TRUE);
	else
		maLogAPI("CheckBoxEnable nocb", window, checkbox);
}


void CheckBoxDisable(int window, int checkbox)
{
#ifdef MATRACEGUIWX
	maTrace("CheckBoxDisable");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(checkbox, (wxWindow *)g_w[window]);
	
	if(cb)
		((MACHECKBOX *)cb)->Enable(FALSE);
	else
		maLogAPI("CheckBoxDisable nocb", window, checkbox);
}


void maLogAPI(const char *errtxt, int window, int item)
{
	char cstr[256];
	// sprintf(cstr, "%s window=%d=x%x item=%d", errtxt, window,  (int)g_w[window], item); // 32-bit
	// sprintf(cstr, "%s window=%d=x%x item=%d", errtxt, window, (long)g_w[window], item); // 64-bit
	sprintf(cstr, "%s window=%d item=%d", errtxt, window, item);
	maLog(cstr);
}


void DisplayGetSize(int *x, int *y)
{
#ifdef MATRACEGUIWX
	maTrace("DisplayGetSize");
#endif
	if(!x || !y)
		maLog("DisplayGetSize null x or y parameter");

	wxSize d = wxGetDisplaySize();
	if(x)
		*x = d.x;
	if(y)
		*y = d.y;
}


void WindowDoClose(int window)
{
#ifdef MATRACEGUIWX
	maTrace("WindowDoClose");
#endif
	if(window < 0 || window >= WINDOWLAST || !g_w[window])
		return;

	((wxFrame *)g_w[window])->Close();
	
	// OnWindowClosedPromptNum() // if not called by callback

} // WindowDoClose


void WindowDoDestroy(int window)
{
#ifdef MATRACEGUIWX
	maTrace("WindowDoDestroy");
#endif
	if(window < 0 || window >= WINDOWLAST || !g_w[window])
		return;

	((wxFrame *)g_w[window])->Destroy();
}


int WindowIsShown(int window)
{
#ifdef MATRACEGUIWX
	maTrace("WindowIsShown");
#endif
	if(!g_w[window])
		return 0;
		
	return ((wxFrame *)g_w[window])->IsShown();
}


void WindowSetSize(int window, int xsize, int ysize)
{
#ifdef MATRACEGUIWX
	maTrace("WindowSetSize");
#endif
	if(!g_w[window])
		return;
	((wxFrame *)g_w[window])->SetSize(-1, -1, xsize, ysize, wxSIZE_USE_EXISTING);
}


void WindowMove(int window, int xpos, int ypos)
{
#ifdef MATRACEGUIWX
	maTrace("WindowMove");
#endif
	if(!g_w[window])
	{
		maLog("WindowMove no window");
		return;
	}
	((wxFrame *)g_w[window])->Move(xpos, ypos);
}


void WindowShow(int window)
{
#ifdef MATRACEGUIWX
	maTrace("WindowShow");
#endif
	if(!g_w[window])
	{
		maLog("WindowShow no window");
		return;
	}
	((wxFrame *)g_w[window])->Show();
}


void WindowSetTitle(int window, char *title)
{
#ifdef MATRACEGUIWX
	char cstr[256];
	sprintf(cstr, "WindowSetTitle %d '%s'", window, title);
	maLog(cstr);
#endif
	if(!g_w[window])
	{
		maLog("WindowSetTitle no window");
		return;
	}
	((wxFrame *)g_w[window])->SetTitle(title);
}


void WindowGetCoordinates(int window, int *xpos, int *ypos, int *xsize, int *ysize)
{
#ifdef MATRACEGUIWX
	maTrace("WindowGetCoordinates");
#endif
	if(!g_w[window])
	{
		maLog("WindowGetCoordinates no window");
		return;
	}
	
	if(!xpos || !ypos || !xsize || !ysize)
	{
		maLog("WindowGetCoordinates bad pos or size parameter");
		return;
	}
	
	((wxWindow *)g_w[window])->GetSize(xsize, ysize);
	((wxWindow *)g_w[window])->GetPosition(xpos, ypos);
	
} // WindowGetCoordinates


void WindowItemHide(int window, int item)
{
#ifdef MATRACEGUIWX
	maTrace("WindowItemHide");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(item, (wxWindow *)g_w[window]);
	
	if(cb)
		cb->Hide();
	else
		maLogAPI("WindowItemHide nocb", window, item);
}


void WindowItemShow(int window, int item)
{
#ifdef MATRACEGUIWX
	maTrace("WindowItemShow");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(item, (wxWindow *)g_w[window]);
	
	if(cb)
		cb->Show();
	else
		maLogAPI("WindowItemShow nocb", window, item);
}


void ListWindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("ListWindowMake");
#endif
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("ListWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWLIST])
	{		
		wxPoint pos(g_sets.listxpos[g_sets.winconf],  g_sets.listypos[g_sets.winconf]); 
		wxSize  siz(g_sets.listxsize[g_sets.winconf], g_sets.listysize[g_sets.winconf]);
		sprintf(cstr, "%s List", g_prognametitle);
		MyFrameList *listframe = new MyFrameList(wxT(cstr), pos, siz);

		if(listframe)
		{
			g_w[WINDOWLIST] = listframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			listframe->SetIcon(ic);
#endif

			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				listframe->Show();
		}
		else
			maLog("ListWindowMake failed");
	}
	else
		maLog("ListWindowMake already made");
		
} // ListWindowMake


void EqualizerWindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("EqualizerWindowMake");
#endif
	char cstr[256];
	if(!g_w[WINDOWAPP])
	{
		maLog("EqualizerWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEQ])
	{		
		wxPoint pos(g_sets.eqxpos[g_sets.winconf],  g_sets.eqypos[g_sets.winconf]); 
		wxSize  siz(g_sets.eqxsize[g_sets.winconf], g_sets.eqysize[g_sets.winconf]);
		if(g_sets.eqflags & MASEPARATELR)
			sprintf(cstr, "%s Equalizer Left Channel", g_prognametitle);
		else
			sprintf(cstr, "%s Equalizer", g_prognametitle);
		MyFrameEq *eqframe = new MyFrameEq(wxT(cstr), pos, siz);

		if(eqframe)
		{
			g_w[WINDOWEQ] = eqframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			eqframe->SetIcon(ic);
#endif

			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				eqframe->Show();
		}
		else
			maLog("EqualizerWindowMake failed");
	}
	else
		maLog("EqualizerWindowMake already made");

} // EqualizerWindowMake


void Equalizer2WindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("Equalizer2WindowMake");
#endif
	char cstr[256];
	if(!g_w[WINDOWAPP])
	{
		maLog("Equalizer2WindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEQ2])
	{		
		wxPoint pos(g_sets.eq2xpos[g_sets.winconf],  g_sets.eq2ypos[g_sets.winconf]); 
		wxSize  siz(g_sets.eq2xsize[g_sets.winconf], g_sets.eq2ysize[g_sets.winconf]);
		sprintf(cstr, "%s Equalizer Right Channel", g_prognametitle);
		MyFrameEq2 *eqframe = new MyFrameEq2(wxT(cstr), pos, siz);

		if(eqframe)
		{
			g_w[WINDOWEQ2] = eqframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			eqframe->SetIcon(ic);
#endif

			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				eqframe->Show();
		}
		else
			maLog("Equalizer2WindowMake failed");
	}
	else
		maLog("Equalizer2WindowMake already made");

} // Equalizer2WindowMake


void EffectsWindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("EffectsWindowMake");
#endif
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("EffectsWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEFFECTS])
	{		
		wxPoint pos(g_sets.effectsxpos[g_sets.winconf],  g_sets.effectsypos[g_sets.winconf]); 
		wxSize  siz(g_sets.effectsxsize[g_sets.winconf], g_sets.effectsysize[g_sets.winconf]);
		sprintf(cstr, "%s Effects", g_prognametitle);
		MyFrameEffects *effectsframe = new MyFrameEffects(wxT(cstr), pos, siz);

		if(effectsframe)
		{
			g_w[WINDOWEFFECTS] = effectsframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			effectsframe->SetIcon(ic);
#endif

			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				effectsframe->Show();
		}
		else
			maLog("EffectsWindowMake failed");
	}
	else
		maLog("EffectsWindowMake already made");

} // EffectsWindowMake


#if !defined(MANOCDA) && defined(__MAUNIX__)
void AudioCDWindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("AudioCDWindowMake");
#endif
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("AudioCDWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWAUDIOCD])
	{		
		wxPoint pos(g_setscdrom.winx[g_sets.winconf], g_setscdrom.winy[g_sets.winconf]); 
		wxSize  siz(g_setscdrom.winw[g_sets.winconf], g_setscdrom.winh[g_sets.winconf]);
		sprintf(cstr, "%s AudioCD", g_prognametitle);
		MyFrameAudioCD *audiocdframe = new MyFrameAudioCD(wxT(cstr), pos, siz);

		if(audiocdframe)
		{
			g_w[WINDOWAUDIOCD] = audiocdframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			audiocdframe->SetIcon(ic);
#endif
			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				audiocdframe->Show();
		}
		else
			maLog("AudioCDWindowMake failed");
	}
	else
		maLog("AudioCDWindowMake already made");

} // AudioCDWindowMake
#endif


void AdvancedWindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("AdvancedWindowMake");
#endif
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("AdvancedWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWADVANCED])
	{		
		wxPoint pos(g_sets.advancedxpos, g_sets.advancedypos); 
		wxSize  siz(g_sets.advancedxsize, g_sets.advancedysize);
		sprintf(cstr, "%s Advanced Settings", g_prognametitle);
		MyFrameAdvanced *advancedframe = new MyFrameAdvanced(wxT(cstr), pos, siz);

		if(advancedframe)
		{
			g_w[WINDOWADVANCED] = advancedframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			advancedframe->SetIcon(ic);
#endif
			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				advancedframe->Show();
		}
		else
			maLog("AdvancedWindowMake failed");
	}
	else
		maLog("AdvancedWindowMake already made");

} // AdvancedWindowMake


void FileOutWindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("FileOutWindowMake");
#endif
	char cstr[256];
	if(!g_w[WINDOWAPP])
	{
		maLog("FileOutWindowMake no App window");
		return;
	}
	
	if(WINDOWOUTCUR >= WINDOWOUTFIRST && WINDOWOUTCUR <= WINDOWOUTLAST && !g_w[WINDOWOUTCUR])
	{		
		wxPoint pos(g_sets.fileoutxpos[g_sets.winconf],
					g_sets.fileoutypos[g_sets.winconf]); 
		wxSize siz(g_sets.fileoutxsize[g_sets.winconf],
					g_sets.fileoutysize[g_sets.winconf]);
		sprintf(cstr, "%s %s File Output", g_prognametitle, g_extstrout[g_sets.output]);
		MyFrameFileOut *fileoutframe = new MyFrameFileOut(wxT(cstr), pos, siz);

		if(fileoutframe)
		{
			g_w[WINDOWOUTCUR] = fileoutframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			fileoutframe->SetIcon(ic);
#endif

			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				fileoutframe->Show();
		}
		else
			maLog("FileOutWindowMake failed");
	}
	else
	{
		sprintf(cstr, "FileOutWindowMake error WINDOWOUTCUR=%d g_sets.output=%d", WINDOWOUTCUR, g_sets.output);
		maLog(cstr);
	}
	
} // FileOutWindowMake


void PromptNumWindowMake()
{
#ifdef MATRACEGUIWX
	maTrace("PromptNumWindowMake");
#endif
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("PromptNumWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWPROMPTNUM])
	{		
		sprintf(cstr, "%s Prompt Number", g_prognametitle);
		MyFramePromptNum *promptnumframe = new MyFramePromptNum(wxT(cstr), 
			wxPoint(g_sets.xpos[g_sets.winconf] + 10, g_sets.ypos[g_sets.winconf] + 26), // over main window
									wxSize(PROMPTNUMDEFXSIZE, PROMPTNUMDEFYSIZE));
		if(promptnumframe)
		{
			g_w[WINDOWPROMPTNUM] = promptnumframe;

#if !defined(__WXX11__)
 #if defined(__WXMSW__)
			wxIcon ic(wxICON(APP_ICON));
 #else
			wxIcon ic(wxICON(MoreAmpIcon));
 #endif
			promptnumframe->SetIcon(ic);
#endif

			if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
				promptnumframe->Show();
		}
		else
			maLog("PromptNumWindowMake failed");
	}
	else
		maLog("PromptNumWindowMake already made");
		
} // PromptNumWindowMake


int HSliderGetValue(int window, int slider) // for horizontal sliders
{
#ifdef MATRACEGUIWX
	maTrace("HSliderGetValue");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(slider, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		int ret = ((MASLIDER *)cb)->GetValue();
		((MASLIDER *)cb)->Refresh();
		return ret;
	}
	maLogAPI("HSliderGetValue nocb", window, slider);
	return 0;
}


void HSliderSetValue(int window, int slider, int value) // for horizontal sliders
{
#ifdef MATRACEGUIWX
	maTrace("HSliderSetValue");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(slider, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		((MASLIDER *)cb)->SetValue(value);
		((MASLIDER *)cb)->Refresh();
	}
	else
		maLogAPI("HSliderSetValue nocb", window, slider);
}


int SliderGetValue(int window, int slider) // for vertical sliders
{
#ifdef MATRACEGUIWX
	maTrace("SliderGetValue");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(slider, (wxWindow *)g_w[window]);
	
	if(cb)
	{
#if defined(MAUSEMASLIDER)
		int ret = ((MASLIDER *)cb)->GetValue();
#else // upside down, min is always 0
		int ret = ((MASLIDER *)cb)->GetMax() - ((MASLIDER *)cb)->GetValue();
#endif
		((MASLIDER *)cb)->Refresh();
		return ret;
	}
	maLogAPI("SliderGetValue nocb", window, slider);
	return 0;
}


void SliderSetValue(int window, int slider, int value) // for vertical sliders
{
#ifdef MATRACEGUIWX
	maTrace("SliderSetValue");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(slider, (wxWindow *)g_w[window]);
	
	if(cb)
	{
#if defined(MAUSEMASLIDER)
		((MASLIDER *)cb)->SetValue(value);
#else // upside down, min is always 0
		((MASLIDER *)cb)->SetValue(((MASLIDER *)cb)->GetMax() - value);
#endif
		((MASLIDER *)cb)->Refresh();
	}
	else
		maLogAPI("SliderSetValue nocb", window, slider);
}


void SliderEnable(int window, int slider)
{
#ifdef MATRACEGUIWX
	maTrace("SliderEnable");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(slider, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		((MASLIDER *)cb)->Enable();
		((MASLIDER *)cb)->Refresh();
	}
	else
		maLogAPI("SliderEnable nocb", window, slider);
}


void SliderDisable(int window, int slider)
{
#ifdef MATRACEGUIWX
	maTrace("SliderDisable");
#endif
	wxWindow *cb = ((wxWindow *)g_w[window])->FindWindowById(slider, (wxWindow *)g_w[window]);
	
	if(cb)
	{
		((MASLIDER *)cb)->Disable();
		((MASLIDER *)cb)->Refresh();
	}
	else
		maLogAPI("SliderDisable nocb", window, slider);
}


int maFileDialog(char *selectedpath, int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags)
{
#ifdef MATRACEGUIWX
	maTrace("maFileDialog");
#endif
	int lflags = 0;
	
	if(flags & maOPEN)				lflags |= wxOPEN;
	if(flags & maSAVE)				lflags |= wxSAVE;
	if(flags & maOVERWRITE_PROMPT)  lflags |= wxOVERWRITE_PROMPT;
#if defined(wxHIDE_READONLY) // iff WXWIN_COMPATIBILITY_2_4
	if(flags & maHIDE_READONLY)		lflags |= wxHIDE_READONLY;
#endif
	if(flags & maFILE_MUST_EXIST)   lflags |= wxFILE_MUST_EXIST;
	if(flags & maCHANGE_DIR)		lflags |= wxCHANGE_DIR;

	wxFileDialog dialog((wxFrame *)g_w[window], prompt, defdir, deffile, wildcard, lflags);
								
	if(dialog.ShowModal() != wxID_OK) // cancelled
		return 1;

	strcpy(selectedpath, dialog.GetPath());
	
	return 0;
	
} // maFileDialog


void maFileDialogMFree(maArray *parray)
{
#ifdef MATRACEGUIWX
	maTrace("maFileDialogMFree");
#endif
	if(parray)
	{
		if(parray->items)
			delete (wxArrayString *)parray->items;
		if(parray->pitems)
			MAFREE(parray->pitems);
	}
}


int maFileDialogM(maArray *parray, int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags)
{
#ifdef MATRACEGUIWX
	maTrace("maFileDialogM");
#endif
	int lflags = wxMULTIPLE;
	
	if(flags & maOPEN)				lflags |= wxOPEN;
	if(flags & maSAVE)				lflags |= wxSAVE;
	if(flags & maOVERWRITE_PROMPT)  lflags |= wxOVERWRITE_PROMPT;
#if defined(wxHIDE_READONLY) // iff WXWIN_COMPATIBILITY_2_4
	if(flags & maHIDE_READONLY)		lflags |= wxHIDE_READONLY;
#endif
	if(flags & maFILE_MUST_EXIST)   lflags |= wxFILE_MUST_EXIST;
	if(flags & maCHANGE_DIR)		lflags |= wxCHANGE_DIR;
	
	parray->nitems = 0;
	parray->pitems = NULL;
	parray->items = NULL;
	
	wxFileDialog dialog((wxFrame *)g_w[window], prompt, defdir, deffile, wildcard, lflags);
								
	if(dialog.ShowModal() != wxID_OK) // cancelled
		return 1;
	
	wxArrayString *s;
	
	if((s = new wxArrayString()) == NULL)
	{
		maLog("maFileDialog new wxArrayString failed");
		return 1;
	}
	
	dialog.GetPaths(*s);
	s->Sort();
		
	size_t count = s->GetCount();
	
	if((parray->pitems = (char **)MAMALLOC(count * sizeof(char *))) == NULL)
	{
		delete s;
		maLog("maFileDialog MAMALLOC failed");
		return 1;
	}
	
	char **p = parray->pitems;
	size_t n;
	for(n = 0; n < count; n++, p++)
		*p = (char *)(*s)[n].c_str();
	
	parray->nitems = (int)count;
	parray->items = (void *)s;

	return 0;
	
} //maFileDialogM


int maDirSelector(char *dirpath, char *prompt)
{
#ifdef MATRACEGUIWX
	maTrace("maDirSelector");
#endif
	wxString dir = wxDirSelector(prompt);   // wxDirSelector returns an alias' volume, not the alias...
											// osx does not return a cd as a dir (but osx debug version does)
	if(dir.empty()) // cancelled
		return 1;

	strcpy(dirpath, (char *)dir.c_str());
	
	return 0;
}


void guiAppYield() 
{
#ifdef MATRACEGUIWX
	maTrace("guiAppYield");
#endif
	g_theApp->Yield(1);
} // guiAppYield


int maMessageBox(char *s1, char *s2, int flags)
{
	int lflags = 0;
	char title[256];
	
	if(flags & maYES)				lflags |= wxYES;
	if(flags & maOK)				lflags |= wxOK;
	if(flags & maNO)				lflags |= wxNO;
	if(flags & maYES_NO)			lflags |= wxYES_NO;
	if(flags & maCANCEL)			lflags |= wxCANCEL;
	if(flags & maICON_EXCLAMATION)	lflags |= wxICON_EXCLAMATION;
	if(flags & maICON_HAND)		lflags |= wxICON_HAND;
	if(flags & maICON_QUESTION)	lflags |= wxICON_QUESTION;
	if(flags & maICON_INFORMATION)	lflags |= wxICON_INFORMATION;
	
	sprintf(title, "%s : %s", g_prognametitle, s2);

	if(wxMessageBox(s1, title, lflags) == wxYES)
		return maYES;
	
	return maNO;

} // maMessageBox


void DoTimerRunLoop(int delay)
{
#ifdef MATRACEGUIWX
	maTrace("DoTimerRunLoop");
#endif
	((MyFrame *)g_w[WINDOWAPP])->m_timerrunloop->Start(delay, TRUE);
}


void DoTimerPlay(int delay)
{
#ifdef MATRACEGUIWX
	maTrace("DoTimerPlay");
#endif
	((MyFrame *)g_w[WINDOWAPP])->m_timerplay->Start(delay, TRUE);
}


void DoTimerStop(int delay)
{
#ifdef MATRACEGUIWX
	maTrace("DoTimerStop");
#endif
	((MyFrame *)g_w[WINDOWAPP])->m_timerstop->Start(delay, TRUE);
}


void DoTimerPlaySonglist(int delay)
{
#ifdef MATRACEGUIWX
	maTrace("DoTimerPlaySonglist");
#endif
	((MyFrame *)g_w[WINDOWAPP])->m_timerplaysonglist->Start(delay, TRUE);
}


void maViewCatalog()
{
#ifdef MATRACEGUIWX
	maTrace("maViewCatalog");
#endif
	
	if((g_w[WINDOWCATALOG] = (void *) new MyFrameViewer(WINDOWCATALOG, "MoreAmp CATALOG",
									wxPoint(g_sets.viewerxpos, g_sets.viewerypos),
									wxSize(g_sets.viewerxsize, g_sets.viewerysize))) != NULL)
		WindowShow(WINDOWCATALOG);
	else
		ShowErr("maViewCatalog failed to create Catalog window");

} // maViewCatalog


void maViewLog()
{
#ifdef MATRACEGUIWX
	maTrace("maViewLog");
#endif
	
	if((g_w[WINDOWLOG] = (void *) new MyFrameViewer(WINDOWLOG, "MoreAmp LOG",
									wxPoint(g_sets.viewerxpos, g_sets.viewerypos),
									wxSize(g_sets.viewerxsize, g_sets.viewerysize))) != NULL)
		WindowShow(WINDOWLOG);
	else
		ShowErr("maViewLog failed to create Log window");

} // maViewLog


#if defined(MAKEYBOARD)
void maEditKeyBindings()
{
#ifdef MATRACEGUIWX
	maTrace("maEditKeyBindings");
#endif
	
	if((g_w[WINDOWKEYBINDINGS] = (void *) new MyFrameViewer(WINDOWKEYBINDINGS, "MoreAmp Key Bindings",
									wxPoint(g_sets.keybindingsxpos, g_sets.keybindingsypos),
									wxSize(g_sets.keybindingsxsize, g_sets.keybindingsysize))) != NULL)
		WindowShow(WINDOWKEYBINDINGS);
	else
		ShowErr("maEditKeyBindings failed to create window");

} // maEditKeyBindings


void maTrace(char *str)
{
	maLog(str);
}
#endif


void maViewReadme()
{
#ifdef MATRACEGUIWX
	maTrace("maViewReadme");
#endif

	if(g_w[WINDOWREADME])
		return;

	if((g_w[WINDOWREADME] = (void *) new MyFrameViewer(WINDOWREADME, "MoreAmp README",
									wxPoint(g_sets.viewerxpos, g_sets.viewerypos),
									wxSize(g_sets.viewerxsize, g_sets.viewerysize))) != NULL)
		((MyFrameViewer *)g_w[WINDOWREADME])->Show();
	else
		maLog("maViewReadme failed to create Readme window");

} // maViewReadme


void maViewAbout() // OnAbout
{
#ifdef MATRACEGUIWX
	maTrace("maViewAbout");
#endif

	if(g_w[WINDOWABOUT])
		return;

	if((g_w[WINDOWABOUT] = (void *) new MyFrameAbout("About MoreAmp", 
									wxPoint(g_sets.aboutxpos, g_sets.aboutypos),
									wxSize(g_sets.aboutxsize, g_sets.aboutysize))) != NULL)
		((MyFrameAbout *)g_w[WINDOWABOUT])->Show();
	else
		maLog("maViewAbout failed to create About window");

} // maViewAbout


void maGUIfree()
{
}


void maGUIQuit()
{
} // maGUIQuit


#if defined(__WXGTK__)
 extern "C" { void* gdk_window_get_pointer(void*, int*, int*, unsigned int*); }
 // #include <gdk/gdk.h> // for GDK_xxx_MASK
#endif
 int maModKeyDown() // the mouse modifier key or Shift or Alt key, depending on platform
 {
  #if defined(__WXMSW__)
	if(GetKeyState(VK_SHIFT) < 0)
		return 1;
 #endif

  #if defined(__WXGTK__)
	int x, y;
	unsigned int m;
	gdk_window_get_pointer(NULL, &x, &y, &m);
	//if(m & GDK_BUTTON3_MASK)	// GDK_BUTTON1_MASK = 1 << 8, GDK_BUTTON2_MASK = 1 << 9, GDK_BUTTON3_MASK = 1 << 10,
	if(m & (1 << 3) ||			// if(m & GDK_MOD1_MASK) // normally Alt key
	   m & (1 << 0))			// if(m & GDK_SHIFT_MASK)
	// if(m & (1 << 9))			// if(m & GDK_BUTTON2_MASK)
	// if(m & (1 << 10))		// if(m & GDK_BUTTON3_MASK)
		return 1;
  #endif
        
  #if defined(__WXMAC__) && defined(__MAOSX__) // some mice cannot have both right and left button down simultaneously...
	UInt32 bstate;
	if((bstate = GetCurrentEventButtonState()) & (1 << 1)) // secondary button
		return 1;
	if(bstate & (1 << 0)) // primary)
		if(GetCurrentEventKeyModifiers() & shiftKey)
			return 1;
	KeyMap Keys; 
	unsigned char *BytePtr = (unsigned char*)Keys; 
	GetKeys(Keys);
	if(BytePtr[7] & 1) // Shift 0x38 == 56 = (7 * 8) + 0
		return 1;
  #endif 

	return 0;
	
} // maModKeyDown

#ifdef __cplusplus
}
#endif

#endif // !wxUSE_UNICODE

#endif // MAGUIWX

// eof

